//Titel:            Testbeispuiel fr MDI-Fenster
//Version:          1.0
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf. Dipl.-Ing. Michael Wlhelm
//Firma:
//Beschreibung:

// Beispiel eines Dialogs
// startet drei Threads mit dem Schalter 2

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



public class ClientThread3 extends JFrame {

  JToolBar toolBar = new JToolBar();
  JButton Bn1 = new JButton();
  JButton Bn2 = new JButton();
  JLabel label1;

   // Konstruktor
  public ClientThread3() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void jbInit() throws Exception {

      // BorderLayout setzen
    this.getContentPane().setLayout( new BorderLayout() );

      // Variable DesktopPane einfgen
      // in ihr werden alle Clientfenster eingefgt
    this.setSize( 400, 200);

    Bn1.setText("1. Summe");
    Bn1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        Bn1_actionPerformed(e);
      }
    });
    toolBar.add(Bn1);
    Bn1.setFont( new Font("Arial", Font.BOLD,24)  );
    Bn1.setForeground( Color.blue );


    Bn2.setText("2. Summe");
    Bn2.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        Bn2_actionPerformed(e);
      }
    });
    toolBar.add(Bn2);
    Bn2.setFont( new Font("Arial", Font.BOLD,24)  );
    Bn2.setForeground( Color.blue );


    this.getContentPane().add(toolBar, BorderLayout.NORTH);

    label1 = new JLabel("0");
    label1.setFont( new Font("TimesRoman", Font.ITALIC,32)  );


    this.getContentPane().add(label1, BorderLayout.CENTER);

  }

  public ImageIcon loadImageIcon(String filename, String description) {
    return new ImageIcon(filename, description);
  }



   // wird aufgerufen beim Schlieen des Hauptfensters
  void MnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }


    // zum korrekten Beenden bentigt
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

 void Bn1_actionPerformed(ActionEvent e) {
     // e.getSource()
    System.out.println("Schalter1 angeklickt");
    int summe;
    summe = calc1(100);
    summe += calc2(100);
    summe += calc3(100);
    System.out.println("Summe: "+Integer.toString(summe));
 }


 void Bn2_actionPerformed(ActionEvent e) {
     System.out.println("Schalter2 angeklickt");
     // e.getSource()
    int summe;
    SummenThread t1, t2, t3;
    t1 = new SummenThread(100);
    t2 = new SummenThread(100);
    t3 = new SummenThread(100);

    summe =0;

    t1.start();
    t2.start();
    t3.start();
    try {
      t1.join();
      t2.join();
      t3.join();
    }
    catch (InterruptedException e1) {
    }


    summe = t1.getSumme();
    summe += t2.getSumme();
    summe += t3.getSumme();
    System.out.println("Summe: "+Integer.toString(summe));

  }


  public int calc1(int n){
    int i, summe;
      summe = 0;
      System.out.println("calc1");
      try  {
        for (i=1; i<=n; i++) {
          summe+=i;
          label1.setText( Integer.toString(summe) );
          label1.paintImmediately(0,0, label1.getWidth(), label1.getHeight()  );
          Thread.sleep(10);
        }
      }
      catch (InterruptedException e1) {}
      return summe;
  }


  public int calc2(int n){
    int i, summe;
      summe = 0;
      System.out.println("calc2");
      try  {
        for (i=1; i<=n; i++) {
          summe+=i;
          label1.setText( Integer.toString(summe) );
          label1.paintImmediately(0,0, label1.getWidth(), label1.getHeight()  );
          Thread.sleep(10);
        }
      }
      catch (InterruptedException e1) {}
      return summe;
  }

  public int calc3(int n){
    int i, summe;
      summe = 0;
      System.out.println("calc3");
      try  {
        for (i=1; i<=n; i++) {
          summe+=i;
          label1.setText( Integer.toString(summe) );
          label1.paintImmediately(0,0, label1.getWidth(), label1.getHeight()  );
          Thread.sleep(10);
        }
      }
      catch (InterruptedException e1) {}
      return summe;
  }


   // Hauptprogramm
  static public void main(String[] args) {
    try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    ClientThread3 desktop = new ClientThread3();
    desktop.setVisible(true);
  }

}



class SummenThread extends Thread {

  int _summe;
  int _n;
  public SummenThread (int n) {
    _summe = 0;
    _n = n;
  }

  public int getSumme() {
   return _summe; 
  }

  public void run() {
    // Aktion
    int i;
      System.out.println(" Thread run");
      try  {
        for (i=1; i<=_n; i++) {
          _summe+=i;
          if ( (i % 10) == 0) {
            System.out.println("i: "+Integer.toString(i));
          }
          Thread.sleep(10);
        }
      }
      catch (InterruptedException e1) {}
  }
}


