//Titel:        JTree
//Version:       1.0
//Copyright:     Copyright (c) 2203
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einfhrung in JTree

// Einfaches Beispiel mit DefaultMutableTreeNode
// MvcTreeNodeRec liefert Zusatzinformationen, mit toString
// Analysiert eine Festplattenstruktur


import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

// Tree
import javax.swing.tree.DefaultMutableTreeNode;


import java.io.*;

public class fcb2 extends JFrame implements ActionListener {

  JTextArea editor = new JTextArea();
  JToolBar toolbar;
  JTree myTree;

	ButtonGroup bg;
  

  public fcb2() {
    setGUI();
  }

  private void setGUI() {
    toolbar = new JToolBar();

    setSize(600, 500);
    setTitle("Direktory 2. Beispiel");
    this.getContentPane().setLayout( new BorderLayout() );

    myTree = new JTree();
    editor.setFont( new Font("Arial", Font.BOLD,18)  );

 		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,false,
       new JScrollPane(myTree), new JScrollPane(editor));

    this.getContentPane().add(toolbar, BorderLayout.NORTH);

    this.getContentPane().add(split, BorderLayout.CENTER);

    makeRootButton();

  }


  void makeRootButton() {
    File[] driveList = File.listRoots();
    	// neue Buttonleiste erstellen
    	bg=new ButtonGroup();
    	// Feld durchlaufen
    	for(int i=0;i<driveList.length;i++) {
    		// Button erstellen mit den Laufwerken (Buchstaben)
      		JToggleButton bn=new JToggleButton(driveList[i].getPath());
          editor.setFont( new Font("Arial", Font.BOLD,18)  );
          toolbar.add( bn );
          toolbar.addSeparator( new Dimension(20,5) );

      		// Tip Anzeigen bei Mauskontakt
      		bn.setToolTipText("Wechseln zu Laufwerk "+driveList[i].getPath());
      		// gibt auf Tastendruck den Pfad des Laufwerkes
      		bn.setActionCommand("Root"+driveList[i].getPath());
      		// Abstaende einstellen
      		bn.setMargin(new Insets(2,2,2,2));
      		// hinzufuegen des ActionListeners
      		bn.addActionListener(this);
          // suche das aktuelle Verzeichnis, ist es identisch mit Laufwerk
      		bn.setSelected(bn.getText().equals(System.getProperty("user.dir").substring(0,3)));
      		// Button der Buttongroup hinzufuegen
      		bg.add(bn);
    	}//for
  	}//makeRootButton

  	public void actionPerformed(ActionEvent e) {
  		// herausloesen des Root, Kontrolle des Aufrufes
    	if(e.getActionCommand().substring(0,4).equals("Root")) {
    		// Loeschen von Root => in t ist z.B C:\
      		String sStr=e.getActionCommand().substring(4);
      	   	System.out.println("ToolLeiste actionPerformed "+sStr);
      	   	// Aufruf von setRoot im Editor mit Uebergabe des Laufwerks
      		ScanRoot(sStr);
      	}//if
  	}//actionPerformed


    void ScanRoot(String sRoot) {
      editor.setText(sRoot);
      editor.append("\n" );
      // editor.append(System.getProperty("user.dir") );
      Scan(sRoot,0);
    }

    void  Scan(String sPath, int Stufe) {
        int i;
        String sMargin="";
        for (i=0; i<Stufe+1; i++) sMargin+="   ";

        editor.append("\n"+sMargin+sPath );

        Stufe++;
        sMargin+="   ";
      	File dir = new File( sPath );
        // File[] items = dir.listRoots();
        File[] items = dir.listFiles();
        for (i=0; i<items.length; i++) {
           if ( items[i].isFile() ) {
             editor.append("\n"+sMargin+items[i].getName() );
           }
        }

         // Unterverzeichnisse rekursiv aufrufen, keine HiddenVerz
         // dann Absturz
        for (i=0; i<items.length; i++) {          
           if ( items[i].isDirectory() && (!items[i].isHidden()) ) {              
             Scan(sPath+items[i].getName()+"\\", Stufe) ;
           }
        }


    }


  //berschreiben, damit das Programm bei Herunterfahren des Systems beendet werden kann
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }


  public static void main(String[] args) {
    fcb2 frame = new fcb2();
    frame.setVisible(true);
 }


}


