//Titel:        JTree
//Version:       1.0
//Copyright:     Copyright (c) 2003, 06
//Autor:         Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
//Organisation:  HS Harz
//Beschreibung:  Einfhrung in JTree


// Einfaches Beispiel mit DefaultMutableTreeNode
// CTreeNodeRec liefert Zusatzinformationen
// mit Methode toString

import java.awt.*;
import javax.swing.*;

import java.awt.event.*;

import javax.swing.tree.DefaultMutableTreeNode;

import java.io.*;


// Treeselection
import javax.swing.tree.*;

public class Tree06 extends JFrame {

  JTree jTree1;


  public Tree06() {
    setGUI();
  }

  private void setGUI() {
    DefaultMutableTreeNode root;

    setSize(400, 300);
    setTitle("JTree 5. Beispiel");
    this.getContentPane().setLayout(  new BorderLayout()  );

    root = BuildTree();
    jTree1 = new javax.swing.JTree(root);
   jTree1.setFont( new Font("Arial", Font.BOLD,22)  );
 

    this.getContentPane().add(jTree1, BorderLayout.CENTER);
    jTree1.getSelectionModel().setSelectionMode (TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);


    // Neue Version
    // setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  } // setGUI


  // ----------------------------------------
  // BuildTree
  // ----------------------------------------
  DefaultMutableTreeNode BuildTree() {
    DefaultMutableTreeNode root;
    DefaultMutableTreeNode[]  Knoten = new DefaultMutableTreeNode[3];

    DefaultMutableTreeNode Kn0, Kn1, Kn2;

    root = new DefaultMutableTreeNode("root");

      // liefert einen DefaultMutableTreeNode
    Kn0 = createCNode(  1,  "1. Stufe");   // Daten und Bezeichnung
    root.add( Kn0 );

    Kn1 = createCNode(  2, "AAA");
    Kn0.add( Kn1 );
    Kn1 = createCNode(  3,  "BBB");
    Kn0.add( Kn1 );


    // ---------

    Kn0 = new DefaultMutableTreeNode("1. Stufe");
    root.add( Kn0 );

    Kn1 = new DefaultMutableTreeNode("CCC");
    Kn0.add( Kn1 );

    Kn1 = new DefaultMutableTreeNode("DDD");
    Kn0.add( Kn1 );

    return root;
  }  // BuildTree




  // erzeugt einen Knoten
  // CTreeNodeRec liefert Zusatzinformationen
 DefaultMutableTreeNode createCNode(int CData,  String nodeString) {
    CTreeNodeRec CNode;
    DefaultMutableTreeNode Node;

    CNode = new  CTreeNodeRec(CData, nodeString);
    Node = new DefaultMutableTreeNode(CNode);
    //Node.setUserObject(CNode);
    return Node;
 }


 
  //berschreiben, damit das Programm bei Herunterfahren des Systems beendet werden kann
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }
 
  public static void main(String[] args) {
    Tree06 frame = new Tree06();
    frame.setVisible(true);
 }


}



// Einfache Klasse fr jeden Knoten
class CTreeNodeRec  {
  public static long nr=0;

    private long _id = 0; // Id des Knotens  z.B. als ID

    private int _CData;

    public String _nodeString;


   public CTreeNodeRec(int CData,  String nodeString) {
      _CData = CData;
      _nodeString = nodeString;  // fr JTree;
      nr++;
      _id = nr;  // setzt eindeutige Nummer
   }


   public long getID() {
     return _id;
   }


   public int getData() {
     return _CData;
   }

   public void setData(int CData) {
     _CData = CData;
   }
   
   // sehr wichtig
   public String toString() {
     return _nodeString;
   }
   

}  // CTreeNodeRec


