//Titel:            Testbeispuiel fr MDI-Fenster
//Version:          1.0
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf. Dipl.-Ing. Michael Wlhelm
//Firma:
//Beschreibung:

// Beispiel eines MDI-Fenster

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// Packages fr Opendialog
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.*;
import java.util.Hashtable;
import java.util.Enumeration;

// Packages fr Filter
import javax.swing.filechooser.*;
import java.io.File;
import java.util.Hashtable;
import java.util.Enumeration;




public class MyDesktop02 extends JFrame {

  // Container fr die Clientfenster
  private JDesktopPane _desktopPane = new JDesktopPane();

    // Variablen fr die Mens
  private JMenuBar menuBar1;   // MenContainer
  private JMenu MainFile;      // Hauptmen
  private JMenuItem MnNew;     // Meneintrag
  private JMenuItem MnOpen;    // Meneintrag
  private JMenuItem MnSave;    // Meneintrag
  private JMenuItem MnSaveAs;    // Meneintrag
  private JMenuItem MnClose;   // Meneintrag

  private JMenu MainEdit;         // HauptMen
  private JMenuItem MnCut;        // Meneintrag
  private JMenuItem MnCopy;       // Meneintrag
  private JMenuItem MnInsert;     // Meneintrag

  private JMenu MainWindows;        // HauptMen
  private JMenuItem MnPrevWindows;  // Meneintrag
  private JMenuItem MnNextWindows;  // Meneintrag
  private JMenuItem MnTile;         // Meneintrag
  private JMenuItem MnCascade;      // Meneintrag


  String _sFileName="";


   // Konstruktor
  public MyDesktop02() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void jbInit() throws Exception {

      // BorderLayout setzen
    this.getContentPane().setLayout( new BorderLayout() );

      // Variable DesktopPane einfgen
      // in ihr werden alle Clientfenster eingefgt
    this.getContentPane().add(_desktopPane, BorderLayout.CENTER);
    this.setSize( 600, 400);
    this.setVisible(true);
    
    setMenus();
  }



    // setzt die Mens
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    MainFile = new JMenu("Datei");
    MnNew = new JMenuItem("Neu");
    MnOpen = new JMenuItem("ffnen");
    MnSave = new JMenuItem("Speichern");
    MnSaveAs = new JMenuItem("Speichern Als");
    MnClose = new JMenuItem("Schlieen");

      // Event definieren
    MnNew.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnNew_Click();
      }
    });
      // Short Key definieren  STRG+N
    MnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
    MainFile.add(MnNew);

      // Event definieren
    MnOpen.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnOpen_Click();
      }
    });
      // Short Key definieren  STRG+O
    MnOpen.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
     // Meneintrge zum MainFile hinzufgen
    MainFile.add(MnOpen);

    MainFile.addSeparator();

      // Event definieren
    MnSave.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnSave_Click();
      }
    });
      // Short Key definieren  STRG+O
    MnSave.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
     // Meneintrge zum MainFile hinzufgen
    MainFile.add(MnSave);

      // Event definieren
    MnSaveAs.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        MnSaveAs_Click();
      }
    });
     // Meneintrge zum MainFile hinzufgen
    MainFile.add(MnSaveAs);
    MainFile.addSeparator();



    // --------------------------
      // Event definieren
    MnClose.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnClose_actionPerformed(e);
      }
    });
    MainFile.add(MnClose);

      // Hauptmen FILE in den MenBar einfgen
    menuBar1.add(MainFile);



    // Men EDIT
    MainEdit = new JMenu("Bearbeiten");
    MnCut = new JMenuItem("Ausschneiden");
    MnCopy = new JMenuItem("Kopieren");
    MnInsert = new JMenuItem("Einfgen");

      // Event definieren
    MnCut.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnCut_actionPerformed(e);
      }
    });
    MainEdit.add(MnCut);

    MnCopy.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnCopy_actionPerformed(e);
      }
    });
    MainEdit.add(MnCopy);
    // MainFile.addSeparator();

    // --------------------------
      // Event definieren
    MnInsert.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnInsert_actionPerformed(e);
      }
    });
    MainEdit.add(MnInsert);
    menuBar1.add(MainEdit);

    // ----------------
    // Men Windows
    MainWindows = new JMenu("Fenster");
    MnPrevWindows = new JMenuItem("Vorheriges Fenster");
    MnNextWindows = new JMenuItem("Nchstes Fenster");
    MnCascade = new JMenuItem("Kaskade");
    MnTile = new JMenuItem("Aufteilen");

      // Event definieren
    MnCascade.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnCascade_actionPerformed(e);
      }
    });

      // Event definieren
    MnTile.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        MnTile_actionPerformed(e);
      }
    });
      // MenEintrge definieren
    MainWindows.add(MnPrevWindows);
    MainWindows.add(MnNextWindows);
    MainWindows.addSeparator();
    MainWindows.add(MnCascade);
    MainWindows.add(MnTile);
    menuBar1.add(MainWindows);

    this.setJMenuBar(menuBar1);
  } // setMenus


     // Event definieren, CODE
  void MnNew_Click() {
    MyInternalFrame frame = new MyInternalFrame(null);
    frame.setBounds(0, 0, 450, 300);
    _desktopPane.add(frame, new Integer(1));
      // Neu
    _desktopPane.moveToFront(frame);
  }




     // Event definieren, CODE
     // Beispiel zum ffnen EINER Datei
  void MnOpen_Click() {
   JFileChooser jFileChooser1 = new JFileChooser();
   String sFileName;

     // Filter definieren
   MyFileFilter javaFilter, txtFilter;

       // Eine Maske
	javaFilter = new MyFileFilter("java", "Java-Texte");
       // Zwei Masken
	txtFilter = new MyFileFilter( new String[] {"dat", "txt"}, "Texte");

     // setzen der Optionen
   jFileChooser1.setMultiSelectionEnabled(false);
   jFileChooser1.setCurrentDirectory( new File("D:\\hs-harz\\Vorlesungen\\WS\\INF 3\\java\\MDI\\") );
   jFileChooser1.addChoosableFileFilter(javaFilter);
   jFileChooser1.addChoosableFileFilter(txtFilter);

      // Aufruf des Dialogfensters
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
        // holen des Dateinamens
      sFileName = jFileChooser1.getSelectedFile().getPath();
        // Erzeugen des Clientframes
      MyInternalFrame frame = new MyInternalFrame( sFileName );
        // Grenzen
      frame.setBounds(0, 0, 450, 300);
      _desktopPane.add(frame, new Integer(1));

      // Neu
      _desktopPane.moveToFront(frame);

    }
  }  // MnOpen


     // Beispiel zum ffnen MEHRERE Datei
  void MnOpen2_Click() {
   JFileChooser jFileChooser1;
   String sFileName;
   File [] files;  // Array fr

   jFileChooser1 = new JFileChooser();
   jFileChooser1.setMultiSelectionEnabled(true);

   jFileChooser1.setCurrentDirectory( new File("D:\\HS-Harz\\Vorlesungen\\Grundlagen INF 3\\java\\MDI") );

     // Okay gedrckt ?
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      files = jFileChooser1.getSelectedFiles();

      int k;
      k = files.length;
      for (int i=0; i<files.length; i++) {
        sFileName = files[i].getPath();
        MyInternalFrame frame = new MyInternalFrame( sFileName );
        frame.setBounds(0, 0, 450, 300);
        _desktopPane.add(frame, new Integer(1));
          // Neu
        _desktopPane.moveToFront(frame);
      }
    }
  }  // MnOpen

  void MnSave_Click() {
    if (_sFileName.length()==0)
      MnSaveAs_Click();
    else
      SaveToFile();
  }

  void MnSaveAs_Click() {
   JFileChooser jFileChooser1 = new JFileChooser();
   String sFileName;

   MyFileFilter dbsFilter;

   dbsFilter = new MyFileFilter( new String[] {"std"}, "Studenten-Datenbank");

   jFileChooser1.addChoosableFileFilter(dbsFilter);

	// Ok-Schalter gedrckt ?
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
      _sFileName = jFileChooser1.getSelectedFile().getPath();
      SaveToFile();
    }
  }

  public void SaveToFile() {
    // speichert eine Datei
  }


   // wird aufgerufen beim Schlieen des Hauptfensters
  void MnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }


   // -----------------
     // Event definieren, CODE
     // Hier sollte das alktuelle Clientfensters aufgerufen werden
  void MnCut_actionPerformed(ActionEvent e) {
    System.out.println("Meneintrag Cut");
  }

     // Event definieren, CODE
     // Hier sollte das alktuelle Clientfensters aufgerufen werden
  void MnCopy_actionPerformed(ActionEvent e) {
    System.out.println("Meneintrag Copy");
  }

     // Event definieren, CODE
     // Hier sollte das alktuelle Clientfensters aufgerufen werden
  void MnInsert_actionPerformed(ActionEvent e) {
    System.out.println("Meneintrag Insert");
  }


   // -----------------
   // Cascade der Fenster
  void MnCascade_actionPerformed(ActionEvent e) {
      int i, j, p, Abstand, w, h, n;
      JInternalFrame f;     // the actual Clientwindow
      JInternalFrame[] ff;  // Array of all internal Clientwindow
      ff = _desktopPane.getAllFrames();
      n = ff.length;  // Count of
      // calc the distace of the frames, depends on the count of the frames
      if (n > 0) {
          if (n<=3)
            Abstand = 80;
          else {
            if (n>6)
              Abstand = 25;
            else
              Abstand = 40;
          }
          // calc the width and height of each frame
          w = _desktopPane.getWidth() - (n-1)*Abstand;
          h = _desktopPane.getHeight() - (n-1)*Abstand;
          // the top frame has the index 0 !
          // index i is for the position
          // index j ist for the frames, the last is the top-frame !
          for (i = 0, j=n-1; i <n; i++,j--) {
              f = (JInternalFrame)ff[j];  // typecasting
              p = i*Abstand;
              f.setLocation(p, p);        // position
              f.setSize(w,h);             // width height
          }
      }
  }   // MnCascade_actionPerformed(ActionEvent e) {



   // Aufteilen der Fenster
  void MnTile_actionPerformed(ActionEvent e) {
    System.out.println("Meneintrag Tile");
      JInternalFrame[] ff;    // Array for all internal frames
      JInternalFrame f; //
      int hoehe, anz, breite, left, top;
      int indexCol, anzCol, anzRow, anzRowUnten, n, i, h, b1, b2;
      boolean bZweiBreiten;

      ff = _desktopPane.getAllFrames();
        // Count > 0 ?
      if (ff.length > 0) {
          // Quadratische Aufteilung

            /*
             5:
                 -
                - -
                - -

             11:
                 - -
                - - -
                - - -
                - - -

            */

          n = ff.length;
          if (n < 1) {
              return;
          }
          if (n == 1) {
              f = (JInternalFrame)ff[0];
              try {
                  f.setMaximum(true);
              }
              catch (Exception e1) {
                  e1.printStackTrace();
              }
              return;
          }
          
          anzCol = (int)Math.round(Math.sqrt(n)); // Wurzel aus Anzahl
          // bestimme Anzahl der unteren (vollen) Zeilen
          anzRowUnten = n / anzCol;  // trunc
            // Abfrage nach Rest
          if (n > (anzRowUnten * anzCol)) {
              anzRow = anzRowUnten + 1;
              bZweiBreiten = true;
          }
          else {
              anzRow = anzRowUnten;
              bZweiBreiten = false;
          }
          //  AnzRow zeigt die Anzahl aller Zeilen
          
          // nun werden zwei Breiten und eine Hhe ausgerechnet
          // 1. Breite  gilt fr die vollen Reihen
          // 2. Breite  gilt fr oberste  Reihe, falls sie nicht voll ist
          hoehe = _desktopPane.getHeight();
          h = _desktopPane.getHeight() / anzRow;
          b1 = _desktopPane.getWidth() / anzCol; // volle Breite
          if (bZweiBreiten)
             b2 = _desktopPane.getWidth() / (n - anzCol * anzRowUnten); // untere Breite
          else
             b2 = b1;

          // Rckwrts
          anz = 0;
          left = 0;
          top = hoehe - h;
          indexCol = 0;
          for (i = ff.length - 1; i >= 0; i--) {
              f = (JInternalFrame)ff[i];
              //f.setSize(100,100);
              try {
                  f.setMaximum(false);
              }
              catch (Exception e2) {
                  e2.printStackTrace();
              }
              anz++;
              indexCol++;
              if (indexCol > anzCol) {
                  // neue Reihe anfangen
                  left = 0;
                  top -= h;
                  indexCol = 1;
              }
              // Position im Fenster setzen
              f.setLocation(left, top);
              // Breite Hhe setzen
              // Check, ob man in der obersten Zeile sich befindet ?
              if (anz > (anzRowUnten * anzCol)) {
                  f.setSize(b2, h); // width height
                  left += b2;
              }
              else {
                  f.setSize(b1, h); // width height
                  left += b1;
              }
          }
      }
  }  // Tile



    // zum korrekten Beenden bentigt
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

   // Hauptprogramm
  static public void main(String[] args) {
    try  {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e) {
    }
    MyDesktop02 desktop = new MyDesktop02();
    desktop.setVisible(true);
  }
  
}





// Clientfenster
class MyInternalFrame extends JInternalFrame {
  private String _sFileName;
  private String _Caption;


  public MyInternalFrame(String sFileName) {
    _sFileName = sFileName;
    if (sFileName==null)
      _Caption = "noname";
    else
      _Caption = sFileName;

    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void jbInit() throws Exception {
    this.setClosable(true);
    this.setIconifiable(true);
    this.setMaximizable(true);
    this.setResizable(true);
    this.getContentPane().setLayout( new BorderLayout() );
    this.setTitle(_Caption);
  }

}  // MyInternalFrame




// Klasse fr die Filter eines FileChoosers
// muss nicht gendert werden
class MyFileFilter extends FileFilter {

    private static String TYPE_UNKNOWN = "Type Unknown";
    private static String HIDDEN_FILE = "Hidden File";

    private Hashtable filters = null;
    private String description = null;
    private String fullDescription = null;
    private boolean useExtensionsInDescription = true;

    /**
     * Creates a file filter. If no filters are added, then all
     * files are accepted.
     *
     * @see #addExtension
     */
    public MyFileFilter() {
     	this((String) null, (String) null);
    }

    /**
     * Creates a file filter that accepts files with the given extension.
     * Example: new ExampleFileFilter("jpg");
     *
     * @see #addExtension
     */
    public MyFileFilter(String extension) {
     	this(extension,null);
    }

    /**
     * Creates a file filter that accepts the given file type.
     * Example: new ExampleFileFilter("jpg", "JPEG Image Images");
     *
     * Note that the "." before the extension is not needed. If
     * provided, it will be ignored.
     *
     * @see #addExtension
     */
    public MyFileFilter(String extension, String description) {
     	this(new String[] {extension}, description);
    }

    /**
     * Creates a file filter from the given string array.
     * Example: new ExampleFileFilter(String {"gif", "jpg"});
     *
     * Note that the "." before the extension is not needed adn
     * will be ignored.
     *
     * @see #addExtension
     */
    public MyFileFilter(String[] filters) {
     	this(filters, null);
    }

    /**
     * Creates a file filter from the given string array and description.
     * Example: new ExampleFileFilter(String {"gif", "jpg"}, "Gif and JPG Images");
     *
     * Note that the "." before the extension is not needed and will be ignored.
     *
     * @see #addExtension
     */
    public MyFileFilter(String[] filters, String description) {
      this.filters = new Hashtable(filters.length);
      for (int i = 0; i < filters.length; i++) {
          // add filters one by one
          addExtension(filters[i]);
      }
      setDescription(description);
    }

    /**
     * Return true if this file should be shown in the directory pane,
     * false if it shouldn't.
     *
     * Files that begin with "." are ignored.
     *
     * @see #getExtension
     * @see FileFilter#accepts
     */
    public boolean accept(File f) {
      if(f != null) {
          if(f.isDirectory()) {
        return true;
          }
          String extension = getExtension(f);
          if(extension != null && filters.get(getExtension(f)) != null) {
        return true;
          };
      }
      return false;
    }

    /**
     * Return the extension portion of the file's name .
     *
     * @see #getExtension
     * @see FileFilter#accept
     */
     public String getExtension(File f) {
        if(f != null) {
            String filename = f.getName();
            int i = filename.lastIndexOf('.');
            if(i>0 && i<filename.length()-1) {
          return filename.substring(i+1).toLowerCase();
            };
        }
        return null;
    }

    /**
     * Adds a filetype "dot" extension to filter against.
     *
     * For example: the following code will create a filter that filters
     * out all files except those that end in ".jpg" and ".tif":
     *
     *   ExampleFileFilter filter = new ExampleFileFilter();
     *   filter.addExtension("jpg");
     *   filter.addExtension("tif");
     *
     * Note that the "." before the extension is not needed and will be ignored.
     */
    public void addExtension(String extension) {
      if(filters == null) {
          filters = new Hashtable(5);
      }
      filters.put(extension.toLowerCase(), this);
      fullDescription = null;
    }


    /**
     * Returns the human readable description of this filter. For
     * example: "JPEG and GIF Image Files (*.jpg, *.gif)"
     *
     * @see setDescription
     * @see setExtensionListInDescription
     * @see isExtensionListInDescription
     * @see FileFilter#getDescription
     */
    public String getDescription() {
      if(fullDescription == null) {
          if(description == null || isExtensionListInDescription()) {
        if(description != null) {
            fullDescription = description;
        }
        fullDescription += " (";
        // build the description from the extension list
        Enumeration extensions = filters.keys();
        if(extensions != null) {
            fullDescription += "." + (String) extensions.nextElement();
            while (extensions.hasMoreElements()) {
          fullDescription += ", " + (String) extensions.nextElement();
            }
        }
        fullDescription += ")";
          } else {
        fullDescription = description;
          }
      }
      return fullDescription;
    }

    /**
     * Sets the human readable description of this filter. For
     * example: filter.setDescription("Gif and JPG Images");
     *
     * @see setDescription
     * @see setExtensionListInDescription
     * @see isExtensionListInDescription
     */
    public void setDescription(String description) {
   	  this.description = description;
    	fullDescription = null;
    }

    /**
     * Determines whether the extension list (.jpg, .gif, etc) should
     * show up in the human readable description.
     *
     * Only relevent if a description was provided in the constructor
     * or using setDescription();
     *
     * @see getDescription
     * @see setDescription
     * @see isExtensionListInDescription
     */
    public void setExtensionListInDescription(boolean b) {
      useExtensionsInDescription = b;
      fullDescription = null;
    }

    /**
     * Returns whether the extension list (.jpg, .gif, etc) should
     * show up in the human readable description.
     *
     * Only relevent if a description was provided in the constructor
     * or using setDescription();
     *
     * @see getDescription
     * @see setDescription
     * @see setExtensionListInDescription
     */
    public boolean isExtensionListInDescription() {
     	return useExtensionsInDescription;
    }
}  // MyFilter

