
// Bounce Ball innerhalb eines Thread
// Express-Schalter

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;


public class Bounce4 extends JFrame{

   private Canvas canvas;

   public Bounce4() {
     JToolBar toolBar = new JToolBar();
     JButton BnClear;
     JButton BnStart;
     JButton BnExpress1;
     JButton BnExpress2;
     JButton BnSelfish;
     JButton BnClose;

      setSize(600, 600);
      setTitle("Bounce4-Selfish");

      this.getContentPane().setLayout ( new BorderLayout() );

      canvas = new Canvas();
      this.getContentPane().add(canvas, BorderLayout.CENTER);

      this.getContentPane().add(toolBar, BorderLayout.NORTH);

      BnClear = new JButton( "Clear" );
      BnClear.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
          BnClear_Click(e);
         }
      });
      toolBar.add(BnClear);


      BnStart = new JButton( "Start" );
      BnStart.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
          BnStart_Click(e);
         }
      });
      toolBar.add(BnStart);


      BnExpress1 = new JButton( "Express1" );
      BnExpress1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
          BnExpress1_Click(e);
         }
      });
      toolBar.add(BnExpress1);

      BnExpress2 = new JButton( "Express2" );
      BnExpress2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
          BnExpress2_Click(e);
         }
      });
      toolBar.add(BnExpress2);


      BnSelfish = new JButton( "Selfish" );
      BnSelfish.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
          BnSelfish_Click(e);
         }
      });
      toolBar.add(BnSelfish);



      BnClose = new JButton( "Close" );
      BnClose.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) {
          BnClose_Click(e);
         }
      });
      toolBar.add(BnClose);


   }  //  Bounce4()

   void BnClear_Click(ActionEvent e) {
      Graphics g = canvas.getGraphics();
      g.setColor(Color.white);
      g.fillRect(0, 0, 600, 600);
      g.dispose();
   }

   void BnStart_Click(ActionEvent e) {
       System.out.println("BnStart");
       Ball b = new Ball(canvas, Color.blue);
       b.setPriority(Thread.MIN_PRIORITY);
       b.start();
   }


   void BnExpress1_Click(ActionEvent e) {
      System.out.println("BnExpress");
      for (int i= 0; i < 5; i++) {
          Ball b = new Ball(canvas, Color.red);
          // b.setPriority(Thread.NORM_PRIORITY + 4);
          b.setPriority(Thread.MAX_PRIORITY);
          b.start();
      }
   } // BnExpress1_Click


   void BnExpress2_Click(ActionEvent e) {
      System.out.println("BnExpress");
      for (int i= 0; i < 3; i++) {
          Ball b = new Ball(canvas, Color.blue);
          // b.setPriority(Thread.NORM_PRIORITY + 4);
          b.setPriority(Thread.MIN_PRIORITY);
          b.start();
      }
      for (int i= 0; i < 5; i++) {
          Ball b = new Ball(canvas, Color.red);
          // b.setPriority(Thread.NORM_PRIORITY + 4);
          b.setPriority(Thread.MAX_PRIORITY);
          b.start();
      }
   } // BnExpress2_Click


   void BnSelfish_Click(ActionEvent e) {
      System.out.println("BnExpress");
      Ball b = new SelfishBall(canvas, Color.green);
      b.setPriority(Thread.MAX_PRIORITY);
      b.start();
   } // BnSelfish_Click


   void BnClose_Click(ActionEvent e) {
       System.out.println("Close");
       canvas.setVisible(false);
       System.exit(0);
    }



  //berschreiben, damit das Programm bei Herunterfahren des Systems beendet werden kann
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

   public static void main(String[] args) {
      Frame f = new Bounce4();
      f.show();
   }

}  // Bounce2



class Ball extends Thread
{
   private Canvas box;
   private static final int XSIZE = 10;
   private static final int YSIZE = 10;
   private static int number = 0;
   private int x = 0;
   private int y = 0;
   private int dx = 2;
   private Color color;

   // Konstruktor
   public Ball(Canvas c, Color co) {
     number++;
     y = number*30;
     box = c;
     color = co;
   } // Konstruktor


   public void draw(){
      Graphics g = box.getGraphics();
      g.setColor(color);
      g.fillOval(x, y, XSIZE, YSIZE);
      g.dispose();
   }  // draw

   public void move() {
      if (!box.isVisible()) return;

      Graphics g = box.getGraphics();
      g.setColor(Color.white);
      // g.setXORMode(box.getBackground());
      g.fillOval(x, y, XSIZE, YSIZE);
      x += dx;
      Dimension d = box.getSize();
      if (x < 0) {
       x = 0;
       dx = -dx;
      }

      if (x + XSIZE >= d.width){
        x = d.width - XSIZE;
        dx = -dx;
      }

      g.setColor(color);
      g.fillOval(x, y, XSIZE, YSIZE);
      g.dispose();
   }  // move


   public void run()
   {  draw();
      for (int i = 1; i <= 5000; i++)
      {  move();
         try {
           Thread.sleep(5);
         }
         catch(InterruptedException e) {}
      }
   } // run

}  // ball




class SelfishBall extends Ball
{
   public SelfishBall(Canvas c, Color co) {
      super(c, co);
   }

   public void run(){
      draw();
      for (int i = 1; i <= 1000; i++)
      {  move();
         long t = System.currentTimeMillis();
         while (System.currentTimeMillis() < t+ 5) {
            double b=Math.sin(23.455);
         }
      }
   }
}

