/**
 * @(#) ChangePLAFAction.java 19.07.01
 *
 * jfem - a java finite element system
 *
 * Copyright (C) 1999-2001 HS-MD
 * jfem.support@jfem.de
 * www.jfem.de
 *
 * For License information see License.txt
 */

package org.app.action;

import java.awt.event.*;
import java.awt.*;
import org.app.manager.*;
import org.app.manager.property.*;

/** Change the pluggable look and feel of the application. */
/**
 * description:
 *
 * @version     1.0  19.07.01
 * @author      Thomas Schmidt, Michael Wilhelem
 */

public class ChangePLAFAction implements ActionListener {
    /**
     * Create a new object with the plaf as parameter.
     * @param plaf The look-and-feel to change to.
     */
    public ChangePLAFAction(String plaf) {
        _plaf = plaf;
    }

    /**
     * Change the plaf. This method yust calls the doChangePLAF method.
     * @param e Not used.
     */
    public void actionPerformed(ActionEvent e) {
        AppMan.getProperty(GlobalProperties.APP_PLAF).setValue(_plaf);
    }

    /**
     * Change the plaf. This method yust calls the doChangePLAF method.
     * @param e delete
     */
    public void actionPerformed() {
        AppMan.getProperty(GlobalProperties.APP_PLAF).setValue(_plaf);
    }

    /** The plaf to switch to. */
    private String _plaf;
}
