/**
 * @(#) IActionDefinitions.java 19.07.01
 *
 * jfem - a java finite element system
 *
 * Copyright (C) 1999-2001 HS-MD
 * jfem.support@jfem.de
 * www.jfem.de
 *
 * For License information see License.txt
 */

package org.app.action;


/** This interface contains command and action definitions from the main frame. */
/**
 * description:
 *
 * @version     1.0  19.07.01
 * @author      Thomas Schmidt, Michael Wilhelem
 * @see         #org.jfem.Action.ActionDefinitions
 * @see         #org.jfem.Action.ActionLibmanager Organisation:  FH MagdeburgDescription:   Definiert die Actions-Kommandos
 */

public interface IActionDefinitions {
    public final static int Modell_DOT = 1;
    public final static int Modell_DIT = 2;
    public final static int Modell_DXF = 3;
    public final static int Modell_SNAP = 4;

    /** Do toggle the query window. */
    public static final String ACTION_TOGGLE_QUERY_WINDOW = "mfQueryWindow";

    /** Do toggle the content window. */
    public static final String ACTION_TOGGLE_CONTENT_WINDOW = "mfContentWindow";
    //*******************************************************************
    //  Command definitions:
    //*******************************************************************
    public final static int CMD_NOT_IMPLEMENTED = 0;
    public final static int CMD_OPEN = 1;
    public final static int CMD_SAVE = 2;
    public final static int CMD_SAVEAS = 3;
    public final static int CMD_NEW = 4;
    public final static int CMD_CLOSE = 5;
    public final static int CMD_PRINT = 6;

    /** Close the application. */
    public static final int CMD_EXIT = 7;

    /** Windows Kaskade. */
    public static final int CMD_Win_New = 41;
    public static final int CMD_Win_Prev = 42;
    public static final int CMD_Win_Next = 43;
    public static final int CMD_Win_Overlapped = 44;
    public static final int CMD_Win_Tile = 45;
    public final static int CMD_OPEN_DAT = 103;
    public final static int CMD_OPEN_DIT = 104;

    /** Change the applications language. */
    public static final int CMD_CHANGE_LANGUAGE = 101;

    /** Open help index command. */
    public static final int CMD_HELP_INDEX = 102;
    //*******************************************************************
    //      Action definitions
    //*******************************************************************
    public static final int CMD_Modell1_Frame1 = 2001;
    public static final int CMD_Modell1_Frame2 = 2002;
    public static final int CMD_Modell1_Frame3 = 2003;
    public static final int CMD_Modell1_Frame4 = 2004;
    public static final int CMD_Modell1_Frame5 = 2005;
    public static final int CMD_Modell1_Frame6 = 2006;
    public static final int CMD_Modell1_Frame7 = 2007;
    public static final int CMD_Modell1_Frame8 = 2008;
    public static final int CMD_Modell1_Frame9 = 2009;
    public static final int CMD_Modell1_Frame10 = 2010;
    public static final int CMD_Modell2_Frame1 = 2101;
    public static final int CMD_Modell2_Frame2 = 2102;
}
