/////////////////////////////////////////////////////////////////////////////
// Function : NavNode (constructor)
// Comments :
/////////////////////////////////////////////////////////////////////////////
function NavNode(id, label, href, parent)
{
	this.m_parent = null;
	this.m_level = 0;

	if (parent)
	{
		this.m_parent = parent;
		this.m_level = parent.m_level+1;
	}

	this.m_id = id;

	// assume that m_label will most often be used directly as HTML
	this.m_rawlabel = label;

	label = label.replace(/&/g, '&amp;');
	label = label.replace(/</g, '&lt;');
	label = label.replace(/>/g, '&gt;');
	label = label.replace(/"/g, '&quot;');

	this.m_label = label;

	this.m_href = href;
	this.m_subNodes = new Array();

	var argValues = NavNode.arguments;
	var argCount = NavNode.arguments.length;

	for (i = 4 ; i < argCount ; i++)
	{
		var eqPos = argValues[i].indexOf("==");
		var attrName = argValues[i].substring(0,eqPos);
		var attrValue = argValues[i].substring(eqPos+2);

		eval("this.cp_" + attrName + " = '" + attrValue + "';");
	}

	NavNode.prototype.addNode = addNode;
	NavNode.prototype.isSelected = isSelected;
}

/////////////////////////////////////////////////////////////////////////////
// Function : addNode
// Comments :
/////////////////////////////////////////////////////////////////////////////
function addNode(id, label, href)
{
	var newIndex = this.m_subNodes.length;
	var newNode = new NavNode(id, label, href, this);

	var argValues = addNode.arguments;
	var argCount = addNode.arguments.length;

	for (i = 3 ; i < argCount ; i++)
	{
		var eqPos = argValues[i].indexOf("==");
		var attrName = argValues[i].substring(0,eqPos);
		var attrValue = argValues[i].substring(eqPos+2);

		eval("newNode.cp_" + attrName + " = '" + attrValue + "';");
	}

	this.m_subNodes[newIndex] = newNode;
	return newNode;
}

/////////////////////////////////////////////////////////////////////////////
// Function : isSelected
// Comments :
/////////////////////////////////////////////////////////////////////////////
function isSelected()
{
    var pos = window.location.href.lastIndexOf("/");
    var docname = window.location.href.substring(pos+1, window.location.href.length);

    pos = this.m_href.lastIndexOf("/");
    var myname = this.m_href.substring(pos+1, this.m_href.length);

    if (docname == myname)
		return true;
	else
		return false;
}

/////////////////////////////////////////////////////////////////////////////
// Function : customSectionPropertyExists
// Comments :
/////////////////////////////////////////////////////////////////////////////
function customSectionPropertyExists(csp)
{
	return (typeof csp != _U && csp != null);
}

/////////////////////////////////////////////////////////////////////////////
// Function : getCustomSectionProperty
// Comments :
/////////////////////////////////////////////////////////////////////////////
function getCustomSectionProperty(csp)
{
	if (customSectionPropertyExists(csp))
	{
		return csp;
	}
	else
	{
		return "";
	}
}

/////////////////////////////////////////////////////////////////////////////

var g_navNode_Root = new NavNode('otnen','Oracle Technology Network',ssUrlPrefix + 'index.html',null);
g_navNode_0=g_navNode_Root.addNode('otnen_database','Database',ssUrlPrefix + 'database/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_0=g_navNode_0.addNode('otnen_entedition','Database 11g',ssUrlPrefix + 'database/enterprise-edition/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_0_0=g_navNode_0_0.addNode('otnen_entedition_overview','Overview',ssUrlPrefix + 'database/enterprise-edition/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_0_1=g_navNode_0_0.addNode('otnen_entedition_downloads','Downloads',ssUrlPrefix + 'database/enterprise-edition/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_0_2=g_navNode_0_0.addNode('otnen_entedition_docs','Documentation',ssUrlPrefix + 'database/enterprise-edition/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_0_3=g_navNode_0_0.addNode('otnen_entedition_learnmore','Learn More',ssUrlPrefix + 'database/enterprise-edition/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_0_4=g_navNode_0_0.addNode('otnen_entedition_community','Community',ssUrlPrefix + 'database/enterprise-edition/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1=g_navNode_0.addNode('otnen_dbfeatures','Database Focus Areas',ssUrlPrefix + 'database/features/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_0=g_navNode_0_1.addNode('otnen_instantclient','Database Instant Client',ssUrlPrefix + 'database/features/instant-client/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_1=g_navNode_0_1.addNode('otnen_dbperformance','Performance \x26 Scalability',ssUrlPrefix + 'database/features/performance/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_2=g_navNode_0_1.addNode('otnen_dbstorage','Optimized Storage Management',ssUrlPrefix + 'database/features/storage/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_3=g_navNode_0_1.addNode('otnen_infomgmt','Information Management',ssUrlPrefix + 'database/features/information-management/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_4=g_navNode_0_1.addNode('otnen_callinterface','Oracle Call Interface',ssUrlPrefix + 'database/features/oci/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_5=g_navNode_0_1.addNode('otnen_manageability','Manageability',ssUrlPrefix + 'database/features/manageability/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_6=g_navNode_0_1.addNode('otnen_globalization','Globalization',ssUrlPrefix + 'database/features/globalization/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_7=g_navNode_0_1.addNode('otnen_dbappdev','Application Development',ssUrlPrefix + 'database/features/application-development/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_8=g_navNode_0_1.addNode('otnen_availability','High Availability',ssUrlPrefix + 'database/features/availability/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_9=g_navNode_0_1.addNode('otnen_datarep','Data Replication and Integration',ssUrlPrefix + 'database/features/data-integration/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_10=g_navNode_0_1.addNode('otnen_xmldb','XML DB',ssUrlPrefix + 'database/features/xmldb/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_10_0=g_navNode_0_1_10.addNode('otnen_xmldb_overview','Overview',ssUrlPrefix + 'database/features/xmldb/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_10_1=g_navNode_0_1_10.addNode('otnen_xmldb_downloads','Downloads',ssUrlPrefix + 'database/features/xmldb/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_10_2=g_navNode_0_1_10.addNode('otnen_xmldb_docs','Documentation',ssUrlPrefix + 'database/features/xmldb/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_10_3=g_navNode_0_1_10.addNode('otnen_xmldb_community','Community',ssUrlPrefix + 'database/features/xmldb/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_10_4=g_navNode_0_1_10.addNode('otnen_xmldb_learnmore','Learn More',ssUrlPrefix + 'database/features/xmldb/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_11=g_navNode_0_1.addNode('otnen_sqlplus','SQL Plus',ssUrlPrefix + 'database/features/sql-plus/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_12=g_navNode_0_1.addNode('otnen_plsql','PL/SQL',ssUrlPrefix + 'database/features/plsql/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_12_0=g_navNode_0_1_12.addNode('otnen_plsql_overview','Overview',ssUrlPrefix + 'database/features/plsql/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_12_1=g_navNode_0_1_12.addNode('otnen_plsql_downloads','Downloads',ssUrlPrefix + 'database/features/plsql/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_12_2=g_navNode_0_1_12.addNode('otnen_plsql_docs','Documentation',ssUrlPrefix + 'database/features/plsql/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_12_3=g_navNode_0_1_12.addNode('otnen_plsql_community','Community',ssUrlPrefix + 'database/features/plsql/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_12_4=g_navNode_0_1_12.addNode('otnen_plsql_learnmore','Learn More',ssUrlPrefix + 'database/features/plsql/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_1_13=g_navNode_0_1.addNode('otnen_dbbidata','BI \x26 Data Warehousing',ssUrlPrefix + 'database/features/bi-datawarehousing/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_14=g_navNode_0_1.addNode('otnen_jdbc','JDBC',ssUrlPrefix + 'database/features/jdbc/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_1_15=g_navNode_0_1.addNode('otnen_securefiles','Secure Files',ssUrlPrefix + 'database/features/secure-files/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2=g_navNode_0.addNode('otnen_dboptions','Database Options',ssUrlPrefix + 'database/options/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_0=g_navNode_0_2.addNode('otnen_semantictech','Semantic Technologies',ssUrlPrefix + 'database/options/semantic-tech/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_0_0=g_navNode_0_2_0.addNode('otnen_semantictech_whatsnew','What\'s New',ssUrlPrefix + 'database/options/semantic-tech/whatsnew/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_0_1=g_navNode_0_2_0.addNode('otnen_semantictech_downloads','Downloads',ssUrlPrefix + 'database/options/semantic-tech/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_0_2=g_navNode_0_2_0.addNode('otnen_semantictech_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'database/options/semantic-tech/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_0_3=g_navNode_0_2_0.addNode('otnen_semantictech_community','Community',ssUrlPrefix + 'database/options/semantic-tech/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_0_4=g_navNode_0_2_0.addNode('otnen_semantictech_learnmore','Learn More',ssUrlPrefix + 'database/options/semantic-tech/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_1=g_navNode_0_2.addNode('otnen_contentdb','Content DB',ssUrlPrefix + 'database/options/contentdb/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_1_0=g_navNode_0_2_1.addNode('otnen_contentdb_overview','Overview',ssUrlPrefix + 'database/options/contentdb/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_1_1=g_navNode_0_2_1.addNode('otnen_contentdb_downloads','Downloads',ssUrlPrefix + 'database/options/contentdb/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_1_2=g_navNode_0_2_1.addNode('otnen_contentdb_docs','Documentation',ssUrlPrefix + 'database/options/contentdb/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_1_3=g_navNode_0_2_1.addNode('otnen_contentdb_community','Community',ssUrlPrefix + 'database/options/contentdb/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_1_4=g_navNode_0_2_1.addNode('otnen_contentdb_learnmore','Learn More',ssUrlPrefix + 'database/options/contentdb/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_2=g_navNode_0_2.addNode('otnen_advcompression','Advanced Compression',ssUrlPrefix + 'database/options/compression/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_2_0=g_navNode_0_2_2.addNode('otnen_advcompression_overview','Overview',ssUrlPrefix + 'database/options/compression/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_2_1=g_navNode_0_2_2.addNode('otnen_advcompression_downloads','Downloads',ssUrlPrefix + 'database/options/compression/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_2_2=g_navNode_0_2_2.addNode('otnen_advcompression_docs','Documentation',ssUrlPrefix + 'database/options/compression/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_2_3=g_navNode_0_2_2.addNode('otnen_advcompression_community','Community',ssUrlPrefix + 'database/options/compression/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_2_4=g_navNode_0_2_2.addNode('otnen_advcompression_learnmore','Learn More',ssUrlPrefix + 'database/options/compression/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_3=g_navNode_0_2.addNode('otnen_imdbcache','In-Memory Database Cache',ssUrlPrefix + 'database/options/imdb-cache/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_3_0=g_navNode_0_2_3.addNode('otnen_imdbcache_overview','Overview',ssUrlPrefix + 'database/options/imdb-cache/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_3_1=g_navNode_0_2_3.addNode('otnen_imdbcache_downloads','Downloads',ssUrlPrefix + 'database/options/imdb-cache/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_3_2=g_navNode_0_2_3.addNode('otnen_imdbcache_docs','Documentation',ssUrlPrefix + 'database/options/imdb-cache/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_3_3=g_navNode_0_2_3.addNode('otnen_imdbcache_community','Community',ssUrlPrefix + 'database/options/imdb-cache/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_3_4=g_navNode_0_2_3.addNode('otnen_imdbcache_learnmore','Learn More',ssUrlPrefix + 'database/options/imdb-cache/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_4=g_navNode_0_2.addNode('otnen_datamining','Data Mining',ssUrlPrefix + 'database/options/odm/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_4_0=g_navNode_0_2_4.addNode('otnen_datamining_overview','Overview',ssUrlPrefix + 'database/options/odm/overview/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_4_1=g_navNode_0_2_4.addNode('otnen_datamining_downloads','Downloads',ssUrlPrefix + 'database/options/odm/downloads/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_4_2=g_navNode_0_2_4.addNode('otnen_datamining_docs','Documentation',ssUrlPrefix + 'database/options/odm/documentation/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_4_3=g_navNode_0_2_4.addNode('otnen_datamining_community','Community',ssUrlPrefix + 'database/options/odm/community/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_4_4=g_navNode_0_2_4.addNode('otnen_datamining_learnmore','Learn More',ssUrlPrefix + 'database/options/odm/learnmore/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_5=g_navNode_0_2.addNode('otnen_olap','OLAP',ssUrlPrefix + 'database/options/olap/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_6=g_navNode_0_2.addNode('otnen_spatial','Spatial',ssUrlPrefix + 'database/options/spatial/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_6_0=g_navNode_0_2_6.addNode('otnen_spatial_overview','Overview',ssUrlPrefix + 'database/options/spatial/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_6_1=g_navNode_0_2_6.addNode('otnen_spatial_downloads','Downloads',ssUrlPrefix + 'database/options/spatial/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_6_2=g_navNode_0_2_6.addNode('otnen_spatial_docs','Documentation',ssUrlPrefix + 'database/options/spatial/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_6_3=g_navNode_0_2_6.addNode('otnen_spatial_community','Community',ssUrlPrefix + 'database/options/spatial/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_6_4=g_navNode_0_2_6.addNode('otnen_spatial_learnmore','Learn More',ssUrlPrefix + 'database/options/spatial/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_2_7=g_navNode_0_2.addNode('otnen_partitioning','Partitioning',ssUrlPrefix + 'database/options/partitioning/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_8=g_navNode_0_2.addNode('otnen_advsecurity','Advanced Security',ssUrlPrefix + 'database/options/advanced-security/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_9=g_navNode_0_2.addNode('otnen_labelsecurity','Label Security',ssUrlPrefix + 'database/options/label-security/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_10=g_navNode_0_2.addNode('otnen_retaildata','Retail Data Model',ssUrlPrefix + 'database/options/retail-data-model/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_11=g_navNode_0_2.addNode('otnen_commdata','Communications Data Model',ssUrlPrefix + 'database/options/comm-data-model/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_2_12=g_navNode_0_2.addNode('otnen_databasevault','Database Vault',ssUrlPrefix + 'database/options/database-vault/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_3=g_navNode_0.addNode('otnen_expressedition','Database Express Edition',ssUrlPrefix + 'database/express-edition/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_3_0=g_navNode_0_3.addNode('otnen_expressedition_overview','Overview',ssUrlPrefix + 'database/express-edition/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_3_1=g_navNode_0_3.addNode('otnen_expressedition_downloads','Downloads',ssUrlPrefix + 'database/express-edition/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_3_2=g_navNode_0_3.addNode('otnen_expressedition_docs','Documentation',ssUrlPrefix + 'database/express-edition/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_3_3=g_navNode_0_3.addNode('otnen_expressedition_community','Community',ssUrlPrefix + 'database/express-edition/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_3_4=g_navNode_0_3.addNode('otnen_expressedition_learnmore','Learn More',ssUrlPrefix + 'database/express-edition/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_4=g_navNode_0.addNode('otnen_dbupgrade','Database Upgrade',ssUrlPrefix + 'database/upgrade/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_5=g_navNode_0.addNode('otnen_berkeleydb','Berkeley DB',ssUrlPrefix + 'database/berkeleydb/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_5_0=g_navNode_0_5.addNode('otnen_berkeleydb_overview','Overview',ssUrlPrefix + 'database/berkeleydb/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_5_1=g_navNode_0_5.addNode('otnen_berkeleydb_downloads','Downloads',ssUrlPrefix + 'database/berkeleydb/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_5_2=g_navNode_0_5.addNode('otnen_berkeleydb_docs','Documentation',ssUrlPrefix + 'database/berkeleydb/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_5_3=g_navNode_0_5.addNode('otnen_berkeleydb_learnmore','Learn More',ssUrlPrefix + 'database/berkeleydb/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_5_4=g_navNode_0_5.addNode('otnen_berkeleydb_community','Community',ssUrlPrefix + 'database/berkeleydb/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_6=g_navNode_0.addNode('otnen_timesten','TimesTen In-Memory Database',ssUrlPrefix + 'database/timesten/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_6_0=g_navNode_0_6.addNode('otnen_timesten_overview','Overview',ssUrlPrefix + 'database/timesten/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_6_1=g_navNode_0_6.addNode('otnen_timesten_downloads','Downloads',ssUrlPrefix + 'database/timesten/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_6_2=g_navNode_0_6.addNode('otnen_timesten_docs','Documentation',ssUrlPrefix + 'database/timesten/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_6_3=g_navNode_0_6.addNode('otnen_timesten_community','Community',ssUrlPrefix + 'database/timesten/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_6_4=g_navNode_0_6.addNode('otnen_timesten_learnmore','Learn More',ssUrlPrefix + 'database/timesten/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_7=g_navNode_0.addNode('otnen_exadata','Exadata',ssUrlPrefix + 'database/exadata/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_0_8=g_navNode_0.addNode('otnen_database10g','Database 10g',ssUrlPrefix + 'database/database10g/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_8_0=g_navNode_0_8.addNode('otnen_database10g_overview','Overview',ssUrlPrefix + 'database/database10g/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_8_1=g_navNode_0_8.addNode('otnen_database10g_downloads','Downloads',ssUrlPrefix + 'database/database10g/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_8_2=g_navNode_0_8.addNode('otnen_database10g_docs','Documentation',ssUrlPrefix + 'database/database10g/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_8_3=g_navNode_0_8.addNode('otnen_database10g_community','Community',ssUrlPrefix + 'database/database10g/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_8_4=g_navNode_0_8.addNode('otnen_database10g_learnmore','Learn More',ssUrlPrefix + 'database/database10g/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_9=g_navNode_0.addNode('otnen_dblite','Database Lite',ssUrlPrefix + 'database/database-lite/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_9_0=g_navNode_0_9.addNode('otnen_dblite_overview','Overview',ssUrlPrefix + 'database/database-lite/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_9_1=g_navNode_0_9.addNode('otnen_dblite_downloads','Downloads',ssUrlPrefix + 'database/database-lite/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_9_2=g_navNode_0_9.addNode('otnen_dblite_docs','Documentation',ssUrlPrefix + 'database/database-lite/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_9_3=g_navNode_0_9.addNode('otnen_dblite_community','Community',ssUrlPrefix + 'database/database-lite/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_9_4=g_navNode_0_9.addNode('otnen_dblite_learnmore','Learn More',ssUrlPrefix + 'database/database-lite/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_10=g_navNode_0.addNode('otnen_rdb','RDB',ssUrlPrefix + 'database/rdb/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_10_0=g_navNode_0_10.addNode('otnen_rdb_overview','Overview',ssUrlPrefix + 'database/rdb/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_10_1=g_navNode_0_10.addNode('otnen_rdb_downloads','Downloads',ssUrlPrefix + 'database/rdb/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_10_2=g_navNode_0_10.addNode('otnen_rdb_docs','Documentation',ssUrlPrefix + 'database/rdb/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_10_3=g_navNode_0_10.addNode('otnen_rdb_community','Community',ssUrlPrefix + 'database/rdb/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_10_4=g_navNode_0_10.addNode('otnen_rdb_learnmore','Learn More',ssUrlPrefix + 'database/rdb/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_12=g_navNode_0.addNode('otnen_auditvault','Audit Vault',ssUrlPrefix + 'database/audit-vault/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_12_0=g_navNode_0_12.addNode('otnen_auditvault_overview','Overview',ssUrlPrefix + 'database/audit-vault/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_12_1=g_navNode_0_12.addNode('otnen_auditvault_downloads','Downloads',ssUrlPrefix + 'database/audit-vault/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_12_2=g_navNode_0_12.addNode('otnen_auditvault_docs','Documentation',ssUrlPrefix + 'database/audit-vault/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_12_3=g_navNode_0_12.addNode('otnen_auditvault_community','Community',ssUrlPrefix + 'database/audit-vault/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_12_4=g_navNode_0_12.addNode('otnen_auditvault_learnmore','Learn More',ssUrlPrefix + 'database/audit-vault/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_13=g_navNode_0.addNode('otnen_securebackup','Secure Backup',ssUrlPrefix + 'database/secure-backup/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_13_0=g_navNode_0_13.addNode('otnen_securebackup_overview','Overview',ssUrlPrefix + 'database/secure-backup/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_13_1=g_navNode_0_13.addNode('otnen_securebackup_downloads','Downloads',ssUrlPrefix + 'database/secure-backup/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_13_2=g_navNode_0_13.addNode('otnen_securebackup_docs','Documentation',ssUrlPrefix + 'database/secure-backup/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_13_3=g_navNode_0_13.addNode('otnen_securebackup_community','Community',ssUrlPrefix + 'database/secure-backup/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_13_4=g_navNode_0_13.addNode('otnen_securebackup_learnmore','Learn More',ssUrlPrefix + 'database/secure-backup/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_14=g_navNode_0.addNode('otnen_rac','Real Application Clusters',ssUrlPrefix + 'database/clustering/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_14_0=g_navNode_0_14.addNode('otnen_rac_overview','Overview',ssUrlPrefix + 'database/clustering/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_14_1=g_navNode_0_14.addNode('otnen_rac_downloads','Downloads',ssUrlPrefix + 'database/clustering/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_14_2=g_navNode_0_14.addNode('otnen_rac_docs','Documentation',ssUrlPrefix + 'database/clustering/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_14_3=g_navNode_0_14.addNode('otnen_rac_community','Community',ssUrlPrefix + 'database/clustering/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_14_4=g_navNode_0_14.addNode('otnen_rac_learnmore','Learn More',ssUrlPrefix + 'database/clustering/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_15=g_navNode_0.addNode('otnen_clusterware','Clusterware',ssUrlPrefix + 'database/clusterware/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_15_0=g_navNode_0_15.addNode('otnen_clusterware_overview','Overview',ssUrlPrefix + 'database/clusterware/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_15_1=g_navNode_0_15.addNode('otnen_clusterware_downloads','Downloads',ssUrlPrefix + 'database/clusterware/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_15_2=g_navNode_0_15.addNode('otnen_clusterware_docs','Documentation',ssUrlPrefix + 'database/clusterware/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_15_3=g_navNode_0_15.addNode('otnen_clusterware_community','Community',ssUrlPrefix + 'database/clusterware/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_15_4=g_navNode_0_15.addNode('otnen_clusterware_learnmore','Learn More',ssUrlPrefix + 'database/clusterware/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_17=g_navNode_0.addNode('otnen_multimedia','Multimedia',ssUrlPrefix + 'database/multimedia/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_17_0=g_navNode_0_17.addNode('otnen_multimedia_overview','Overview',ssUrlPrefix + 'database/multimedia/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_17_1=g_navNode_0_17.addNode('otnen_multimedia_downloads','Downloads',ssUrlPrefix + 'database/multimedia/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_17_2=g_navNode_0_17.addNode('otnen_multimedia_docs','Documentation',ssUrlPrefix + 'database/multimedia/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_17_3=g_navNode_0_17.addNode('otnen_multimedia_community','Community',ssUrlPrefix + 'database/multimedia/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_17_4=g_navNode_0_17.addNode('otnen_multimedia_learnmore','Learn More',ssUrlPrefix + 'database/multimedia/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_18=g_navNode_0.addNode('otnen_dbwindows','Windows',ssUrlPrefix + 'database/windows/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_18_0=g_navNode_0_18.addNode('otnen_dbwindows_overview','What\'s New',ssUrlPrefix + 'database/windows/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_18_1=g_navNode_0_18.addNode('otnen_dbwindows_beginners','For Beginners',ssUrlPrefix + 'database/windows/for-beginners/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_18_2=g_navNode_0_18.addNode('otnen_dbwindows_products','Products',ssUrlPrefix + 'database/windows/products/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_18_3=g_navNode_0_18.addNode('otnen_dbwindows_techinfo','Technical Information',ssUrlPrefix + 'database/windows/tech-info/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_18_4=g_navNode_0_18.addNode('otnen_dbwindows_downloads','Downloads',ssUrlPrefix + 'database/windows/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_0_19=g_navNode_0.addNode('otnen_migration','Migration',ssUrlPrefix + 'database/migration/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1=g_navNode_Root.addNode('otnen_middleware','Middleware',ssUrlPrefix + 'middleware/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==/technetwork/middleware/fusion-middleware/overview/index.html');
g_navNode_1_0=g_navNode_1.addNode('otnen_fusmiddleware','Fusion Middleware Home',ssUrlPrefix + 'middleware/fusion-middleware/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_0_0=g_navNode_1_0.addNode('otnen_fusmiddleware_overview','Overview',ssUrlPrefix + 'middleware/fusion-middleware/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_0_1=g_navNode_1_0.addNode('otnen_fusmiddleware_downloads','Downloads',ssUrlPrefix + 'middleware/fusion-middleware/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_0_2=g_navNode_1_0.addNode('otnen_fusmiddleware_docs','Documentation',ssUrlPrefix + 'middleware/fusion-middleware/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_0_3=g_navNode_1_0.addNode('otnen_fusmiddleware_community','Community',ssUrlPrefix + 'middleware/fusion-middleware/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_0_4=g_navNode_1_0.addNode('otnen_fusmiddleware_learnmore','Learn More',ssUrlPrefix + 'middleware/fusion-middleware/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_1=g_navNode_1.addNode('otnen_foundpack','AIA Foundation Pack',ssUrlPrefix + 'middleware/foundation-pack/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_1_0=g_navNode_1_1.addNode('otnen_foundpack_overview','Overview',ssUrlPrefix + 'middleware/foundation-pack/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_1_1=g_navNode_1_1.addNode('otnen_foundpack_downloads','Downloads',ssUrlPrefix + 'middleware/foundation-pack/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_1_2=g_navNode_1_1.addNode('otnen_foundpack_docs','Documentation',ssUrlPrefix + 'middleware/foundation-pack/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_1_3=g_navNode_1_1.addNode('otnen_foundpack_community','Community',ssUrlPrefix + 'middleware/foundation-pack/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_1_4=g_navNode_1_1.addNode('otnen_foundpack_learnmore','Learn More',ssUrlPrefix + 'middleware/foundation-pack/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_2=g_navNode_1.addNode('otnen_businessintel','Business Intelligence',ssUrlPrefix + 'middleware/bi/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1_2_0=g_navNode_1_2.addNode('otnen_businessintel_overview','Overview',ssUrlPrefix + 'middleware/bi/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_2_1=g_navNode_1_2.addNode('otnen_businessintel_downloads','Downloads',ssUrlPrefix + 'middleware/bi/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_2_2=g_navNode_1_2.addNode('otnen_businessintel_docs','Documentation',ssUrlPrefix + 'middleware/bi/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_2_3=g_navNode_1_2.addNode('otnen_businessintel_community','Community',ssUrlPrefix + 'middleware/bi/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_2_4=g_navNode_1_2.addNode('otnen_businessintel_learnmore','Learn More',ssUrlPrefix + 'middleware/bi/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_3=g_navNode_1.addNode('otnen_coherence','Coherence',ssUrlPrefix + 'middleware/coherence/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_3_0=g_navNode_1_3.addNode('otnen_coherence_overview','Overview',ssUrlPrefix + 'middleware/coherence/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_3_1=g_navNode_1_3.addNode('otnen_coherence_downloads','Downloads',ssUrlPrefix + 'middleware/coherence/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_3_2=g_navNode_1_3.addNode('otnen_coherence_docs','Documentation',ssUrlPrefix + 'middleware/coherence/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_3_3=g_navNode_1_3.addNode('otnen_coherence_community','Community',ssUrlPrefix + 'middleware/coherence/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_3_4=g_navNode_1_3.addNode('otnen_coherence_learnmore','Learn More',ssUrlPrefix + 'middleware/coherence/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_4=g_navNode_1.addNode('otnen_mwdevtools','Developer Tools',ssUrlPrefix + 'middleware/dev-tools/index.html','ssRedirectURL==/technetwork/developer-tools/index.html','ssTabsLevelOverride==-1');
g_navNode_1_5=g_navNode_1.addNode('otnen_eventdrivearch','Event-Driven Architecture Suite',ssUrlPrefix + 'middleware/event-driven-architecture/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==http\x3a//www.oracle.com/technology/products/event-driven-architecture/index.html');
g_navNode_1_5_0=g_navNode_1_5.addNode('otnen_eventdrivenarch_overview','Overview',ssUrlPrefix + 'middleware/event-driven-architecture/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_5_1=g_navNode_1_5.addNode('otnen_eventdrivenarch_download','Downloads',ssUrlPrefix + 'middleware/event-driven-architecture/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_5_2=g_navNode_1_5.addNode('otnen_eventdrivenarch_docs','Documentation',ssUrlPrefix + 'middleware/event-driven-architecture/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_5_3=g_navNode_1_5.addNode('otnen_eventdrivenarch_comm','Community',ssUrlPrefix + 'middleware/event-driven-architecture/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_5_4=g_navNode_1_5.addNode('otnen_eventdrivenarch_learnmor','Learn More',ssUrlPrefix + 'middleware/event-driven-architecture/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_6=g_navNode_1.addNode('otnen_glassfish','GlassFish Server',ssUrlPrefix + 'middleware/glassfish/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_6_0=g_navNode_1_6.addNode('otnen_glassfish_overview','Overview',ssUrlPrefix + 'middleware/glassfish/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_6_1=g_navNode_1_6.addNode('otnen_glassfish_downloads','Downloads',ssUrlPrefix + 'middleware/glassfish/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_6_2=g_navNode_1_6.addNode('otnen_glassfish_docs','Documentation',ssUrlPrefix + 'middleware/glassfish/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_6_3=g_navNode_1_6.addNode('otnen_glassfish_community','Community',ssUrlPrefix + 'middleware/glassfish/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_6_4=g_navNode_1_6.addNode('otnen_glassfish_learnmore','Learn More',ssUrlPrefix + 'middleware/glassfish/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_7=g_navNode_1.addNode('otnen_idmgmt','Identity Management',ssUrlPrefix + 'middleware/id-mgmt/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_7_0=g_navNode_1_7.addNode('otnen_idmgmt_overview','Overview',ssUrlPrefix + 'middleware/id-mgmt/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_7_1=g_navNode_1_7.addNode('otnen_idmgmt_downloads','Downloads',ssUrlPrefix + 'middleware/id-mgmt/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_7_2=g_navNode_1_7.addNode('otnen_idmgmt_docs','Documentation',ssUrlPrefix + 'middleware/id-mgmt/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_7_3=g_navNode_1_7.addNode('otnen_idmgmt_community','Community',ssUrlPrefix + 'middleware/id-mgmt/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_7_4=g_navNode_1_7.addNode('otnen_idmgmt_learnmore','Learn More',ssUrlPrefix + 'middleware/id-mgmt/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_8=g_navNode_1.addNode('otnen_jrockit','JRockit',ssUrlPrefix + 'middleware/jrockit/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_8_0=g_navNode_1_8.addNode('otnen_jrockit_overview','Overview',ssUrlPrefix + 'middleware/jrockit/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_8_1=g_navNode_1_8.addNode('otnen_jrockit_downloads','Downloads',ssUrlPrefix + 'middleware/jrockit/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_8_2=g_navNode_1_8.addNode('otnen_jrockit_docs','Documentation',ssUrlPrefix + 'middleware/jrockit/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_8_3=g_navNode_1_8.addNode('otnen_jrockit_community','Community',ssUrlPrefix + 'middleware/jrockit/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_8_4=g_navNode_1_8.addNode('otnen_jrockit_learnmore','Learn More',ssUrlPrefix + 'middleware/jrockit/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_9=g_navNode_1.addNode('otnen_soasuite','SOA Suite',ssUrlPrefix + 'middleware/soasuite/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==http\x3a//www.oracle.com/technology/products/soa/soasuite/index.html');
g_navNode_1_9_0=g_navNode_1_9.addNode('otnen_soasuite_overview','Overview',ssUrlPrefix + 'middleware/soasuite/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_9_1=g_navNode_1_9.addNode('otnen_soasuite_downloads','Downloads',ssUrlPrefix + 'middleware/soasuite/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_9_2=g_navNode_1_9.addNode('otnen_soasuite_docs','Documentation',ssUrlPrefix + 'middleware/soasuite/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_9_3=g_navNode_1_9.addNode('otnen_soasuite_community','Customers',ssUrlPrefix + 'middleware/soasuite/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_9_4=g_navNode_1_9.addNode('otnen_soasuite_learnmore','Learn More',ssUrlPrefix + 'middleware/soasuite/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_10=g_navNode_1.addNode('otnen_toplink','TopLink',ssUrlPrefix + 'middleware/toplink/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_10_0=g_navNode_1_10.addNode('otnen_toplink_overview','Overview',ssUrlPrefix + 'middleware/toplink/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_10_1=g_navNode_1_10.addNode('otnen_toplink_downloads','Downloads',ssUrlPrefix + 'middleware/toplink/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_10_2=g_navNode_1_10.addNode('otnen_toplink_docs','Documentation',ssUrlPrefix + 'middleware/toplink/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_10_3=g_navNode_1_10.addNode('otnen_toplink_community','Community',ssUrlPrefix + 'middleware/toplink/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_10_4=g_navNode_1_10.addNode('otnen_toplink_learnmore','Learn More',ssUrlPrefix + 'middleware/toplink/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_11=g_navNode_1.addNode('otnen_tuxedo','Tuxedo',ssUrlPrefix + 'middleware/tuxedo/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_11_0=g_navNode_1_11.addNode('otnen_tuxedo_overview','Overview',ssUrlPrefix + 'middleware/tuxedo/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_11_1=g_navNode_1_11.addNode('otnen_tuxedo_downloads','Downloads',ssUrlPrefix + 'middleware/tuxedo/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_11_2=g_navNode_1_11.addNode('otnen_tuxedo_docs','Documentation',ssUrlPrefix + 'middleware/tuxedo/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_11_3=g_navNode_1_11.addNode('otnen_tuxedo_community','Community',ssUrlPrefix + 'middleware/tuxedo/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_11_4=g_navNode_1_11.addNode('otnen_tuxedo_learnmore','Learn More',ssUrlPrefix + 'middleware/tuxedo/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_12=g_navNode_1.addNode('otnen_webcenter','WebCenter Suite',ssUrlPrefix + 'middleware/webcenter/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_12_0=g_navNode_1_12.addNode('otnen_webcenter_overview','Overview',ssUrlPrefix + 'middleware/webcenter/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_12_1=g_navNode_1_12.addNode('otnen_webcenter_downloads','Downloads',ssUrlPrefix + 'middleware/webcenter/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_12_2=g_navNode_1_12.addNode('otnen_webcenter_docs','Documentation',ssUrlPrefix + 'middleware/webcenter/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_12_3=g_navNode_1_12.addNode('otnen_webcenter_community','Community',ssUrlPrefix + 'middleware/webcenter/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_12_4=g_navNode_1_12.addNode('otnen_webcenter_learnmore','Learn More',ssUrlPrefix + 'middleware/webcenter/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_13=g_navNode_1.addNode('otnen_weblogic','WebLogic Server',ssUrlPrefix + 'middleware/weblogic/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_13_0=g_navNode_1_13.addNode('otnen_weblogic_overview','Overview',ssUrlPrefix + 'middleware/weblogic/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_13_1=g_navNode_1_13.addNode('otnen_weblogic_downloads','Downloads',ssUrlPrefix + 'middleware/weblogic/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_13_2=g_navNode_1_13.addNode('otnen_weblogic_docs','Documentation',ssUrlPrefix + 'middleware/weblogic/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_13_3=g_navNode_1_13.addNode('otnen_weblogic_learnmore','Learn More',ssUrlPrefix + 'middleware/weblogic/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_13_4=g_navNode_1_13.addNode('otnen_weblogic_community','Community',ssUrlPrefix + 'middleware/weblogic/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_14=g_navNode_1.addNode('otnen_compeventproc','Complex Event Processing',ssUrlPrefix + 'middleware/complex-event-processing/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_14_0=g_navNode_1_14.addNode('otnen_compeventproc_overview','Overview',ssUrlPrefix + 'middleware/complex-event-processing/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_14_1=g_navNode_1_14.addNode('otnen_compeventproc_downloads','Downloads',ssUrlPrefix + 'middleware/complex-event-processing/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_14_2=g_navNode_1_14.addNode('otnen_compeventproc_docs','Documentation',ssUrlPrefix + 'middleware/complex-event-processing/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_14_3=g_navNode_1_14.addNode('otnen_compeventproc_community','Community',ssUrlPrefix + 'middleware/complex-event-processing/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_14_4=g_navNode_1_14.addNode('otnen_compeventproc_learnmore','Learn More',ssUrlPrefix + 'middleware/complex-event-processing/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_15=g_navNode_1.addNode('otnen_bifoundation','Business Intelligence Foundation',ssUrlPrefix + 'middleware/bi-foundation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_15_0=g_navNode_1_15.addNode('otnen_bifoundation_overview','Overview',ssUrlPrefix + 'middleware/bi-foundation/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_15_1=g_navNode_1_15.addNode('otnen_bifoundation_downloads','Downloads',ssUrlPrefix + 'middleware/bi-foundation/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_15_2=g_navNode_1_15.addNode('otnen_bifoundation_docs','Documentation',ssUrlPrefix + 'middleware/bi-foundation/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_15_3=g_navNode_1_15.addNode('otnen_bifoundation_community','Community',ssUrlPrefix + 'middleware/bi-foundation/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_15_4=g_navNode_1_15.addNode('otnen_bifoundation_learnmore','Learn More',ssUrlPrefix + 'middleware/bi-foundation/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_16=g_navNode_1.addNode('otnen_dataint','Data Integration',ssUrlPrefix + 'middleware/data-integration/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_16_0=g_navNode_1_16.addNode('otnen_dataint_overview','Overview',ssUrlPrefix + 'middleware/data-integration/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_16_1=g_navNode_1_16.addNode('otnen_dataint_downloads','Downloads',ssUrlPrefix + 'middleware/data-integration/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_16_2=g_navNode_1_16.addNode('otnen_dataint_docs','Documentation',ssUrlPrefix + 'middleware/data-integration/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_16_3=g_navNode_1_16.addNode('otnen_dataint_community','Community',ssUrlPrefix + 'middleware/data-integration/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_16_4=g_navNode_1_16.addNode('otnen_dataint_learnmore','Learn More',ssUrlPrefix + 'middleware/data-integration/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_19=g_navNode_1.addNode('otnen_appserver','Application Server',ssUrlPrefix + 'middleware/ias/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_19_0=g_navNode_1_19.addNode('otnen_appserver_overview','Overview',ssUrlPrefix + 'middleware/ias/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_19_1=g_navNode_1_19.addNode('otnen_appserver_downloads','Downloads',ssUrlPrefix + 'middleware/ias/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_19_2=g_navNode_1_19.addNode('otnen_appserver_docs','Documentation',ssUrlPrefix + 'middleware/ias/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_19_3=g_navNode_1_19.addNode('otnen_appserver_community','Community',ssUrlPrefix + 'middleware/ias/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_19_4=g_navNode_1_19.addNode('otnen_appserver_learnmore','Learn More',ssUrlPrefix + 'middleware/ias/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_20=g_navNode_1.addNode('otnen_beehive','Beehive',ssUrlPrefix + 'middleware/beehive/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_20_0=g_navNode_1_20.addNode('otnen_beehive_overview','Overview',ssUrlPrefix + 'middleware/beehive/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_20_1=g_navNode_1_20.addNode('otnen_beehive_downloads','Downloads',ssUrlPrefix + 'middleware/beehive/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_20_2=g_navNode_1_20.addNode('otnen_beehive_docs','Documentation',ssUrlPrefix + 'middleware/beehive/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_20_3=g_navNode_1_20.addNode('otnen_beehive_community','Community',ssUrlPrefix + 'middleware/beehive/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_20_4=g_navNode_1_20.addNode('otnen_beehive_learnmore','Learn More',ssUrlPrefix + 'middleware/beehive/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_21=g_navNode_1.addNode('otnen_bpel','BPEL Process Manager',ssUrlPrefix + 'middleware/bpel/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_21_0=g_navNode_1_21.addNode('otnen_bpel_overview','Overview',ssUrlPrefix + 'middleware/bpel/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_21_1=g_navNode_1_21.addNode('otnen_bpel_downloads','Downloads',ssUrlPrefix + 'middleware/bpel/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_21_2=g_navNode_1_21.addNode('otnen_bpel_docs','Documentation',ssUrlPrefix + 'middleware/bpel/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_21_3=g_navNode_1_21.addNode('otnen_bpel_community','Customers',ssUrlPrefix + 'middleware/bpel/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_21_4=g_navNode_1_21.addNode('otnen_bpel_learnmore','Learn More',ssUrlPrefix + 'middleware/bpel/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_22=g_navNode_1.addNode('otnen_integration','Business Integration',ssUrlPrefix + 'middleware/integration/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1_23=g_navNode_1.addNode('otnen_bpm','Business Process Management',ssUrlPrefix + 'middleware/bpm/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_23_0=g_navNode_1_23.addNode('otnen_bpm_overview','Overview',ssUrlPrefix + 'middleware/bpm/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_23_1=g_navNode_1_23.addNode('otnen_bpm_downloads','Downloads',ssUrlPrefix + 'middleware/bpm/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_23_2=g_navNode_1_23.addNode('otnen_bpm_docs','Documentation',ssUrlPrefix + 'middleware/bpm/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_23_3=g_navNode_1_23.addNode('otnen_bpm_community','Community',ssUrlPrefix + 'middleware/bpm/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_23_4=g_navNode_1_23.addNode('otnen_bpm_learnmore','Learn More',ssUrlPrefix + 'middleware/bpm/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_25=g_navNode_1.addNode('otnen_ccas','Communications Converged Applications Server',ssUrlPrefix + 'middleware/ccas/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_25_0=g_navNode_1_25.addNode('otnen_ccas_overview','Overview',ssUrlPrefix + 'middleware/ccas/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_25_1=g_navNode_1_25.addNode('otnen_ccas_downloads','Downloads',ssUrlPrefix + 'middleware/ccas/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_25_2=g_navNode_1_25.addNode('otnen_ccas_docs','Documentation',ssUrlPrefix + 'middleware/ccas/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_25_3=g_navNode_1_25.addNode('otnen_ccas_community','Community',ssUrlPrefix + 'middleware/ccas/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_25_4=g_navNode_1_25.addNode('otnen_ccas_learnmore','Learn More',ssUrlPrefix + 'middleware/ccas/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_26=g_navNode_1.addNode('otnen_ocp','Communications Presence',ssUrlPrefix + 'middleware/ocp/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_26_0=g_navNode_1_26.addNode('otnen_ocp_overview','Overview',ssUrlPrefix + 'middleware/ocp/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_26_1=g_navNode_1_26.addNode('otnen_ocp_downloads','Downloads',ssUrlPrefix + 'middleware/ocp/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_26_2=g_navNode_1_26.addNode('otnen_ocp_docs','Documentation',ssUrlPrefix + 'middleware/ocp/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_26_3=g_navNode_1_26.addNode('otnen_ocp_community','Community',ssUrlPrefix + 'middleware/ocp/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_26_4=g_navNode_1_26.addNode('otnen_ocp_learnmore','Learn More',ssUrlPrefix + 'middleware/ocp/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_27=g_navNode_1.addNode('otnen_contentmgmt','Content Management',ssUrlPrefix + 'middleware/content-management/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_27_0=g_navNode_1_27.addNode('otnen_contentmgmt_overview','Overview',ssUrlPrefix + 'middleware/content-management/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_27_1=g_navNode_1_27.addNode('otnen_contentmgmt_downloads','Downloads',ssUrlPrefix + 'middleware/content-management/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_27_2=g_navNode_1_27.addNode('otnen_contentmgmt_docs','Documentation',ssUrlPrefix + 'middleware/content-management/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_27_3=g_navNode_1_27.addNode('otnen_contentmgmt_community','Community',ssUrlPrefix + 'middleware/content-management/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_27_4=g_navNode_1_27.addNode('otnen_contentmgmt_learnmore','Learn More',ssUrlPrefix + 'middleware/content-management/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_28=g_navNode_1.addNode('otnen_entrepository','Enterprise Repository',ssUrlPrefix + 'middleware/repository/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_28_0=g_navNode_1_28.addNode('otnen_entrepository_overview','Overview',ssUrlPrefix + 'middleware/repository/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_28_1=g_navNode_1_28.addNode('otnen_entrepository_downloads','Downloads',ssUrlPrefix + 'middleware/repository/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_28_2=g_navNode_1_28.addNode('otnen_entrepository_docs','Documentation',ssUrlPrefix + 'middleware/repository/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_28_3=g_navNode_1_28.addNode('otnen_entrepository_community','Community',ssUrlPrefix + 'middleware/repository/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_28_4=g_navNode_1_28.addNode('otnen_entrepository_learnmore','Learn More',ssUrlPrefix + 'middleware/repository/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_29=g_navNode_1.addNode('otnen_oes','Entitlements Server',ssUrlPrefix + 'middleware/oes/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_29_0=g_navNode_1_29.addNode('otnen_oes_overview','Overview',ssUrlPrefix + 'middleware/oes/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_29_1=g_navNode_1_29.addNode('otnen_oes_downloads','Downloads',ssUrlPrefix + 'middleware/oes/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_29_2=g_navNode_1_29.addNode('otnen_oes_docs','Documentation',ssUrlPrefix + 'middleware/oes/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_29_3=g_navNode_1_29.addNode('otnen_oes_community','Community',ssUrlPrefix + 'middleware/oes/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_29_4=g_navNode_1_29.addNode('otnen_oes_learnmore','Learn More',ssUrlPrefix + 'middleware/oes/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_32=g_navNode_1.addNode('otnen_portal','Portal',ssUrlPrefix + 'middleware/portal/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_32_0=g_navNode_1_32.addNode('otnen_portal_overview','Overview',ssUrlPrefix + 'middleware/portal/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_32_1=g_navNode_1_32.addNode('otnen_portal_downloads','Downloads',ssUrlPrefix + 'middleware/portal/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_32_2=g_navNode_1_32.addNode('otnen_portal_docs','Documentation',ssUrlPrefix + 'middleware/portal/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_32_3=g_navNode_1_32.addNode('otnen_portal_community','Community',ssUrlPrefix + 'middleware/portal/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_32_4=g_navNode_1_32.addNode('otnen_portal_learnmore','Learn More',ssUrlPrefix + 'middleware/portal/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_33=g_navNode_1.addNode('otnen_reports','Reports',ssUrlPrefix + 'middleware/reports/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_33_0=g_navNode_1_33.addNode('otnen_reports_overview','Overview',ssUrlPrefix + 'middleware/reports/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_33_1=g_navNode_1_33.addNode('otnen_reports_downloads','Downloads',ssUrlPrefix + 'middleware/reports/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_33_2=g_navNode_1_33.addNode('otnen_reports_docs','Documentation',ssUrlPrefix + 'middleware/reports/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_33_3=g_navNode_1_33.addNode('otnen_reports_community','Community',ssUrlPrefix + 'middleware/reports/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_33_4=g_navNode_1_33.addNode('otnen_reports_learnmore','Learn More',ssUrlPrefix + 'middleware/reports/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_34=g_navNode_1.addNode('otnen_servicebus','Service Bus',ssUrlPrefix + 'middleware/service-bus/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_34_0=g_navNode_1_34.addNode('otnen_servicebus_overview','Overview',ssUrlPrefix + 'middleware/service-bus/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_34_1=g_navNode_1_34.addNode('otnen_servicebus_downloads','Downloads',ssUrlPrefix + 'middleware/service-bus/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_34_2=g_navNode_1_34.addNode('otnen_servicebus_docs','Documentation',ssUrlPrefix + 'middleware/service-bus/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_34_3=g_navNode_1_34.addNode('otnen_servicebus_community','Customers',ssUrlPrefix + 'middleware/service-bus/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_34_4=g_navNode_1_34.addNode('otnen_servicebus_learnmore','Learn More',ssUrlPrefix + 'middleware/service-bus/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_35=g_navNode_1.addNode('otnen_registry','Service Registry',ssUrlPrefix + 'middleware/registry/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_35_0=g_navNode_1_35.addNode('otnen_registry_overview','Overview',ssUrlPrefix + 'middleware/registry/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_35_1=g_navNode_1_35.addNode('otnen_registry_downloads','Downloads',ssUrlPrefix + 'middleware/registry/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_35_2=g_navNode_1_35.addNode('otnen_registry_docs','Documentation',ssUrlPrefix + 'middleware/registry/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_35_3=g_navNode_1_35.addNode('otnen_registry_community','Community',ssUrlPrefix + 'middleware/registry/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_35_4=g_navNode_1_35.addNode('otnen_registry_learnmore','Learn More',ssUrlPrefix + 'middleware/registry/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_36=g_navNode_1.addNode('otnen_ovab','Virtual Assembly Builder',ssUrlPrefix + 'middleware/ovab/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_36_0=g_navNode_1_36.addNode('otnen_ovab_overview','Overview',ssUrlPrefix + 'middleware/ovab/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_36_1=g_navNode_1_36.addNode('otnen_ovab_downloads','Downloads',ssUrlPrefix + 'middleware/ovab/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_36_2=g_navNode_1_36.addNode('otnen_ovab_docs','Documentation',ssUrlPrefix + 'middleware/ovab/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_36_3=g_navNode_1_36.addNode('otnen_ovab_community','Community',ssUrlPrefix + 'middleware/ovab/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_36_4=g_navNode_1_36.addNode('otnen_ovab_learnmore','Learn More',ssUrlPrefix + 'middleware/ovab/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_37=g_navNode_1.addNode('otnen_webservmgr','Web Services Manager',ssUrlPrefix + 'middleware/webservices-manager/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1_38=g_navNode_1.addNode('otnen_wcinteraction','WebCenter Interaction',ssUrlPrefix + 'middleware/webcenter-interaction/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_38_0=g_navNode_1_38.addNode('otnen_wcinteraction_overview','Overview',ssUrlPrefix + 'middleware/webcenter-interaction/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_38_1=g_navNode_1_38.addNode('otnen_wcinteraction_downloads','Downloads',ssUrlPrefix + 'middleware/webcenter-interaction/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_38_2=g_navNode_1_38.addNode('otnen_wcinteraction_docs','Documentation',ssUrlPrefix + 'middleware/webcenter-interaction/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_38_3=g_navNode_1_38.addNode('otnen_wcinteraction_community','Community',ssUrlPrefix + 'middleware/webcenter-interaction/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_38_4=g_navNode_1_38.addNode('otnen_wcinteraction_learnmore','Learn More',ssUrlPrefix + 'middleware/webcenter-interaction/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_39=g_navNode_1.addNode('otnen_wcservices','WebCenter Services',ssUrlPrefix + 'middleware/webcenter-services/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1_40=g_navNode_1.addNode('otnen_wcintelcollab','WebCenter Intelligent Collaboration',ssUrlPrefix + 'middleware/wc-intelligent-collaboration/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_40_0=g_navNode_1_40.addNode('otnen_wcintelcollab_overview','Overview',ssUrlPrefix + 'middleware/wc-intelligent-collaboration/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_40_1=g_navNode_1_40.addNode('otnen_wcintelcollab_downloads','Downloads',ssUrlPrefix + 'middleware/wc-intelligent-collaboration/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_40_2=g_navNode_1_40.addNode('otnen_wcintelcollab_docs','Documentation',ssUrlPrefix + 'middleware/wc-intelligent-collaboration/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_40_3=g_navNode_1_40.addNode('otnen_wcintelcollab_community','Community',ssUrlPrefix + 'middleware/wc-intelligent-collaboration/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_40_4=g_navNode_1_40.addNode('otnen_wcintelcollab_learnmore','Learn More',ssUrlPrefix + 'middleware/wc-intelligent-collaboration/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_41=g_navNode_1.addNode('otnen_wcrtcollab','WebCenter Real-Time Collaboration',ssUrlPrefix + 'middleware/wc-real-time-collaboration/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_41_0=g_navNode_1_41.addNode('otnen_wcrtcollab_overview','Overview',ssUrlPrefix + 'middleware/wc-real-time-collaboration/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_41_1=g_navNode_1_41.addNode('otnen_wcrtcollab_downloads','Downloads',ssUrlPrefix + 'middleware/wc-real-time-collaboration/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_41_2=g_navNode_1_41.addNode('otnen_wcrtcollab_docs','Documentation',ssUrlPrefix + 'middleware/wc-real-time-collaboration/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_41_3=g_navNode_1_41.addNode('otnen_wcrtcollab_community','Community',ssUrlPrefix + 'middleware/wc-real-time-collaboration/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_41_4=g_navNode_1_41.addNode('otnen_wcrtcollab_learnmore','Learn More',ssUrlPrefix + 'middleware/wc-real-time-collaboration/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_42=g_navNode_1.addNode('otnen_weblogicint','WebLogic Integration',ssUrlPrefix + 'middleware/weblogic-integration/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_42_0=g_navNode_1_42.addNode('otnen_weblogicint_overview','Overview',ssUrlPrefix + 'middleware/weblogic-integration/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_42_1=g_navNode_1_42.addNode('otnen_weblogicint_downloads','Downloads',ssUrlPrefix + 'middleware/weblogic-integration/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_42_2=g_navNode_1_42.addNode('otnen_weblogicint_docs','Documentation',ssUrlPrefix + 'middleware/weblogic-integration/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_42_3=g_navNode_1_42.addNode('otnen_weblogicint_community','Community',ssUrlPrefix + 'middleware/weblogic-integration/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_42_4=g_navNode_1_42.addNode('otnen_weblogicint_learnmore','Learn More',ssUrlPrefix + 'middleware/weblogic-integration/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_43=g_navNode_1.addNode('otnen_weblogicportal','WebLogic Portal',ssUrlPrefix + 'middleware/weblogic-portal/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_43_0=g_navNode_1_43.addNode('otnen_weblogicportal_overview','Overview',ssUrlPrefix + 'middleware/weblogic-portal/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_43_1=g_navNode_1_43.addNode('otnen_weblogicportal_downloads','Downloads',ssUrlPrefix + 'middleware/weblogic-portal/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_43_2=g_navNode_1_43.addNode('otnen_weblogicportal_docs','Documentation',ssUrlPrefix + 'middleware/weblogic-portal/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_43_3=g_navNode_1_43.addNode('otnen_weblogicportal_community','Community',ssUrlPrefix + 'middleware/weblogic-portal/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_43_4=g_navNode_1_43.addNode('otnen_weblogicportal_learnmore','Learn More',ssUrlPrefix + 'middleware/weblogic-portal/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_44=g_navNode_1.addNode('otnen_bam','Business Activity Monitoring',ssUrlPrefix + 'middleware/bam/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==http\x3a//www.oracle.com/technology/products/integration/bam/index.html');
g_navNode_1_44_0=g_navNode_1_44.addNode('otnen_bam_overview','Overview',ssUrlPrefix + 'middleware/bam/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_44_1=g_navNode_1_44.addNode('otnen_bam_downloads','Downloads',ssUrlPrefix + 'middleware/bam/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_44_2=g_navNode_1_44.addNode('otnen_bam_docs','Documentation',ssUrlPrefix + 'middleware/bam/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_44_3=g_navNode_1_44.addNode('otnen_bam_community','Community',ssUrlPrefix + 'middleware/bam/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_44_4=g_navNode_1_44.addNode('otnen_bam_learnmore','Learn More',ssUrlPrefix + 'middleware/bam/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_45=g_navNode_1.addNode('otnen_bipublisher','BI Publisher',ssUrlPrefix + 'middleware/bi-publisher/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_45_0=g_navNode_1_45.addNode('otnen_bipublisher_overview','Overview',ssUrlPrefix + 'middleware/bi-publisher/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_45_1=g_navNode_1_45.addNode('otnen_bipublisher_downloads','Downloads',ssUrlPrefix + 'middleware/bi-publisher/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_45_2=g_navNode_1_45.addNode('otnen_bipublisher_docs','Documentation',ssUrlPrefix + 'middleware/bi-publisher/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_45_3=g_navNode_1_45.addNode('otnen_bipublisher_community','Community',ssUrlPrefix + 'middleware/bi-publisher/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_45_4=g_navNode_1_45.addNode('otnen_bipublisher_learnmore','Learn More',ssUrlPrefix + 'middleware/bi-publisher/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_46=g_navNode_1.addNode('otnen_crystalball','Crystal Ball',ssUrlPrefix + 'middleware/crystalball/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_46_0=g_navNode_1_46.addNode('otnen_crystalball_overview','Overview',ssUrlPrefix + 'middleware/crystalball/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_46_1=g_navNode_1_46.addNode('otnen_crystalball_downloads','Downloads',ssUrlPrefix + 'middleware/crystalball/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_46_2=g_navNode_1_46.addNode('otnen_crystalball_docs','Documentation',ssUrlPrefix + 'middleware/crystalball/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_46_3=g_navNode_1_46.addNode('otnen_crystalball_community','Community',ssUrlPrefix + 'middleware/crystalball/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_46_4=g_navNode_1_46.addNode('otnen_crystalball_learnmore','Learn More',ssUrlPrefix + 'middleware/crystalball/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_47=g_navNode_1.addNode('otnen_epm','Enterprise Performance Management',ssUrlPrefix + 'middleware/epm/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_47_0=g_navNode_1_47.addNode('otnen_epm_overview','Overview',ssUrlPrefix + 'middleware/epm/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_47_1=g_navNode_1_47.addNode('otnen_epm_downloads','Downloads',ssUrlPrefix + 'middleware/epm/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_47_2=g_navNode_1_47.addNode('otnen_epm_docs','Documentation',ssUrlPrefix + 'middleware/epm/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_47_3=g_navNode_1_47.addNode('otnen_epm_community','Community',ssUrlPrefix + 'middleware/epm/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_47_4=g_navNode_1_47.addNode('otnen_epm_learnmore','Learn More',ssUrlPrefix + 'middleware/epm/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48=g_navNode_1.addNode('otnen_essbase','Essbase',ssUrlPrefix + 'middleware/essbase/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48_0=g_navNode_1_48.addNode('otnen_essbase_overview','Overview',ssUrlPrefix + 'middleware/essbase/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48_1=g_navNode_1_48.addNode('otnen_essbase_downloads','Downloads',ssUrlPrefix + 'middleware/essbase/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48_2=g_navNode_1_48.addNode('otnen_essbase_docs','Documentation',ssUrlPrefix + 'middleware/essbase/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48_3=g_navNode_1_48.addNode('otnen_essbase_tutorials','Tutorials',ssUrlPrefix + 'middleware/essbase/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48_4=g_navNode_1_48.addNode('otnen_essbase_community','Community',ssUrlPrefix + 'middleware/essbase/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_48_5=g_navNode_1_48.addNode('otnen_essbase_learnmore','Learn More',ssUrlPrefix + 'middleware/essbase/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_49=g_navNode_1.addNode('otnen_governance','SOA Governance',ssUrlPrefix + 'middleware/governance/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1_50=g_navNode_1.addNode('otnen_bibeans','Business Intelligence Beans',ssUrlPrefix + 'middleware/bbi-beans/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_50_0=g_navNode_1_50.addNode('otnen_bibeans_overview','Overview',ssUrlPrefix + 'middleware/bbi-beans/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_50_1=g_navNode_1_50.addNode('otnen_bibeans_downloads','Downloads',ssUrlPrefix + 'middleware/bbi-beans/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_50_2=g_navNode_1_50.addNode('otnen_bibeans_docs','Documentation',ssUrlPrefix + 'middleware/bbi-beans/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_50_3=g_navNode_1_50.addNode('otnen_bibeans_community','Community',ssUrlPrefix + 'middleware/bbi-beans/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_50_4=g_navNode_1_50.addNode('otnen_bibeans_learnmore','Learn More',ssUrlPrefix + 'middleware/bbi-beans/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_52=g_navNode_1.addNode('otnen_bpasuite','Business Process Analysis Suite',ssUrlPrefix + 'middleware/bpa/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_52_0=g_navNode_1_52.addNode('otnen_bpasuite_overview','Overview',ssUrlPrefix + 'middleware/bpa/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_52_1=g_navNode_1_52.addNode('otnen_bpasuite_downloads','Downloads',ssUrlPrefix + 'middleware/bpa/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_52_2=g_navNode_1_52.addNode('otnen_bpasuite_docs','Documentation',ssUrlPrefix + 'middleware/bpa/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_52_3=g_navNode_1_52.addNode('otnen_bpasuite_community','Community',ssUrlPrefix + 'middleware/bpa/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_52_4=g_navNode_1_52.addNode('otnen_bpasuite_learnmore','Learn More',ssUrlPrefix + 'middleware/bpa/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_53=g_navNode_1.addNode('otnen_adapters','Integration Adapters',ssUrlPrefix + 'middleware/adapters/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_53_0=g_navNode_1_53.addNode('otnen_adapters_overview','Overview',ssUrlPrefix + 'middleware/adapters/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_53_1=g_navNode_1_53.addNode('otnen_adapters_downloads','Downloads',ssUrlPrefix + 'middleware/adapters/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_53_2=g_navNode_1_53.addNode('otnen_adapters_docs','Documentation',ssUrlPrefix + 'middleware/adapters/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_53_3=g_navNode_1_53.addNode('otnen_adapters_community','Customers',ssUrlPrefix + 'middleware/adapters/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_53_4=g_navNode_1_53.addNode('otnen_adapters_learnmore','Learn More',ssUrlPrefix + 'middleware/adapters/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_56=g_navNode_1.addNode('otnen_mapviewer','MapViewer',ssUrlPrefix + 'middleware/mapviewer/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_56_0=g_navNode_1_56.addNode('otnen_mapviewer_overview','Overview',ssUrlPrefix + 'middleware/mapviewer/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_56_1=g_navNode_1_56.addNode('otnen_mapviewer_downloads','Downloads',ssUrlPrefix + 'middleware/mapviewer/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_56_2=g_navNode_1_56.addNode('otnen_mapviewer_docs','Documentation',ssUrlPrefix + 'middleware/mapviewer/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_56_3=g_navNode_1_56.addNode('otnen_mapviewer_community','Community',ssUrlPrefix + 'middleware/mapviewer/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_56_4=g_navNode_1_56.addNode('otnen_mapviewer_learnmore','Learn More',ssUrlPrefix + 'middleware/mapviewer/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57=g_navNode_1.addNode('otnen_perfmgmt','Performance Management',ssUrlPrefix + 'middleware/performance-management/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57_0=g_navNode_1_57.addNode('otnen_perfmgmt_overview','Overview',ssUrlPrefix + 'middleware/performance-management/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57_1=g_navNode_1_57.addNode('otnen_perfmgmt_downloads','Downloads',ssUrlPrefix + 'middleware/performance-management/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57_2=g_navNode_1_57.addNode('otnen_perfmgmt_docs','Documentation',ssUrlPrefix + 'middleware/performance-management/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57_3=g_navNode_1_57.addNode('otnen_perfmgmt_tutorials','Tutorials',ssUrlPrefix + 'middleware/performance-management/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57_4=g_navNode_1_57.addNode('otnen_perfmgmt_community','Community',ssUrlPrefix + 'middleware/performance-management/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_57_5=g_navNode_1_57.addNode('otnen_perfmgmt_learnmore','Learn More',ssUrlPrefix + 'middleware/performance-management/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_58=g_navNode_1.addNode('otnen_perfscorecard','Performance Scorecard',ssUrlPrefix + 'middleware/performance-scorecard/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_58_0=g_navNode_1_58.addNode('otnen_perfscorecard_overview','Overview',ssUrlPrefix + 'middleware/performance-scorecard/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_58_1=g_navNode_1_58.addNode('otnen_perfscorecard_downloads','Downloads',ssUrlPrefix + 'middleware/performance-scorecard/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_58_2=g_navNode_1_58.addNode('otnen_perfscorecard_docs','Documentation',ssUrlPrefix + 'middleware/performance-scorecard/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_58_3=g_navNode_1_58.addNode('otnen_perfscorecard_community','Community',ssUrlPrefix + 'middleware/performance-scorecard/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_58_4=g_navNode_1_58.addNode('otnen_perfscorecard_learnmore','Learn More',ssUrlPrefix + 'middleware/performance-scorecard/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59=g_navNode_1.addNode('otnen_workforceplan','Workforce Planning',ssUrlPrefix + 'middleware/workforce-planning/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59_0=g_navNode_1_59.addNode('otnen_workforceplan_overview','Overview',ssUrlPrefix + 'middleware/workforce-planning/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59_1=g_navNode_1_59.addNode('otnen_workforceplan_downloads','Downloads',ssUrlPrefix + 'middleware/workforce-planning/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59_2=g_navNode_1_59.addNode('otnen_workforceplan_docs','Documentation',ssUrlPrefix + 'middleware/workforce-planning/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59_3=g_navNode_1_59.addNode('otnen_workforceplan_tutorials','Tutorials',ssUrlPrefix + 'middleware/workforce-planning/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59_4=g_navNode_1_59.addNode('otnen_workforceplan_community','Community',ssUrlPrefix + 'middleware/workforce-planning/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_59_5=g_navNode_1_59.addNode('otnen_workforceplan_learnmore','Learn More',ssUrlPrefix + 'middleware/workforce-planning/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60=g_navNode_1.addNode('otnen_financemgmt','Financial Management',ssUrlPrefix + 'middleware/financial-management/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60_0=g_navNode_1_60.addNode('otnen_financemgmt_overview','Overview',ssUrlPrefix + 'middleware/financial-management/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60_1=g_navNode_1_60.addNode('otnen_financemgmt_downloads','Downloads',ssUrlPrefix + 'middleware/financial-management/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60_2=g_navNode_1_60.addNode('otnen_financemgmt_docs','Documentation',ssUrlPrefix + 'middleware/financial-management/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60_3=g_navNode_1_60.addNode('otnen_financemgmt_tutorials','Tutorials',ssUrlPrefix + 'middleware/financial-management/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60_4=g_navNode_1_60.addNode('otnen_financemgmt_community','Community',ssUrlPrefix + 'middleware/financial-management/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_60_5=g_navNode_1_60.addNode('otnen_financemgmt_learnmore','Learn More',ssUrlPrefix + 'middleware/financial-management/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_61=g_navNode_1.addNode('otnen_closemgmt','Financial Close Management',ssUrlPrefix + 'middleware/close-management/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_1_62=g_navNode_1.addNode('otnen_stratfinance','Strategic Finance',ssUrlPrefix + 'middleware/strategic-finance/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_62_0=g_navNode_1_62.addNode('otnen_stratfinance_overview','Overview',ssUrlPrefix + 'middleware/strategic-finance/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_62_1=g_navNode_1_62.addNode('otnen_stratfinance_downloads','Downloads',ssUrlPrefix + 'middleware/strategic-finance/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_62_2=g_navNode_1_62.addNode('otnen_stratfinance_docs','Documentation',ssUrlPrefix + 'middleware/strategic-finance/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_62_3=g_navNode_1_62.addNode('otnen_stratfinance_community','Community',ssUrlPrefix + 'middleware/strategic-finance/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_62_4=g_navNode_1_62.addNode('otnen_stratfinance_learnmore','Learn More',ssUrlPrefix + 'middleware/strategic-finance/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_63=g_navNode_1.addNode('otnen_profitcostmgmt','Profitability and Cost Management',ssUrlPrefix + 'middleware/profit-cost-management/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_63_0=g_navNode_1_63.addNode('otnen_profitcostmgmt_overview','Overview',ssUrlPrefix + 'middleware/profit-cost-management/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_63_1=g_navNode_1_63.addNode('otnen_profitcostmgmt_downloads','Downloads',ssUrlPrefix + 'middleware/profit-cost-management/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_63_2=g_navNode_1_63.addNode('otnen_profitcostmgmt_docs','Documentation',ssUrlPrefix + 'middleware/profit-cost-management/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_63_3=g_navNode_1_63.addNode('otnen_profitcostmgmt_community','Community',ssUrlPrefix + 'middleware/profit-cost-management/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_63_4=g_navNode_1_63.addNode('otnen_profitcostmgmt_learnmore','Learn More',ssUrlPrefix + 'middleware/profit-cost-management/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64=g_navNode_1.addNode('otnen_planning','Hyperion Planning',ssUrlPrefix + 'middleware/planning/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64_0=g_navNode_1_64.addNode('otnen_planning_overview','Overview',ssUrlPrefix + 'middleware/planning/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64_1=g_navNode_1_64.addNode('otnen_planning_downloads','Downloads',ssUrlPrefix + 'middleware/planning/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64_2=g_navNode_1_64.addNode('otnen_planning_docs','Documentation',ssUrlPrefix + 'middleware/planning/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64_3=g_navNode_1_64.addNode('otnen_planning_tutorials','Tutorials',ssUrlPrefix + 'middleware/planning/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64_4=g_navNode_1_64.addNode('otnen_planning_community','Community',ssUrlPrefix + 'middleware/planning/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_64_5=g_navNode_1_64.addNode('otnen_planning_learnmore','Learn More',ssUrlPrefix + 'middleware/planning/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_66=g_navNode_1.addNode('otnen_bientedition','Business Intelligence Enterprise Edition',ssUrlPrefix + 'middleware/bi-enterprise-edition/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_66_0=g_navNode_1_66.addNode('otnen_bientedition_overview','Overview',ssUrlPrefix + 'middleware/bi-enterprise-edition/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_66_1=g_navNode_1_66.addNode('otnen_bientedition_downloads','Downloads',ssUrlPrefix + 'middleware/bi-enterprise-edition/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_66_2=g_navNode_1_66.addNode('otnen_bientedition_docs','Documentation',ssUrlPrefix + 'middleware/bi-enterprise-edition/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_66_3=g_navNode_1_66.addNode('otnen_bientedition_tutorials','Tutorials',ssUrlPrefix + 'middleware/bi-enterprise-edition/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_67=g_navNode_1.addNode('otnen_stanedition','Business Intelligence Standard Edition',ssUrlPrefix + 'middleware/bi-standard-edition/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_67_0=g_navNode_1_67.addNode('otnen_stanedition_overview','Overview',ssUrlPrefix + 'middleware/bi-standard-edition/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_67_1=g_navNode_1_67.addNode('otnen_stanedition_downloads','Downloads',ssUrlPrefix + 'middleware/bi-standard-edition/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_67_2=g_navNode_1_67.addNode('otnen_stanedition_docs','Documentation',ssUrlPrefix + 'middleware/bi-standard-edition/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_68=g_navNode_1.addNode('otnen_realtimedec','Real-Time Decisions',ssUrlPrefix + 'middleware/real-time-decisions/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_68_0=g_navNode_1_68.addNode('otnen_realtimedec_overview','Overview',ssUrlPrefix + 'middleware/real-time-decisions/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_68_1=g_navNode_1_68.addNode('otnen_realtimedec_downloads','Downloads',ssUrlPrefix + 'middleware/real-time-decisions/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_68_2=g_navNode_1_68.addNode('otnen_realtimedec_docs','Documentation',ssUrlPrefix + 'middleware/real-time-decisions/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_68_3=g_navNode_1_68.addNode('otnen_realtimedec_tutorials','Tutorials',ssUrlPrefix + 'middleware/real-time-decisions/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_68_4=g_navNode_1_68.addNode('otnen_realtimedec_community','Community',ssUrlPrefix + 'middleware/real-time-decisions/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_69=g_navNode_1.addNode('otnen_smartview','Hyperion Smart View for Office',ssUrlPrefix + 'middleware/smart-view-for-office/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_69_0=g_navNode_1_69.addNode('otnen_smartview_overview','Overview',ssUrlPrefix + 'middleware/smart-view-for-office/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_69_1=g_navNode_1_69.addNode('otnen_smartview_downloads','Downloads',ssUrlPrefix + 'middleware/smart-view-for-office/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_69_2=g_navNode_1_69.addNode('otnen_smartview_docs','Documentation',ssUrlPrefix + 'middleware/smart-view-for-office/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_69_3=g_navNode_1_69.addNode('otnen_smartview_tutorials','Tutorials',ssUrlPrefix + 'middleware/smart-view-for-office/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_70=g_navNode_1.addNode('otnen_smartspace','Smart Space',ssUrlPrefix + 'middleware/smart-space/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_70_0=g_navNode_1_70.addNode('otnen_smartspace_overview','Overview',ssUrlPrefix + 'middleware/smart-space/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_70_1=g_navNode_1_70.addNode('otnen_smartspace_downloads','Downloads',ssUrlPrefix + 'middleware/smart-space/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_70_2=g_navNode_1_70.addNode('otnen_smartspace_docs','Documentation',ssUrlPrefix + 'middleware/smart-space/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_71=g_navNode_1.addNode('otnen_intreporting','Interactive Reporting',ssUrlPrefix + 'middleware/interactive-reporting/index.html');
g_navNode_1_71_0=g_navNode_1_71.addNode('otnen_intreporting_overview','Overview',ssUrlPrefix + 'middleware/interactive-reporting/overview/index.html');
g_navNode_1_71_1=g_navNode_1_71.addNode('otnen_intreporting_downloads','Downloads',ssUrlPrefix + 'middleware/interactive-reporting/downloads/index.html');
g_navNode_1_71_2=g_navNode_1_71.addNode('otnen_intreporting_docs','Documentation',ssUrlPrefix + 'middleware/interactive-reporting/documenation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_71_3=g_navNode_1_71.addNode('otnen_intreporting_tutorials','Tutorials',ssUrlPrefix + 'middleware/interactive-reporting/tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_71_4=g_navNode_1_71.addNode('otnen_intreporting_community','Community',ssUrlPrefix + 'middleware/interactive-reporting/community/index.html');
g_navNode_1_71_5=g_navNode_1_71.addNode('otnen_intreporting_learnmore','Learn More',ssUrlPrefix + 'middleware/interactive-reporting/learnmore/index.html');
g_navNode_1_72=g_navNode_1.addNode('otnen_b2bintegration','Business-to-Business Integrations',ssUrlPrefix + 'middleware/b2b-integrations/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==http\x3a//www.oracle.com/technology/products/soa/b2b/index.html');
g_navNode_1_72_0=g_navNode_1_72.addNode('otnen_b2bintegrations_overview','Overview',ssUrlPrefix + 'middleware/b2b-integrations/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_72_1=g_navNode_1_72.addNode('otnen_b2bintegrations_download','Downloads',ssUrlPrefix + 'middleware/b2b-integrations/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_72_2=g_navNode_1_72.addNode('otnen_b2bintegrations_docs','Documentation',ssUrlPrefix + 'middleware/b2b-integrations/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_72_3=g_navNode_1_72.addNode('otnen_b2bintegrations_comm','Community',ssUrlPrefix + 'middleware/b2b-integrations/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_72_4=g_navNode_1_72.addNode('otnen_b2bintegrations_learnmor','Learn More',ssUrlPrefix + 'middleware/b2b-integrations/learnmore/index.html');
g_navNode_1_73=g_navNode_1.addNode('otnen_upk','User Productivity Kit',ssUrlPrefix + 'middleware/upk/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_73_0=g_navNode_1_73.addNode('otnen_upk_overview','Overview',ssUrlPrefix + 'middleware/upk/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_73_1=g_navNode_1_73.addNode('otnen_upk_downloads','Downloads',ssUrlPrefix + 'middleware/upk/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_73_2=g_navNode_1_73.addNode('otnen_upk_docs','Documentation',ssUrlPrefix + 'middleware/upk/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_73_3=g_navNode_1_73.addNode('otnen_upk_community','Community',ssUrlPrefix + 'middleware/upk/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_73_4=g_navNode_1_73.addNode('otnen_upk_learnmore','Learn More',ssUrlPrefix + 'middleware/upk/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_74=g_navNode_1.addNode('otnen_servicebusfs','Service Bus for Financial Services',ssUrlPrefix + 'middleware/service-bus-fs/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_74_0=g_navNode_1_74.addNode('otnen_servicebusfs_overview','Overview',ssUrlPrefix + 'middleware/service-bus-fs/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_74_1=g_navNode_1_74.addNode('otnen_servicebusfs_downloads','Downloads',ssUrlPrefix + 'middleware/service-bus-fs/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_74_2=g_navNode_1_74.addNode('otnen_servicebusfs_docs','Documentation',ssUrlPrefix + 'middleware/service-bus-fs/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_74_3=g_navNode_1_74.addNode('otnen_servicebusfs_community','Customers',ssUrlPrefix + 'middleware/service-bus-fs/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_74_4=g_navNode_1_74.addNode('otnen_servicebusfs_learnmore','Learn More',ssUrlPrefix + 'middleware/service-bus-fs/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_75=g_navNode_1.addNode('otnen_businessrules','Business Rules',ssUrlPrefix + 'middleware/business-rules/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_75_0=g_navNode_1_75.addNode('otnen_businessrules_overview','Overview',ssUrlPrefix + 'middleware/business-rules/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_75_1=g_navNode_1_75.addNode('otnen_businessrules_downloads','Downloads',ssUrlPrefix + 'middleware/business-rules/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_75_2=g_navNode_1_75.addNode('otnen_businessrules_docs','Documentation',ssUrlPrefix + 'middleware/business-rules/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_75_3=g_navNode_1_75.addNode('otnen_businessrules_community','Community',ssUrlPrefix + 'middleware/business-rules/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_75_4=g_navNode_1_75.addNode('otnen_businessrules_learnmore','Learn More',ssUrlPrefix + 'middleware/business-rules/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_76=g_navNode_1.addNode('otnen_humanworkflow','Human Workflow',ssUrlPrefix + 'middleware/human-workflow/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_76_0=g_navNode_1_76.addNode('otnen_humanworkflow_overview','Overview',ssUrlPrefix + 'middleware/human-workflow/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_76_1=g_navNode_1_76.addNode('otnen_humanworkflow_downloads','Downloads',ssUrlPrefix + 'middleware/human-workflow/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_76_2=g_navNode_1_76.addNode('otnen_humanworkflow_docs','Documentation',ssUrlPrefix + 'middleware/human-workflow/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_76_3=g_navNode_1_76.addNode('otnen_humanworkflow_community','Community',ssUrlPrefix + 'middleware/human-workflow/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_76_4=g_navNode_1_76.addNode('otnen_humanworkflow_learnmore','Learn More',ssUrlPrefix + 'middleware/human-workflow/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_77=g_navNode_1.addNode('otnen_dataservint','Data Service Integrator',ssUrlPrefix + 'middleware/data-service-integrator/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_77_0=g_navNode_1_77.addNode('otnen_dataservint_overview','Overview',ssUrlPrefix + 'middleware/data-service-integrator/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_77_1=g_navNode_1_77.addNode('otnen_dataservint_downloads','Downloads',ssUrlPrefix + 'middleware/data-service-integrator/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_77_2=g_navNode_1_77.addNode('otnen_dataservint_docs','Documentation',ssUrlPrefix + 'middleware/data-service-integrator/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_77_3=g_navNode_1_77.addNode('otnen_dataservint_community','Community',ssUrlPrefix + 'middleware/data-service-integrator/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_77_4=g_navNode_1_77.addNode('otnen_dataservint_learnmore','Learn More',ssUrlPrefix + 'middleware/data-service-integrator/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_78=g_navNode_1.addNode('otnen_dataintegrator','Data Integrator',ssUrlPrefix + 'middleware/data-integrator/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_78_0=g_navNode_1_78.addNode('otnen_dataintegrator_overview','Overview',ssUrlPrefix + 'middleware/data-integrator/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_78_1=g_navNode_1_78.addNode('otnen_dataintegrator_downloads','Downloads',ssUrlPrefix + 'middleware/data-integrator/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_78_2=g_navNode_1_78.addNode('otnen_dataintegrator_docs','Documentation',ssUrlPrefix + 'middleware/data-integrator/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_78_3=g_navNode_1_78.addNode('otnen_dataintegrator_community','Community',ssUrlPrefix + 'middleware/data-integrator/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_78_4=g_navNode_1_78.addNode('otnen_dataintegrator_learnmore','Learn More',ssUrlPrefix + 'middleware/data-integrator/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_79=g_navNode_1.addNode('otnen_goldengate','GoldenGate',ssUrlPrefix + 'middleware/goldengate/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_79_0=g_navNode_1_79.addNode('otnen_goldengate_overview','Overview',ssUrlPrefix + 'middleware/goldengate/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_79_1=g_navNode_1_79.addNode('otnen_goldengate_downloads','Downloads',ssUrlPrefix + 'middleware/goldengate/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_79_2=g_navNode_1_79.addNode('otnen_goldengate_docs','Documentation',ssUrlPrefix + 'middleware/goldengate/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_79_3=g_navNode_1_79.addNode('otnen_goldengate_community','Community',ssUrlPrefix + 'middleware/goldengate/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_79_4=g_navNode_1_79.addNode('otnen_goldengate_learnmore','Learn More',ssUrlPrefix + 'middleware/goldengate/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_80=g_navNode_1.addNode('otnen_collabsuite','Collaboration Suite',ssUrlPrefix + 'middleware/collaboration-suite/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_80_0=g_navNode_1_80.addNode('otnen_collabsuite_overview','Overview',ssUrlPrefix + 'middleware/collaboration-suite/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_80_1=g_navNode_1_80.addNode('otnen_collabsuite_docs','Documentation',ssUrlPrefix + 'middleware/collaboration-suite/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_80_2=g_navNode_1_80.addNode('otnen_collabsuite_community','Community',ssUrlPrefix + 'middleware/collaboration-suite/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_80_3=g_navNode_1_80.addNode('otnen_collabsuite_learnmore','Learn More',ssUrlPrefix + 'middleware/collaboration-suite/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81=g_navNode_1.addNode('otnen_fmw4apps','Oracle Fusion Middleware for Apps',ssUrlPrefix + 'middleware/fmw4apps/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81_0=g_navNode_1_81.addNode('otnen_fmw4apps_ebs','E-Business Suite',ssUrlPrefix + 'middleware/fmw4apps/ebs/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81_1=g_navNode_1_81.addNode('otnen_fmw4apps_siebel','Siebel',ssUrlPrefix + 'middleware/fmw4apps/siebel/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81_2=g_navNode_1_81.addNode('otnen_fmw4apps_peoplesoft','PeopleSoft',ssUrlPrefix + 'middleware/fmw4apps/peoplesoft/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81_3=g_navNode_1_81.addNode('otnen_fmw4apps_jde','JD Edwards',ssUrlPrefix + 'middleware/fmw4apps/jde/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81_4=g_navNode_1_81.addNode('otnen_fmw4apps_agile','Agile',ssUrlPrefix + 'middleware/fmw4apps/agile/index.html','secondaryUrlVariableField==MainContent');
g_navNode_1_81_5=g_navNode_1_81.addNode('otnen_fmw4apps_events','Events',ssUrlPrefix + 'middleware/fmw4apps/events/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2=g_navNode_Root.addNode('otnen_developertools','Developer Tools',ssUrlPrefix + 'developer-tools/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_0=g_navNode_2.addNode('otnen_devtools_downloads','Downloads',ssUrlPrefix + 'developer-tools/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_1=g_navNode_2.addNode('otnen_devtools_docs','Documentation',ssUrlPrefix + 'developer-tools/docs/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_2=g_navNode_2.addNode('otnen_jdev','JDeveloper',ssUrlPrefix + 'developer-tools/jdev/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_2_0=g_navNode_2_2.addNode('otnen_jdev_overview','Overview',ssUrlPrefix + 'developer-tools/jdev/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_2_1=g_navNode_2_2.addNode('otnen_jdev_downloads','Downloads',ssUrlPrefix + 'developer-tools/jdev/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_2_2=g_navNode_2_2.addNode('otnen_jdev_docs','Documentation',ssUrlPrefix + 'developer-tools/jdev/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_2_3=g_navNode_2_2.addNode('otnen_jdev_community','Community',ssUrlPrefix + 'developer-tools/jdev/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_2_4=g_navNode_2_2.addNode('otnen_jdev_learnmore','Learn More',ssUrlPrefix + 'developer-tools/jdev/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_3=g_navNode_2.addNode('otnen_sqldeveloper','SQL Developer',ssUrlPrefix + 'developer-tools/sql-developer/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_3_0=g_navNode_2_3.addNode('otnen_sqldeveloper_overview','Overview',ssUrlPrefix + 'developer-tools/sql-developer/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_3_1=g_navNode_2_3.addNode('otnen_sqldeveloper_downloads','Downloads',ssUrlPrefix + 'developer-tools/sql-developer/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_3_2=g_navNode_2_3.addNode('otnen_sqldeveloper_docs','Documentation',ssUrlPrefix + 'developer-tools/sql-developer/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_3_3=g_navNode_2_3.addNode('otnen_sqldeveloper_community','Community',ssUrlPrefix + 'developer-tools/sql-developer/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_3_4=g_navNode_2_3.addNode('otnen_sqldeveloper_learnmore','Learn More',ssUrlPrefix + 'developer-tools/sql-developer/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_4=g_navNode_2.addNode('otnen_adf','Application Development Framework',ssUrlPrefix + 'developer-tools/adf/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_4_0=g_navNode_2_4.addNode('otnen_adf_overview','Overview',ssUrlPrefix + 'developer-tools/adf/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_4_1=g_navNode_2_4.addNode('otnen_adf_downloads','Downloads',ssUrlPrefix + 'developer-tools/adf/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_4_2=g_navNode_2_4.addNode('otnen_adf_docs','Documentation',ssUrlPrefix + 'developer-tools/adf/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_4_3=g_navNode_2_4.addNode('otnen_adf_community','Community',ssUrlPrefix + 'developer-tools/adf/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_4_4=g_navNode_2_4.addNode('otnen_adf_learnmore','Learn More',ssUrlPrefix + 'developer-tools/adf/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_5=g_navNode_2.addNode('otnen_apex','Application Express',ssUrlPrefix + 'developer-tools/apex/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_5_0=g_navNode_2_5.addNode('otnen_apex_overview','Overview',ssUrlPrefix + 'developer-tools/apex/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_5_1=g_navNode_2_5.addNode('otnen_apex_downloads','Downloads',ssUrlPrefix + 'developer-tools/apex/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_5_2=g_navNode_2_5.addNode('otnen_apex_docs','Documentation',ssUrlPrefix + 'developer-tools/apex/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_5_3=g_navNode_2_5.addNode('otnen_apex_community','Community',ssUrlPrefix + 'developer-tools/apex/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_5_4=g_navNode_2_5.addNode('otnen_apex_learnmore','Learn More',ssUrlPrefix + 'developer-tools/apex/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_6=g_navNode_2.addNode('otnen_apexlistener','APEX Listener',ssUrlPrefix + 'developer-tools/apex-listener/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_6_0=g_navNode_2_6.addNode('otnen_apexlistener_overview','Overview',ssUrlPrefix + 'developer-tools/apex-listener/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_6_1=g_navNode_2_6.addNode('otnen_apexlistener_downloads','Downloads',ssUrlPrefix + 'developer-tools/apex-listener/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_6_2=g_navNode_2_6.addNode('otnen_apexlistener_docs','Documentation',ssUrlPrefix + 'developer-tools/apex-listener/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_6_3=g_navNode_2_6.addNode('otnen_apexlistener_community','Community',ssUrlPrefix + 'developer-tools/apex-listener/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_6_4=g_navNode_2_6.addNode('otnen_apexlistener_learnmore','Learn More',ssUrlPrefix + 'developer-tools/apex-listener/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_7=g_navNode_2.addNode('otnen_devsuite','Developer Suite',ssUrlPrefix + 'developer-tools/developer-suite/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_7_0=g_navNode_2_7.addNode('otnen_devsuite_overview','Overview',ssUrlPrefix + 'developer-tools/developer-suite/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_7_1=g_navNode_2_7.addNode('otnen_devsuite_downloads','Downloads',ssUrlPrefix + 'developer-tools/developer-suite/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_7_2=g_navNode_2_7.addNode('otnen_devsuite_docs','Documentation',ssUrlPrefix + 'developer-tools/developer-suite/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_7_3=g_navNode_2_7.addNode('otnen_devsuite_community','Community',ssUrlPrefix + 'developer-tools/developer-suite/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_7_4=g_navNode_2_7.addNode('otnen_devsuite_learnmore','Learn More',ssUrlPrefix + 'developer-tools/developer-suite/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_8=g_navNode_2.addNode('otnen_visualstudio','Developer Tools for Visual Studio',ssUrlPrefix + 'developer-tools/visual-studio/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_8_0=g_navNode_2_8.addNode('otnen_visualstudio_overview','Overview',ssUrlPrefix + 'developer-tools/visual-studio/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_8_1=g_navNode_2_8.addNode('otnen_visualstudio_downloads','Downloads',ssUrlPrefix + 'developer-tools/visual-studio/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_8_2=g_navNode_2_8.addNode('otnen_visualstudio_docs','Documentation',ssUrlPrefix + 'developer-tools/visual-studio/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_8_3=g_navNode_2_8.addNode('otnen_visualstudio_community','Community',ssUrlPrefix + 'developer-tools/visual-studio/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_8_4=g_navNode_2_8.addNode('otnen_visualstudio_learnmore','Learn More',ssUrlPrefix + 'developer-tools/visual-studio/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_9=g_navNode_2.addNode('otnen_discoverer','Discoverer',ssUrlPrefix + 'developer-tools/discoverer/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_9_0=g_navNode_2_9.addNode('otnen_discoverer_overview','Overview',ssUrlPrefix + 'developer-tools/discoverer/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_9_1=g_navNode_2_9.addNode('otnen_discoverer_downloads','Downloads',ssUrlPrefix + 'developer-tools/discoverer/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_9_2=g_navNode_2_9.addNode('otnen_discoverer_docs','Documentation',ssUrlPrefix + 'developer-tools/discoverer/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_9_3=g_navNode_2_9.addNode('otnen_discoverer_community','Community',ssUrlPrefix + 'developer-tools/discoverer/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_9_4=g_navNode_2_9.addNode('otnen_discoverer_learnmore','Learn More',ssUrlPrefix + 'developer-tools/discoverer/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_10=g_navNode_2.addNode('otnen_epeclipse','Enterprise Pack for Eclipse',ssUrlPrefix + 'developer-tools/eclipse/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_10_0=g_navNode_2_10.addNode('otnen_epeclipse_overview','Overview',ssUrlPrefix + 'developer-tools/eclipse/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_10_1=g_navNode_2_10.addNode('otnen_epeclipse_downloads','Downloads',ssUrlPrefix + 'developer-tools/eclipse/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_10_2=g_navNode_2_10.addNode('otnen_epeclipse_docs','Documentation',ssUrlPrefix + 'developer-tools/eclipse/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_10_3=g_navNode_2_10.addNode('otnen_epeclipse_community','Community',ssUrlPrefix + 'developer-tools/eclipse/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_10_4=g_navNode_2_10.addNode('otnen_epeclipse_learnmore','Learn More',ssUrlPrefix + 'developer-tools/eclipse/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_11=g_navNode_2.addNode('otnen_jheadstart','JHeadstart',ssUrlPrefix + 'developer-tools/jheadstart/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_11_0=g_navNode_2_11.addNode('otnen_jheadstart_overview','Overview',ssUrlPrefix + 'developer-tools/jheadstart/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_11_1=g_navNode_2_11.addNode('otnen_jheadstart_downloads','Downloads',ssUrlPrefix + 'developer-tools/jheadstart/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_11_2=g_navNode_2_11.addNode('otnen_jheadstart_docs','Documentation',ssUrlPrefix + 'developer-tools/jheadstart/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_11_3=g_navNode_2_11.addNode('otnen_jheadstart_community','Community',ssUrlPrefix + 'developer-tools/jheadstart/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_11_4=g_navNode_2_11.addNode('otnen_jheadstart_learnmore','Learn More',ssUrlPrefix + 'developer-tools/jheadstart/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_12=g_navNode_2.addNode('otnen_datamodeler','SQL Developer Data Modeler',ssUrlPrefix + 'developer-tools/datamodeler/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_12_0=g_navNode_2_12.addNode('otnen_datamodeler_overview','Overview',ssUrlPrefix + 'developer-tools/datamodeler/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_12_1=g_navNode_2_12.addNode('otnen_datamodeler_downloads','Downloads',ssUrlPrefix + 'developer-tools/datamodeler/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_12_2=g_navNode_2_12.addNode('otnen_datamodeler_docs','Documentation',ssUrlPrefix + 'developer-tools/datamodeler/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_12_3=g_navNode_2_12.addNode('otnen_datamodeler_community','Community',ssUrlPrefix + 'developer-tools/datamodeler/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_12_4=g_navNode_2_12.addNode('otnen_datamodeler_learnmore','Learn More',ssUrlPrefix + 'developer-tools/datamodeler/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_13=g_navNode_2.addNode('otnen_warehouse','Warehouse Builder',ssUrlPrefix + 'developer-tools/warehouse/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_13_0=g_navNode_2_13.addNode('otnen_warehouse_overview','Overview',ssUrlPrefix + 'developer-tools/warehouse/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_13_1=g_navNode_2_13.addNode('otnen_warehouse_downloads','Downloads',ssUrlPrefix + 'developer-tools/warehouse/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_13_2=g_navNode_2_13.addNode('otnen_warehouse_docs','Documentation',ssUrlPrefix + 'developer-tools/warehouse/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_13_3=g_navNode_2_13.addNode('otnen_warehouse_community','Community',ssUrlPrefix + 'developer-tools/warehouse/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_13_4=g_navNode_2_13.addNode('otnen_warehouse_learnmore','Learn More',ssUrlPrefix + 'developer-tools/warehouse/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_14=g_navNode_2.addNode('otnen_workshop','Workshop for WebLogic',ssUrlPrefix + 'developer-tools/workshop/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_14_0=g_navNode_2_14.addNode('otnen_workshop_overview','Overview',ssUrlPrefix + 'developer-tools/workshop/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_14_1=g_navNode_2_14.addNode('otnen_workshop_downloads','Downloads',ssUrlPrefix + 'developer-tools/workshop/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_14_2=g_navNode_2_14.addNode('otnen_workshop_docs','Documentation',ssUrlPrefix + 'developer-tools/workshop/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_14_3=g_navNode_2_14.addNode('otnen_workshop_community','Community',ssUrlPrefix + 'developer-tools/workshop/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_14_4=g_navNode_2_14.addNode('otnen_workshop_learnmore','Learn More',ssUrlPrefix + 'developer-tools/workshop/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_15=g_navNode_2.addNode('otnen_xmldevkit','XML Developer\'s Kit',ssUrlPrefix + 'developer-tools/xmldevkit/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_2_16=g_navNode_2.addNode('otnen_zend','Zend Server',ssUrlPrefix + 'developer-tools/zend/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_2_17=g_navNode_2.addNode('otnen_designer','Designer',ssUrlPrefix + 'developer-tools/designer/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_17_0=g_navNode_2_17.addNode('otnen_designer_overview','Overview',ssUrlPrefix + 'developer-tools/designer/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_17_1=g_navNode_2_17.addNode('otnen_designer_downloads','Downloads',ssUrlPrefix + 'developer-tools/designer/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_17_2=g_navNode_2_17.addNode('otnen_designer_docs','Documentation',ssUrlPrefix + 'developer-tools/designer/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_17_3=g_navNode_2_17.addNode('otnen_designer_community','Community',ssUrlPrefix + 'developer-tools/designer/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_17_4=g_navNode_2_17.addNode('otnen_designer_learnmore','Learn More',ssUrlPrefix + 'developer-tools/designer/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_18=g_navNode_2.addNode('otnen_forms','Forms',ssUrlPrefix + 'developer-tools/forms/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_18_0=g_navNode_2_18.addNode('otnen_forms_overview','Overview',ssUrlPrefix + 'developer-tools/forms/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_18_1=g_navNode_2_18.addNode('otnen_forms_downloads','Downloads',ssUrlPrefix + 'developer-tools/forms/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_18_2=g_navNode_2_18.addNode('otnen_forms_docs','Documentation',ssUrlPrefix + 'developer-tools/forms/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_18_3=g_navNode_2_18.addNode('otnen_forms_community','Community',ssUrlPrefix + 'developer-tools/forms/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_18_4=g_navNode_2_18.addNode('otnen_forms_learnmore','Learn More',ssUrlPrefix + 'developer-tools/forms/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_19=g_navNode_2.addNode('otnen_teamprodcenter','Team Productivity Center',ssUrlPrefix + 'developer-tools/tpc/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_19_0=g_navNode_2_19.addNode('otnen_teamprodcenter_overview','Overview',ssUrlPrefix + 'developer-tools/tpc/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_19_1=g_navNode_2_19.addNode('otnen_teamprodcenter_downloads','Downloads',ssUrlPrefix + 'developer-tools/tpc/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_19_2=g_navNode_2_19.addNode('otnen_teamprodcenter_docs','Documentation',ssUrlPrefix + 'developer-tools/tpc/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_19_3=g_navNode_2_19.addNode('otnen_teamprodcenter_community','Community',ssUrlPrefix + 'developer-tools/tpc/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_19_4=g_navNode_2_19.addNode('otnen_teamprodcenter_learnmore','Learn More',ssUrlPrefix + 'developer-tools/tpc/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_20=g_navNode_2.addNode('otnen_devsuitescm','Developer Suite SCM',ssUrlPrefix + 'developer-tools/scm/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_20_0=g_navNode_2_20.addNode('otnen_devsuitescm_overview','Overview',ssUrlPrefix + 'developer-tools/scm/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_20_1=g_navNode_2_20.addNode('otnen_devsuitescm_downloads','Downloads',ssUrlPrefix + 'developer-tools/scm/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_20_2=g_navNode_2_20.addNode('otnen_devsuitescm_docs','Documentation',ssUrlPrefix + 'developer-tools/scm/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_20_3=g_navNode_2_20.addNode('otnen_devsuitescm_community','Community',ssUrlPrefix + 'developer-tools/scm/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_2_20_4=g_navNode_2_20.addNode('otnen_devsuitescm_learnmore','Learn More',ssUrlPrefix + 'developer-tools/scm/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3=g_navNode_Root.addNode('otnen_oem','Enterprise Management',ssUrlPrefix + 'oem/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==/technetwork/oem/grid-control/overview/index.html');
g_navNode_3_0=g_navNode_3.addNode('otnen_oem_downloads','Downloads',ssUrlPrefix + 'oem/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_1=g_navNode_3.addNode('otnen_emgridcontrol','Enterprise Manager Grid Control',ssUrlPrefix + 'oem/grid-control/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_1_0=g_navNode_3_1.addNode('otnen_emgridcontrol_overview','Overview',ssUrlPrefix + 'oem/grid-control/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_1_1=g_navNode_3_1.addNode('otnen_emgridcontrol_downloads','Downloads',ssUrlPrefix + 'oem/grid-control/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_1_2=g_navNode_3_1.addNode('otnen_emgridcontrol_docs','Documentation',ssUrlPrefix + 'oem/grid-control/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_1_3=g_navNode_3_1.addNode('otnen_emgridcontrol_community','Community',ssUrlPrefix + 'oem/grid-control/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_2=g_navNode_3.addNode('otnen_emopscenter','Enterprise Manager Ops Center',ssUrlPrefix + 'oem/ops-center/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_3=g_navNode_3.addNode('otnen_appqualmgmt','Application Quality Management',ssUrlPrefix + 'oem/app-quality-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_4=g_navNode_3.addNode('otnen_uxinsight','User Experience Management',ssUrlPrefix + 'oem/uxinsight/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_5=g_navNode_3.addNode('otnen_appmgmt','Applications Management',ssUrlPrefix + 'oem/app-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_6=g_navNode_3.addNode('otnen_soamgmt','SOA and Middleware Management',ssUrlPrefix + 'oem/soa-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_7=g_navNode_3.addNode('otnen_dbmgmt','Database Management',ssUrlPrefix + 'oem/db-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_9=g_navNode_3.addNode('otnen_appperfmgmt','Application Performance Management',ssUrlPrefix + 'oem/app-performance-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_10=g_navNode_3.addNode('otnen_configmgmt','Configuration Management',ssUrlPrefix + 'oem/config-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_11=g_navNode_3.addNode('otnen_automation','Software Lifecycle Automation',ssUrlPrefix + 'oem/automation/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_12=g_navNode_3.addNode('otnen_oemext','System Monitoring Plug-ins and Connectors',ssUrlPrefix + 'oem/extensions/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_13=g_navNode_3.addNode('otnen_vmmgmt','VM Management',ssUrlPrefix + 'oem/vm-management/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_13_0=g_navNode_3_13.addNode('otnen_vmmgmt_overview','Overview',ssUrlPrefix + 'oem/vm-management/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_13_1=g_navNode_3_13.addNode('otnen_vmmgmt_downloads','Downloads',ssUrlPrefix + 'oem/vm-management/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_13_2=g_navNode_3_13.addNode('otnen_vmmgmt_docs','Documentation',ssUrlPrefix + 'oem/vm-management/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_13_3=g_navNode_3_13.addNode('otnen_vmmgmt_community','Community',ssUrlPrefix + 'oem/vm-management/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_13_4=g_navNode_3_13.addNode('otnen_vmmgmt_learnmore','Learn More',ssUrlPrefix + 'oem/vm-management/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_3_14=g_navNode_3.addNode('otnen_apptest','Application Testing Suite',ssUrlPrefix + 'oem/app-test/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_15=g_navNode_3.addNode('otnen_hostservmgmt','Host/Server Management',ssUrlPrefix + 'oem/host-server-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_16=g_navNode_3.addNode('otnen_oemidmgmt','Identity Management',ssUrlPrefix + 'oem/id-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_17=g_navNode_3.addNode('otnen_archdeploy','Architecture \x26 Deployment Best Practices',ssUrlPrefix + 'oem/arch-deploy/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_3_18=g_navNode_3.addNode('otnen_sysmgmt','System Management',ssUrlPrefix + 'oem/sys-mgmt/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_4=g_navNode_Root.addNode('otnen_appstech','Applications',ssUrlPrefix + 'apps-tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_1=g_navNode_4.addNode('otnen_aia','AIA Process Integration Packs',ssUrlPrefix + 'apps-tech/aia/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_1_0=g_navNode_4_1.addNode('otnen_aia_overview','Overview',ssUrlPrefix + 'apps-tech/aia/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_1_1=g_navNode_4_1.addNode('otnen_aia_downloads','Downloads',ssUrlPrefix + 'apps-tech/aia/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_1_2=g_navNode_4_1.addNode('otnen_aia_docs','Documentation',ssUrlPrefix + 'apps-tech/aia/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_1_3=g_navNode_4_1.addNode('otnen_aia_community','Community',ssUrlPrefix + 'apps-tech/aia/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_1_4=g_navNode_4_1.addNode('otnen_aia_learnmore','Learn More',ssUrlPrefix + 'apps-tech/aia/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_2=g_navNode_4.addNode('otnen_ebusiness','E-Business Applications Technology',ssUrlPrefix + 'apps-tech/ebusiness/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_2_0=g_navNode_4_2.addNode('otnen_ebusiness_overview','Overview',ssUrlPrefix + 'apps-tech/ebusiness/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_2_1=g_navNode_4_2.addNode('otnen_ebusiness_downloads','Downloads',ssUrlPrefix + 'apps-tech/ebusiness/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_2_2=g_navNode_4_2.addNode('otnen_ebusiness_docs','Documentation',ssUrlPrefix + 'apps-tech/ebusiness/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_2_3=g_navNode_4_2.addNode('otnen_ebusiness_community','Community',ssUrlPrefix + 'apps-tech/ebusiness/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_2_4=g_navNode_4_2.addNode('otnen_ebusiness_learnmore','Learn More',ssUrlPrefix + 'apps-tech/ebusiness/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_3=g_navNode_4.addNode('otnen_policyauto','Oracle Policy Automation',ssUrlPrefix + 'apps-tech/policy-automation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_3_0=g_navNode_4_3.addNode('otnen_policyauto_overview','Overview',ssUrlPrefix + 'apps-tech/policy-automation/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_3_1=g_navNode_4_3.addNode('otnen_policyauto_downloads','Downloads',ssUrlPrefix + 'apps-tech/policy-automation/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_3_2=g_navNode_4_3.addNode('otnen_policyauto_docs','Documentation',ssUrlPrefix + 'apps-tech/policy-automation/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_3_3=g_navNode_4_3.addNode('otnen_policyauto_community','Community',ssUrlPrefix + 'apps-tech/policy-automation/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_3_4=g_navNode_4_3.addNode('otnen_policyauto_learnmore','Learn More',ssUrlPrefix + 'apps-tech/policy-automation/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_4=g_navNode_4.addNode('otnen_autovue','Autovue',ssUrlPrefix + 'apps-tech/autovue/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_4_6=g_navNode_4.addNode('otnen_grc','GRC Accelerators for Risk \x26 Fraud',ssUrlPrefix + 'apps-tech/grc-accelerators/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_4_6_0=g_navNode_4_6.addNode('otnen_grc_overview','Overview',ssUrlPrefix + 'apps-tech/grc-accelerators/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_6_1=g_navNode_4_6.addNode('otnen_grc_downloads','Downloads',ssUrlPrefix + 'apps-tech/grc-accelerators/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_6_2=g_navNode_4_6.addNode('otnen_grc_docs','Documentation',ssUrlPrefix + 'apps-tech/grc-accelerators/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_6_3=g_navNode_4_6.addNode('otnen_grc_community','Community',ssUrlPrefix + 'apps-tech/grc-accelerators/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_6_4=g_navNode_4_6.addNode('otnen_grc_learnmore','Learn More',ssUrlPrefix + 'apps-tech/grc-accelerators/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_7=g_navNode_4.addNode('otnen_grchyperion','- Hyperion SOD Accelerator for GRC',ssUrlPrefix + 'apps-tech/haa-blueprint/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_7_0=g_navNode_4_7.addNode('otnen_grchyperion_overview','Overview',ssUrlPrefix + 'apps-tech/haa-blueprint/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_7_1=g_navNode_4_7.addNode('otnen_grchyperion_downloads','Downloads',ssUrlPrefix + 'apps-tech/haa-blueprint/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_7_2=g_navNode_4_7.addNode('otnen_grchyperion_docs','Documentation',ssUrlPrefix + 'apps-tech/haa-blueprint/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_7_3=g_navNode_4_7.addNode('otnen_grchyperion_community','Community',ssUrlPrefix + 'apps-tech/haa-blueprint/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_7_4=g_navNode_4_7.addNode('otnen_grchyperion_learnmore','Learn More',ssUrlPrefix + 'apps-tech/haa-blueprint/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_8=g_navNode_4.addNode('otnen_grcauditscope','- Financials Audit Scoping Accelerator for GRC ',ssUrlPrefix + 'apps-tech/fast-blueprint/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_8_0=g_navNode_4_8.addNode('otnen_grcauditscope_overview','Overview',ssUrlPrefix + 'apps-tech/fast-blueprint/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_8_1=g_navNode_4_8.addNode('otnen_grcauditscope_downloads','Downloads',ssUrlPrefix + 'apps-tech/fast-blueprint/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_8_2=g_navNode_4_8.addNode('otnen_grcauditscope_docs','Documentation',ssUrlPrefix + 'apps-tech/fast-blueprint/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_8_3=g_navNode_4_8.addNode('otnen_grcauditscope_community','Community',ssUrlPrefix + 'apps-tech/fast-blueprint/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_8_4=g_navNode_4_8.addNode('otnen_grcauditscope_learnmore','Learn More',ssUrlPrefix + 'apps-tech/fast-blueprint/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_9=g_navNode_4.addNode('otnen_grchealth','- Health, Safety \x26 Environment Accelerator for GRC',ssUrlPrefix + 'apps-tech/hse-blueprint/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_9_0=g_navNode_4_9.addNode('otnen_grchealth_overview','Overview',ssUrlPrefix + 'apps-tech/hse-blueprint/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_9_1=g_navNode_4_9.addNode('otnen_grchealth_downloads','Downloads',ssUrlPrefix + 'apps-tech/hse-blueprint/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_9_2=g_navNode_4_9.addNode('otnen_grchealth_docs','Documentation',ssUrlPrefix + 'apps-tech/hse-blueprint/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_9_3=g_navNode_4_9.addNode('otnen_grchealth_community','Community',ssUrlPrefix + 'apps-tech/hse-blueprint/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_9_4=g_navNode_4_9.addNode('otnen_grchealth_learnmore','Learn More',ssUrlPrefix + 'apps-tech/hse-blueprint/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_10=g_navNode_4.addNode('otnen_grcacm','- Active Financial Close Process Monitoring Accelerator for GRC',ssUrlPrefix + 'apps-tech/acm-grcaccelerator/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_10_0=g_navNode_4_10.addNode('otnen_grcacm_overview','Overview',ssUrlPrefix + 'apps-tech/acm-grcaccelerator/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_10_1=g_navNode_4_10.addNode('otnen_grcacm_downloads','Downloads',ssUrlPrefix + 'apps-tech/acm-grcaccelerator/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_10_2=g_navNode_4_10.addNode('otnen_grcacm_docs','Documentation',ssUrlPrefix + 'apps-tech/acm-grcaccelerator/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_10_3=g_navNode_4_10.addNode('otnen_grcacm_community','Community',ssUrlPrefix + 'apps-tech/acm-grcaccelerator/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_4_10_4=g_navNode_4_10.addNode('otnen_grcacm_learnmore','Learn More',ssUrlPrefix + 'apps-tech/acm-grcaccelerator/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_5=g_navNode_Root.addNode('otnen_indexes','Indexes',ssUrlPrefix + 'indexes/index.html','secondaryUrlVariableField==MainContent');
g_navNode_5_0=g_navNode_5.addNode('otnen_indexes_docs','Documentation Index',ssUrlPrefix + 'indexes/documentation/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_5_1=g_navNode_5.addNode('otnen_indexes_downloads','Download Index',ssUrlPrefix + 'indexes/downloads/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_5_4=g_navNode_5.addNode('otnen_indexes_product','Product Index',ssUrlPrefix + 'indexes/products/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_5_6=g_navNode_5.addNode('otnen_exchange','Exchange Index',ssUrlPrefix + 'indexes/exchange/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6=g_navNode_Root.addNode('otnen_articles','Articles',ssUrlPrefix + 'articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_6_0=g_navNode_6.addNode('otnen_articles_adf','Application Development Framework',ssUrlPrefix + 'articles/adf/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_1=g_navNode_6.addNode('otnen_articles_apex','Application Express',ssUrlPrefix + 'articles/apex/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_2=g_navNode_6.addNode('otnen_articles_bi','Business Intelligence',ssUrlPrefix + 'articles/bi/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_3=g_navNode_6.addNode('otnen_articles_cloudcomp','Cloud Computing',ssUrlPrefix + 'articles/cloudcomp/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_4=g_navNode_6.addNode('otnen_articles_comm','Communications',ssUrlPrefix + 'articles/communications/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_5=g_navNode_6.addNode('otnen_articles_dbperformance','Database Performance \x26 Availability',ssUrlPrefix + 'articles/database-performance/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_6=g_navNode_6.addNode('otnen_articles_datawarehouse','Data Warehousing',ssUrlPrefix + 'articles/datawarehouse/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_7=g_navNode_6.addNode('otnen_articles_dotnet','.NET',ssUrlPrefix + 'articles/dotnet/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_8=g_navNode_6.addNode('otnen_articles_dynamicscript','Dynamic Scripting Languages',ssUrlPrefix + 'articles/dsl/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_9=g_navNode_6.addNode('otnen_articles_embedded','Embedded',ssUrlPrefix + 'articles/embedded/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_10=g_navNode_6.addNode('otnen_articles_enterprise2','Enterprise 2.0',ssUrlPrefix + 'articles/enterprise2/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_11=g_navNode_6.addNode('otnen_articles_entarch','Enterprise Architecture',ssUrlPrefix + 'articles/entarch/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_12=g_navNode_6.addNode('oten_articles_oem','Enterprise Management',ssUrlPrefix + 'articles/oem/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_13=g_navNode_6.addNode('otnen_articles_grid','Grid Computing',ssUrlPrefix + 'articles/grid/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_14=g_navNode_6.addNode('otnen_articles_idm','Identity \x26 Security',ssUrlPrefix + 'articles/idm/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_15=g_navNode_6.addNode('otnen_articles_java','Java',ssUrlPrefix + 'articles/java/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_21=g_navNode_6.addNode('otnen_articles_linux','Linux',ssUrlPrefix + 'articles/linux/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_22=g_navNode_6.addNode('otnen_articles_soa','Service-Oriented Architecture',ssUrlPrefix + 'articles/soa/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_23=g_navNode_6.addNode('otnen_articles_sql','SQL \x26 PL/SQL',ssUrlPrefix + 'articles/sql/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_24=g_navNode_6.addNode('otnen_articles_sysadmin','Server and Storage Administration',ssUrlPrefix + 'articles/servers-storage-admin/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_25=g_navNode_6.addNode('oten_articles_syssoftdev','Server and Storage Development',ssUrlPrefix + 'articles/servers-storage-dev/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_26=g_navNode_6.addNode('otnen_articles_syshardwarearch','Systems Hardware and Architecture',ssUrlPrefix + 'articles/systems-hardware-architecture/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_6_27=g_navNode_6.addNode('otnen_articles_virtualization','Virtualization',ssUrlPrefix + 'articles/virtualization/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_7=g_navNode_Root.addNode('otnen_community','Community',ssUrlPrefix + 'community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_0=g_navNode_7.addNode('otnen_join','Join',ssUrlPrefix + 'community/join/index.html');
g_navNode_7_0_0=g_navNode_7_0.addNode('otnen_join_overview','Overview',ssUrlPrefix + 'community/join/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_0_1=g_navNode_7_0.addNode('otnen_join_whyjoin','Why Join?',ssUrlPrefix + 'community/join/why-join/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_0_2=g_navNode_7_0.addNode('otnen_join_memberdiscounts','Member Discounts',ssUrlPrefix + 'community/join/member-discounts/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_0_3=g_navNode_7_0.addNode('otnen_join_help','Help',ssUrlPrefix + 'community/join/help/index.html');
g_navNode_7_1=g_navNode_7.addNode('otnen_community_oracleace','Oracle ACE Program',ssUrlPrefix + 'community/oracle-ace/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_7_2=g_navNode_7.addNode('otnen_usergroups','User Groups',ssUrlPrefix + 'community/user-groups/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_7_3=g_navNode_7.addNode('otnen_bookstore','Bookstore',ssUrlPrefix + 'community/bookstore/index.html','ssTabsLevelOverride==-1');
g_navNode_7_4=g_navNode_7.addNode('otnen_devday','Developer Day',ssUrlPrefix + 'community/developer-day/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_7_5=g_navNode_7.addNode('otnen_womentech','Women in Technology',ssUrlPrefix + 'community/women-in-tech/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_7_6=g_navNode_7.addNode('otnen_futureofjava','\"I Am the Future of Java\"',ssUrlPrefix + 'community/future-of-java/index.html','ssTabsLevelOverride==-1');
g_navNode_7_7=g_navNode_7.addNode('otnen_techcasts','TechCasts',ssUrlPrefix + 'community/techcasts/index.html');
g_navNode_7_7_0=g_navNode_7_7.addNode('otnen_techcasts_live','TechCast Live',ssUrlPrefix + 'community/techcasts/techcastlive/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_7_1=g_navNode_7_7.addNode('otnen_techcasts_archive','Archives',ssUrlPrefix + 'community/techcasts/archives/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_8=g_navNode_7.addNode('otnen_students','Students',ssUrlPrefix + 'community/students/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_8_0=g_navNode_7_8.addNode('otnen_students_overview','Overview',ssUrlPrefix + 'community/students/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_8_1=g_navNode_7_8.addNode('otnen_students_java','Java',ssUrlPrefix + 'community/students/java/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_8_2=g_navNode_7_8.addNode('otnen_students_database','Database',ssUrlPrefix + 'community/students/database/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_8_3=g_navNode_7_8.addNode('otnen_students_devtools','Development Tools',ssUrlPrefix + 'community/students/dev-tools/index.html','secondaryUrlVariableField==MainContent');
g_navNode_7_9=g_navNode_7.addNode('otnen_developervm','Pre-Built Developer VMs',ssUrlPrefix + 'community/developer-vm/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_8=g_navNode_Root.addNode('otnen_oramag1','Oracle Magazine',ssUrlPrefix + 'oramag/index.html','ssRedirectURL==/technetwork/oramag/magazine/home/index.html');
g_navNode_8_0=g_navNode_8.addNode('otnen_magazine','Oracle Magazine Online',ssUrlPrefix + 'oramag/magazine/index.html');
g_navNode_8_0_0=g_navNode_8_0.addNode('otnen_magazine_home','Home',ssUrlPrefix + 'oramag/magazine/home/index.html');
g_navNode_8_0_1=g_navNode_8_0.addNode('otnen_magazine_current','Current Issue',ssUrlPrefix + 'oramag/magazine/current-issue/index.html');
g_navNode_8_0_2=g_navNode_8_0.addNode('otnen_magazine_articles','Technical Articles',ssUrlPrefix + 'oramag/magazine/tech-articles/index.html');
g_navNode_8_0_3=g_navNode_8_0.addNode('otnen_magazine_archive','Issue Archive',ssUrlPrefix + 'oramag/magazine/archive/index.html');
g_navNode_8_0_4=g_navNode_8_0.addNode('otnen_magazine_communities','Communities',ssUrlPrefix + 'oramag/magazine/communities/index.html');
g_navNode_8_1=g_navNode_8.addNode('otnen_currentissue','Current Issue',ssUrlPrefix + 'oramag/current-issue/index.html','ssRedirectURL==/technetwork/oramag/magazine/current-issue/index.html','ssTabsLevelOverride==-1');
g_navNode_8_2=g_navNode_8.addNode('otnen_techarticles','Technical Articles',ssUrlPrefix + 'oramag/tech-articles/index.html','ssRedirectURL==/technetwork/oramag/magazine/tech-articles/index.html','ssTabsLevelOverride==-1');
g_navNode_8_3=g_navNode_8.addNode('otnen_archives','Issue Archives',ssUrlPrefix + 'oramag/archives/index.html','ssRedirectURL==/technetwork/oramag/magazine/archive/index.html','ssTabsLevelOverride==-1');
g_navNode_8_4=g_navNode_8.addNode('otnen_oramagcommunities','Communities',ssUrlPrefix + 'oramag/communities/index.html','ssRedirectURL==/technetwork/oramag/magazine/communities/index.html','ssTabsLevelOverride==-1');
g_navNode_8_5=g_navNode_8.addNode('otnen_edcalendar','Editorial Calendar',ssUrlPrefix + 'oramag/calendar/index.html','ssRedirectURL==/us/corporate/publishing/editorial-calendar/profit-oramag-calendar-078391.html','ssTabsLevelOverride==-1');
g_navNode_8_6=g_navNode_8.addNode('otnen_oramagsubscribe','Subscribe',ssUrlPrefix + 'oramag/subscribe/index.html','ssRedirectURL==/us/corporate/publishing/subscribe/index.html','ssTabsLevelOverride==-1');
g_navNode_8_7=g_navNode_8.addNode('otnen_publishing','Oracle Publishing',ssUrlPrefix + 'oramag/publishing/index.html','ssRedirectURL==/us/corporate/publishing/index.html','ssTabsLevelOverride==-1');
g_navNode_8_8=g_navNode_8.addNode('otnen_profitmag','Profit Magazine',ssUrlPrefix + 'oramag/profit/index.html','ssRedirectURL==http\x3a//www.oracle.com/profit/index.html','ssTabsLevelOverride==-1');
g_navNode_9=g_navNode_Root.addNode('otnen_oramag','Oracle Magazine Issue Archive',ssUrlPrefix + 'issue-archive/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_0=g_navNode_9.addNode('otnen_oramag_online','Oracle Magazine Online',ssUrlPrefix + 'issue-archive/oramag/index.html','ssRedirectURL==/technetwork/oramag/magazine/home/index.html','ssTabsLevelOverride==-1');
g_navNode_9_2=g_navNode_9.addNode('otnen_oramag_2010','2010',ssUrlPrefix + 'issue-archive/2010/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_2_0=g_navNode_9_2.addNode('otnen_oramag_10jan','January 2010',ssUrlPrefix + 'issue-archive/2010/10-jan/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_2_1=g_navNode_9_2.addNode('otnen_oramag_10mar','March 2010',ssUrlPrefix + 'issue-archive/2010/10-mar/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_2_2=g_navNode_9_2.addNode('otnen_oramag_10may','May 2010',ssUrlPrefix + 'issue-archive/2010/10-may/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_2_3=g_navNode_9_2.addNode('otnen_oramag_10jul','July 2010',ssUrlPrefix + 'issue-archive/2010/10-jul/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_2_4=g_navNode_9_2.addNode('otnen_oramag_10sep','September 2010',ssUrlPrefix + 'issue-archive/2010/10-sep/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_2_5=g_navNode_9_2.addNode('otnen_oramag_10nov','November 2010',ssUrlPrefix + 'issue-archive/2010/10-nov/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_3=g_navNode_9.addNode('otnen_oramage_2009','2009',ssUrlPrefix + 'issue-archive/2009/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_3_0=g_navNode_9_3.addNode('otnen_oramag_09jan','January 2009',ssUrlPrefix + 'issue-archive/2009/09-jan/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_3_1=g_navNode_9_3.addNode('otnen_oramag_09mar','March 2009',ssUrlPrefix + 'issue-archive/2009/09-mar/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_3_2=g_navNode_9_3.addNode('otnen_oramag_09may','May 2009',ssUrlPrefix + 'issue-archive/2009/09-may/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_3_3=g_navNode_9_3.addNode('otnen_oramag_09jul','July 2009',ssUrlPrefix + 'issue-archive/2009/09-jul/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_3_4=g_navNode_9_3.addNode('otnen_oramag_09sep','September 2009',ssUrlPrefix + 'issue-archive/2009/09-sep/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_3_5=g_navNode_9_3.addNode('otnen_oramag_09nov','November 2009',ssUrlPrefix + 'issue-archive/2009/09-nov/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_4=g_navNode_9.addNode('otnen_oramag_2008','2008',ssUrlPrefix + 'issue-archive/2008/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_4_0=g_navNode_9_4.addNode('otnen_oramag_08jan','January 2008',ssUrlPrefix + 'issue-archive/2008/08-jan/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_4_1=g_navNode_9_4.addNode('otnen_oramag_08mar','March 2008',ssUrlPrefix + 'issue-archive/2008/08-mar/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_4_2=g_navNode_9_4.addNode('otnen_oramag_08may','May 2008',ssUrlPrefix + 'issue-archive/2008/08-may/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_4_3=g_navNode_9_4.addNode('otnen_oramag_08jul','July 2008',ssUrlPrefix + 'issue-archive/2008/08-jul/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_4_4=g_navNode_9_4.addNode('otnen_oramag_08sep','September 2008',ssUrlPrefix + 'issue-archive/2008/08-sep/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_4_5=g_navNode_9_4.addNode('otnen_oramag_08nov','November 2008',ssUrlPrefix + 'issue-archive/2008/08-nov/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_5=g_navNode_9.addNode('otnen_oramag_2007','2007',ssUrlPrefix + 'issue-archive/2007/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_5_0=g_navNode_9_5.addNode('otnen_oramag_07jan','January 2007',ssUrlPrefix + 'issue-archive/2007/07-jan/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_5_1=g_navNode_9_5.addNode('otnen_oramag_07mar','March 2007',ssUrlPrefix + 'issue-archive/2007/07-mar/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_5_2=g_navNode_9_5.addNode('otnen_oramag_07may','May 2007',ssUrlPrefix + 'issue-archive/2007/07-may/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_5_3=g_navNode_9_5.addNode('otnen_oramag_07jul','July 2007',ssUrlPrefix + 'issue-archive/2007/07-jul/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_5_4=g_navNode_9_5.addNode('otnen_oramag_07sep','September 2007',ssUrlPrefix + 'issue-archive/2007/07-sep/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_5_5=g_navNode_9_5.addNode('otnen_oramag_07nov','November 2007',ssUrlPrefix + 'issue-archive/2007/07-nov/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_6=g_navNode_9.addNode('otnen_oramag_2006','2006',ssUrlPrefix + 'issue-archive/2006/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_6_0=g_navNode_9_6.addNode('otnen_oramag_06jan','January 2006',ssUrlPrefix + 'issue-archive/2006/06-jan/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_6_1=g_navNode_9_6.addNode('otnen_oramag_06mar','March 2006',ssUrlPrefix + 'issue-archive/2006/06-mar/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_6_2=g_navNode_9_6.addNode('otnen_oramag_06may','May 2006',ssUrlPrefix + 'issue-archive/2006/06-may/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_6_3=g_navNode_9_6.addNode('otnen_oramag_06jul','July 2006',ssUrlPrefix + 'issue-archive/2006/06-jul/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_6_4=g_navNode_9_6.addNode('otnen_oramag_06sep','September 2006',ssUrlPrefix + 'issue-archive/2006/06-sep/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_6_5=g_navNode_9_6.addNode('otnen_oramag_06nov','November 2006',ssUrlPrefix + 'issue-archive/2006/06-nov/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_7=g_navNode_9.addNode('otnen_oramag_2005','2005',ssUrlPrefix + 'issue-archive/2005/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_9_7_0=g_navNode_9_7.addNode('otnen_oramag_05jan','January 2005',ssUrlPrefix + 'issue-archive/2005/05-jan/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_7_1=g_navNode_9_7.addNode('otnen_oramag_05mar','March 2005',ssUrlPrefix + 'issue-archive/2005/05-mar/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_7_2=g_navNode_9_7.addNode('otnen_oramag_05may','May 2005',ssUrlPrefix + 'issue-archive/2005/05-may/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_7_3=g_navNode_9_7.addNode('otnen_oramag_05jul','July 2005',ssUrlPrefix + 'issue-archive/2005/05-jul/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_7_4=g_navNode_9_7.addNode('otnen_oramag_05sep','September 2005',ssUrlPrefix + 'issue-archive/2005/05-sep/index.html','secondaryUrlVariableField==MainContent');
g_navNode_9_7_5=g_navNode_9_7.addNode('otnen_oramag_05nov','November 2005',ssUrlPrefix + 'issue-archive/2005/05-nov/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10=g_navNode_Root.addNode('otnen_topics','Topics',ssUrlPrefix + 'topics/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_0=g_navNode_10.addNode('otnen_embedded','Embedded',ssUrlPrefix + 'topics/embedded/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_0_0=g_navNode_10_0.addNode('otnen_embedded_whatsnew','What\'s New',ssUrlPrefix + 'topics/embedded/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_0_1=g_navNode_10_0.addNode('otnen_embedded_downloads','Downloads',ssUrlPrefix + 'topics/embedded/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_0_2=g_navNode_10_0.addNode('otnen_embedded_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/embedded/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_0_3=g_navNode_10_0.addNode('otnen_embedded_community','Community',ssUrlPrefix + 'topics/embedded/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_0_4=g_navNode_10_0.addNode('otnen_embedded_learnmore','Learn More',ssUrlPrefix + 'topics/embedded/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_1=g_navNode_10.addNode('otnen_bidatawarehouse','BI \x26 Data Warehousing',ssUrlPrefix + 'topics/bi/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_1_0=g_navNode_10_1.addNode('otnen_bidatawarehouse_whatsnew','What\'s New',ssUrlPrefix + 'topics/bi/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_1_1=g_navNode_10_1.addNode('otnen_bidatawarehouse_download','Downloads',ssUrlPrefix + 'topics/bi/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_1_2=g_navNode_10_1.addNode('otnen_bidatawarehouse_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/bi/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_1_3=g_navNode_10_1.addNode('otnen_bidatawarehouse_comm','Community',ssUrlPrefix + 'topics/bi/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_1_4=g_navNode_10_1.addNode('otnen_bidatawarehouse_learnmor','Learn More',ssUrlPrefix + 'topics/bi/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_2=g_navNode_10.addNode('otnen_dotnet','.NET',ssUrlPrefix + 'topics/dotnet/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_2_0=g_navNode_10_2.addNode('otnen_dotnet_whatsnew','What\'s New',ssUrlPrefix + 'topics/dotnet/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_2_1=g_navNode_10_2.addNode('otnen_dotnet_beginners','For Beginners',ssUrlPrefix + 'topics/dotnet/for-beginners/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_2_2=g_navNode_10_2.addNode('otnen_dotnet_products','Products',ssUrlPrefix + 'topics/dotnet/products/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_2_3=g_navNode_10_2.addNode('otnen_dotnet_techinfo','Technical Information',ssUrlPrefix + 'topics/dotnet/tech-info/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_2_4=g_navNode_10_2.addNode('otnen_dotnet_downloads','Downloads',ssUrlPrefix + 'topics/dotnet/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_3=g_navNode_10.addNode('otnen_linux','Linux',ssUrlPrefix + 'topics/linux/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_3_0=g_navNode_10_3.addNode('otnen_linux_whatsnew','What\'s New',ssUrlPrefix + 'topics/linux/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_3_1=g_navNode_10_3.addNode('otnen_linux_downloads','Downloads',ssUrlPrefix + 'topics/linux/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_3_2=g_navNode_10_3.addNode('otnen_linux_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/linux/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_3_3=g_navNode_10_3.addNode('otnen_linux_community','Community',ssUrlPrefix + 'topics/linux/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_3_4=g_navNode_10_3.addNode('otnen_linux_learnmore','Learn More',ssUrlPrefix + 'topics/linux/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_4=g_navNode_10.addNode('otnen_php','PHP',ssUrlPrefix + 'topics/php/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_4_0=g_navNode_10_4.addNode('otnen_php_whatsnew','What\'s New',ssUrlPrefix + 'topics/php/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_4_1=g_navNode_10_4.addNode('otnen_php_downloads','Downloads',ssUrlPrefix + 'topics/php/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_4_2=g_navNode_10_4.addNode('otnen_php_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/php/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_4_3=g_navNode_10_4.addNode('otnen_php_community','Community',ssUrlPrefix + 'topics/php/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_4_4=g_navNode_10_4.addNode('otnen_php_learnmore','Learn More',ssUrlPrefix + 'topics/php/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5=g_navNode_10.addNode('otnen_newtojava','New to Java',ssUrlPrefix + 'topics/newtojava/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5_0=g_navNode_10_5.addNode('otnen_newtojava_overview','Overview',ssUrlPrefix + 'topics/newtojava/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5_1=g_navNode_10_5.addNode('otnen_newtojava_downloads','Downloads',ssUrlPrefix + 'topics/newtojava/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5_2=g_navNode_10_5.addNode('otnen_newtojava_docs','Documentation',ssUrlPrefix + 'topics/newtojava/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5_3=g_navNode_10_5.addNode('otnen_newtojava_community','Community',ssUrlPrefix + 'topics/newtojava/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5_4=g_navNode_10_5.addNode('otnen_newtojava_tech','Learn More',ssUrlPrefix + 'topics/newtojava/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_5_5=g_navNode_10_5.addNode('otnen_newtojava_training','Training',ssUrlPrefix + 'topics/newtojava/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_6=g_navNode_10.addNode('otnen_cloud','Cloud Computing',ssUrlPrefix + 'topics/cloud/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_6_0=g_navNode_10_6.addNode('otnen_cloud_whatsnew','What\'s New',ssUrlPrefix + 'topics/cloud/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_6_1=g_navNode_10_6.addNode('otnen_cloud_downloads','Downloads',ssUrlPrefix + 'topics/cloud/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_6_2=g_navNode_10_6.addNode('otnen_cloud_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/cloud/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_6_3=g_navNode_10_6.addNode('otnen_cloud_community','Community',ssUrlPrefix + 'topics/cloud/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_6_4=g_navNode_10_6.addNode('otnen_cloud_learnmore','Learn More',ssUrlPrefix + 'topics/cloud/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_8=g_navNode_10.addNode('otnen_macos','Mac OS X',ssUrlPrefix + 'topics/macos/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_8_0=g_navNode_10_8.addNode('otnen_macos_whatsnew','What\'s New',ssUrlPrefix + 'topics/macos/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_8_1=g_navNode_10_8.addNode('otnen_macos_downloads','Downloads',ssUrlPrefix + 'topics/macos/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_8_2=g_navNode_10_8.addNode('otnen_macos_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/macos/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_8_3=g_navNode_10_8.addNode('otnen_macos_community','Community',ssUrlPrefix + 'topics/macos/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_8_4=g_navNode_10_8.addNode('otnen_macos_learnmore','Learn More',ssUrlPrefix + 'topics/macos/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_9=g_navNode_10.addNode('otnen_modernization','Modernization',ssUrlPrefix + 'topics/modernization/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_9_0=g_navNode_10_9.addNode('otnen_modernization_whatsnew','What\'s New',ssUrlPrefix + 'topics/modernization/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_9_1=g_navNode_10_9.addNode('otnen_modernization_downloads','Downloads',ssUrlPrefix + 'topics/modernization/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_9_2=g_navNode_10_9.addNode('otnen_modernization_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/modernization/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_9_3=g_navNode_10_9.addNode('otnen_modernization_community','Community',ssUrlPrefix + 'topics/modernization/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_9_4=g_navNode_10_9.addNode('otnen_modernization_learnmore','Learn More',ssUrlPrefix + 'topics/modernization/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_12=g_navNode_10.addNode('otnen_scripting','Ruby \x26 Python',ssUrlPrefix + 'topics/scripting-languages/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_12_0=g_navNode_10_12.addNode('otnen_scripting_whatsnew','What\'s New',ssUrlPrefix + 'topics/scripting-languages/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_12_1=g_navNode_10_12.addNode('otnen_scripting_downloads','Downloads',ssUrlPrefix + 'topics/scripting-languages/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_12_2=g_navNode_10_12.addNode('otnen_scripting_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/scripting-languages/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_12_3=g_navNode_10_12.addNode('otnen_scripting_community','Community',ssUrlPrefix + 'topics/scripting-languages/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_12_4=g_navNode_10_12.addNode('otnen_scripting_learnmore','Learn More',ssUrlPrefix + 'topics/scripting-languages/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_14=g_navNode_10.addNode('otnen_security','Security',ssUrlPrefix + 'topics/security/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_14_0=g_navNode_10_14.addNode('otnen_security_whatsnew','What\'s New',ssUrlPrefix + 'topics/security/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_14_1=g_navNode_10_14.addNode('otnen_security_downloads','Downloads',ssUrlPrefix + 'topics/security/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_14_2=g_navNode_10_14.addNode('otnen_security_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/security/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_14_3=g_navNode_10_14.addNode('otnen_security_community','Community',ssUrlPrefix + 'topics/security/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_14_4=g_navNode_10_14.addNode('otnen_security_learnmore','Learn More',ssUrlPrefix + 'topics/security/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_17=g_navNode_10.addNode('otnen_entarch','Enterprise Architecture',ssUrlPrefix + 'topics/entarch/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_17_0=g_navNode_10_17.addNode('otnen_entarch_whatsnew','What\'s New',ssUrlPrefix + 'topics/entarch/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_17_1=g_navNode_10_17.addNode('otnen_entarch_downloads','Downloads',ssUrlPrefix + 'topics/entarch/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_17_2=g_navNode_10_17.addNode('otnen_entarch_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/entarch/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_17_3=g_navNode_10_17.addNode('otnen_entarch_community','Community',ssUrlPrefix + 'topics/entarch/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_17_4=g_navNode_10_17.addNode('otnen_entarch_learnmore','Learn More',ssUrlPrefix + 'topics/entarch/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_18=g_navNode_10.addNode('otnen_ent20','Enterprise 2.0',ssUrlPrefix + 'topics/ent20/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_18_0=g_navNode_10_18.addNode('otnen_ent20_whatsnew','What\'s New',ssUrlPrefix + 'topics/ent20/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_18_1=g_navNode_10_18.addNode('otnen_ent20_downloads','Downloads',ssUrlPrefix + 'topics/ent20/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_18_2=g_navNode_10_18.addNode('otnen_ent20_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/ent20/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_18_3=g_navNode_10_18.addNode('otnen_ent20_community','Community',ssUrlPrefix + 'topics/ent20/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_18_4=g_navNode_10_18.addNode('otnen_ent20_learnmore','Learn More',ssUrlPrefix + 'topics/ent20/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_19=g_navNode_10.addNode('otnen_gridcomp','Grid Computing',ssUrlPrefix + 'topics/grid/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_19_0=g_navNode_10_19.addNode('otnen_gridcomp_whatsnew','What\'s New',ssUrlPrefix + 'topics/grid/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_19_1=g_navNode_10_19.addNode('otnen_gridcomp_downloads','Downloads',ssUrlPrefix + 'topics/grid/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_19_2=g_navNode_10_19.addNode('otnen_gridcomp_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/grid/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_19_3=g_navNode_10_19.addNode('otnen_gridcomp_community','Community',ssUrlPrefix + 'topics/grid/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_19_4=g_navNode_10_19.addNode('otnen_gridcomp_learnmore','Learn More',ssUrlPrefix + 'topics/grid/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_20=g_navNode_10.addNode('otnen_soaarch','Service-Oriented Architecture',ssUrlPrefix + 'topics/soa/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_20_0=g_navNode_10_20.addNode('otnen_soaarch_whatsnew','What\'s New',ssUrlPrefix + 'topics/soa/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_20_1=g_navNode_10_20.addNode('otnen_soaarch_downloads','Products',ssUrlPrefix + 'topics/soa/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_20_2=g_navNode_10_20.addNode('otnen_soaarch_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/soa/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_20_3=g_navNode_10_20.addNode('otnen_soaarch_community','Community',ssUrlPrefix + 'topics/soa/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_20_4=g_navNode_10_20.addNode('otnen_soaarch_learnmore','Learn More',ssUrlPrefix + 'topics/soa/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_21=g_navNode_10.addNode('otnen_virtualization','Virtualization',ssUrlPrefix + 'topics/virtualization/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_21_0=g_navNode_10_21.addNode('otnen_virtualization_whatsnew','What\'s New',ssUrlPrefix + 'topics/virtualization/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_21_1=g_navNode_10_21.addNode('otnen_virtualization_downloads','Downloads',ssUrlPrefix + 'topics/virtualization/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_21_2=g_navNode_10_21.addNode('otnen_virtualization_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'topics/virtualization/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_21_3=g_navNode_10_21.addNode('otnen_virtualization_community','Community',ssUrlPrefix + 'topics/virtualization/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_10_21_4=g_navNode_10_21.addNode('otnen_virtualization_learnmore','Learn More',ssUrlPrefix + 'topics/virtualization/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11=g_navNode_Root.addNode('otnen_java','Java',ssUrlPrefix + 'java/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1=g_navNode_11.addNode('otnen_javase','Java SE',ssUrlPrefix + 'java/javase/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1_0=g_navNode_11_1.addNode('otnen_javase_overview','Overview',ssUrlPrefix + 'java/javase/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1_1=g_navNode_11_1.addNode('otnen_javase_downloads','Downloads',ssUrlPrefix + 'java/javase/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1_2=g_navNode_11_1.addNode('otnen_javase_docs','Documentation',ssUrlPrefix + 'java/javase/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1_3=g_navNode_11_1.addNode('otnen_javase_community','Community',ssUrlPrefix + 'java/javase/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1_4=g_navNode_11_1.addNode('otnen_javase_tech','Technologies',ssUrlPrefix + 'java/javase/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_1_5=g_navNode_11_1.addNode('otnen_javase_training','Training',ssUrlPrefix + 'java/javase/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_2=g_navNode_11.addNode('otnen_javasebusiness','Java SE for Business',ssUrlPrefix + 'java/javasebusiness/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_2_0=g_navNode_11_2.addNode('oten_javasebusiness_overview','Overview',ssUrlPrefix + 'java/javasebusiness/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_2_1=g_navNode_11_2.addNode('oten_javasebusiness_downloads','Downloads',ssUrlPrefix + 'java/javasebusiness/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_2_2=g_navNode_11_2.addNode('oten_javasebusiness_docs','Documentation',ssUrlPrefix + 'java/javasebusiness/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_3=g_navNode_11.addNode('otnen_javaseembed','Java Embedded',ssUrlPrefix + 'java/embedded/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_3_0=g_navNode_11_3.addNode('otnen_javaseembed_overview','Overview',ssUrlPrefix + 'java/embedded/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_3_1=g_navNode_11_3.addNode('otnen_javaseembed_downloads','Downloads',ssUrlPrefix + 'java/embedded/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_3_2=g_navNode_11_3.addNode('otnen_javaseembed_docs','Documentation',ssUrlPrefix + 'java/embedded/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_3_3=g_navNode_11_3.addNode('otnen_javaseembed_community','Community',ssUrlPrefix + 'java/embedded/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4=g_navNode_11.addNode('otnen_javaee','Java EE',ssUrlPrefix + 'java/javaee/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4_0=g_navNode_11_4.addNode('otnen_javaee_overview','Overview',ssUrlPrefix + 'java/javaee/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4_1=g_navNode_11_4.addNode('otnen_javaee_downloads','Downloads',ssUrlPrefix + 'java/javaee/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4_2=g_navNode_11_4.addNode('otnen_javaee_docs','Documentation',ssUrlPrefix + 'java/javaee/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4_3=g_navNode_11_4.addNode('otnen_javaee_community','Community',ssUrlPrefix + 'java/javaee/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4_4=g_navNode_11_4.addNode('otnen_javaee_tech','Technologies',ssUrlPrefix + 'java/javaee/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_4_5=g_navNode_11_4.addNode('otnen_javaee_training','Training',ssUrlPrefix + 'java/javaee/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5=g_navNode_11.addNode('otnen_javame','Java ME',ssUrlPrefix + 'java/javame/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5_0=g_navNode_11_5.addNode('otnen_javame_overview','Overview',ssUrlPrefix + 'java/javame/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5_1=g_navNode_11_5.addNode('otnen_javame_downloads','Downloads',ssUrlPrefix + 'java/javame/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5_2=g_navNode_11_5.addNode('otnen_javame_docs','Documentation',ssUrlPrefix + 'java/javame/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5_3=g_navNode_11_5.addNode('otnen_javame_community','Community',ssUrlPrefix + 'java/javame/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5_4=g_navNode_11_5.addNode('otnen_javame_tech','Technologies',ssUrlPrefix + 'java/javame/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_5_5=g_navNode_11_5.addNode('otnen_javame_training','Training',ssUrlPrefix + 'java/javame/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6=g_navNode_11.addNode('otnen_javafx','JavaFX',ssUrlPrefix + 'java/javafx/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6_0=g_navNode_11_6.addNode('otnen_javafx_overview','Overview',ssUrlPrefix + 'java/javafx/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6_1=g_navNode_11_6.addNode('otnen_javafx_downloads','Downloads',ssUrlPrefix + 'java/javafx/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6_2=g_navNode_11_6.addNode('otnen_javafx_docs','Documentation',ssUrlPrefix + 'java/javafx/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6_3=g_navNode_11_6.addNode('otnen_javafx_community','Community',ssUrlPrefix + 'java/javafx/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6_4=g_navNode_11_6.addNode('otnen_javafx_tech','Technologies',ssUrlPrefix + 'java/javafx/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_6_5=g_navNode_11_6.addNode('otnen_javafx_training','Training',ssUrlPrefix + 'java/javafx/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_7=g_navNode_11.addNode('otnen_javadb','Java DB',ssUrlPrefix + 'java/javadb/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_7_0=g_navNode_11_7.addNode('otnen_javadb_overview','Overview',ssUrlPrefix + 'java/javadb/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_7_1=g_navNode_11_7.addNode('otnen_javadb_downloads','Downloads',ssUrlPrefix + 'java/javadb/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_7_2=g_navNode_11_7.addNode('otnen_javadb_docs','Documentation',ssUrlPrefix + 'java/javadb/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_7_3=g_navNode_11_7.addNode('otnen_javadb_community','Community',ssUrlPrefix + 'java/javadb/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_7_5=g_navNode_11_7.addNode('otnen_javadb_training','Training',ssUrlPrefix + 'java/javadb/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_8=g_navNode_11.addNode('otnen_webtier','Web Tier',ssUrlPrefix + 'java/webtier/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_8_0=g_navNode_11_8.addNode('otnen_webtier_overview','Overview',ssUrlPrefix + 'java/webtier/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_8_1=g_navNode_11_8.addNode('otnen_webtier_downloads','Downloads',ssUrlPrefix + 'java/webtier/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_8_2=g_navNode_11_8.addNode('otnen_webtier_docs','Documentation',ssUrlPrefix + 'java/webtier/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_8_3=g_navNode_11_8.addNode('otnen_webtier_community','Community',ssUrlPrefix + 'java/webtier/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_8_5=g_navNode_11_8.addNode('otnen_webtier_training','Training',ssUrlPrefix + 'java/webtier/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9=g_navNode_11.addNode('otnen_javacard','Java Card',ssUrlPrefix + 'java/javacard/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9_0=g_navNode_11_9.addNode('otnen_javacard_overview','Overview',ssUrlPrefix + 'java/javacard/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9_1=g_navNode_11_9.addNode('otnen_javacard_downloads','Downloads',ssUrlPrefix + 'java/javacard/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9_2=g_navNode_11_9.addNode('otnen_javacard_docs','Documentation',ssUrlPrefix + 'java/javacard/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9_3=g_navNode_11_9.addNode('otnen_javacard_community','Community',ssUrlPrefix + 'java/javacard/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9_4=g_navNode_11_9.addNode('otnen_javacard_tech','Technologies',ssUrlPrefix + 'java/javacard/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_9_5=g_navNode_11_9.addNode('otnen_javacard_training','Training',ssUrlPrefix + 'java/javacard/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_11_10=g_navNode_11.addNode('otnen_javatv','Java TV',ssUrlPrefix + 'java/javatv/index.html','contributorOnly==FALSE');
g_navNode_11_10_0=g_navNode_11_10.addNode('otnen_javatv_overview','Overview',ssUrlPrefix + 'java/javatv/overview/index.html','contributorOnly==FALSE');
g_navNode_11_10_1=g_navNode_11_10.addNode('otnen_javatv_downloads','Downloads',ssUrlPrefix + 'java/javatv/downloads/index.html','contributorOnly==FALSE');
g_navNode_11_10_2=g_navNode_11_10.addNode('otnen_javatv_tech','Technology',ssUrlPrefix + 'java/javatv/tech/index.html','contributorOnly==FALSE');
g_navNode_11_10_3=g_navNode_11_10.addNode('otnen_javatv_community','Community',ssUrlPrefix + 'java/javatv/community/index.html','contributorOnly==FALSE');
g_navNode_13=g_navNode_Root.addNode('687','RegressionTestSection',ssUrlPrefix + 'RegressionTestSection/index.html','secondaryUrlVariableField==MainContent');
g_navNode_14=g_navNode_Root.addNode('688','RegressionTestSectionTabs',ssUrlPrefix + 'RegressionTestSectionTabs/index.html');
g_navNode_14_0=g_navNode_14.addNode('691','RegressionTabsL2',ssUrlPrefix + 'RegressionTestSectionTabs/RegressionTabsL2/index.html','secondaryUrlVariableField==MainContent');
g_navNode_14_0_0=g_navNode_14_0.addNode('689','overview',ssUrlPrefix + 'RegressionTestSectionTabs/RegressionTabsL2/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15=g_navNode_Root.addNode('otnen_serversstorage','Server and Storage Systems',ssUrlPrefix + 'server-storage/index.html','secondaryUrlVariableField==MainContent','ssRedirectURL==/technetwork/systems/index.html');
g_navNode_15_1=g_navNode_15.addNode('otnen_solaris','Oracle Solaris 10',ssUrlPrefix + 'server-storage/solaris/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_1_0=g_navNode_15_1.addNode('otnen_solaris_overview','Overview',ssUrlPrefix + 'server-storage/solaris/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_1_1=g_navNode_15_1.addNode('otnen_solaris_downloads','Downloads',ssUrlPrefix + 'server-storage/solaris/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_1_2=g_navNode_15_1.addNode('otnen_solaris_docs','Documentation',ssUrlPrefix + 'server-storage/solaris/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_1_3=g_navNode_15_1.addNode('otnen_solaris_community','Community',ssUrlPrefix + 'server-storage/solaris/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_1_4=g_navNode_15_1.addNode('otnen_solaris_training','Training',ssUrlPrefix + 'server-storage/solaris/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_2=g_navNode_15.addNode('otnen_solaris11','Oracle Solaris 11',ssUrlPrefix + 'server-storage/solaris11/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_2_0=g_navNode_15_2.addNode('otnen_solaris11_overview','Overview',ssUrlPrefix + 'server-storage/solaris11/overview/index.html','contributorOnly==FALSE','secondaryUrlVariableField==MainContent');
g_navNode_15_2_2=g_navNode_15_2.addNode('otnen_solaris11_docs','Documentation',ssUrlPrefix + 'server-storage/solaris11/documentation/index.html','contributorOnly==FALSE','secondaryUrlVariableField==MainContent');
g_navNode_15_2_3=g_navNode_15_2.addNode('otnen_solaris11_download','Downloads',ssUrlPrefix + 'server-storage/solaris11/downloads/index.html','contributorOnly==FALSE','secondaryUrlVariableField==MainContent');
g_navNode_15_2_4=g_navNode_15_2.addNode('otnen_solaris11_community','Community',ssUrlPrefix + 'server-storage/solaris11/community/index.html','contributorOnly==FALSE','secondaryUrlVariableField==MainContent');
g_navNode_15_4=g_navNode_15.addNode('otnen_solariscluster','Oracle Solaris Cluster',ssUrlPrefix + 'server-storage/solaris-cluster/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_4_0=g_navNode_15_4.addNode('otnen_solariscluster_overview','Overview',ssUrlPrefix + 'server-storage/solaris-cluster/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_4_1=g_navNode_15_4.addNode('otnen_solariscluster_docs','Documentation',ssUrlPrefix + 'server-storage/solaris-cluster/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_4_2=g_navNode_15_4.addNode('otnen_solariscluster_downloads','Downloads',ssUrlPrefix + 'server-storage/solaris-cluster/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_4_3=g_navNode_15_4.addNode('otnen_solariscluster_training','Training',ssUrlPrefix + 'server-storage/solaris-cluster/training/index.html');
g_navNode_15_5=g_navNode_15.addNode('otnen_sunstudio','Oracle Solaris Studio',ssUrlPrefix + 'server-storage/solarisstudio/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_5_0=g_navNode_15_5.addNode('otnen_sunstudio_overview','Overview',ssUrlPrefix + 'server-storage/solarisstudio/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_5_1=g_navNode_15_5.addNode('otnen_sunstudio_downloads','Downloads',ssUrlPrefix + 'server-storage/solarisstudio/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_5_2=g_navNode_15_5.addNode('otnen_sunstudio_docs','Documentation',ssUrlPrefix + 'server-storage/solarisstudio/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_5_3=g_navNode_15_5.addNode('otnen_sunstudio_community','Community',ssUrlPrefix + 'server-storage/solarisstudio/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_5_4=g_navNode_15_5.addNode('otnen_sunstudio_training','Training',ssUrlPrefix + 'server-storage/solarisstudio/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_6=g_navNode_15.addNode('otnen_vm','Oracle VM',ssUrlPrefix + 'server-storage/vm/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_6_0=g_navNode_15_6.addNode('otnen_vm_overview','Overview',ssUrlPrefix + 'server-storage/vm/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_6_1=g_navNode_15_6.addNode('otnen_vm_downloads','Downloads',ssUrlPrefix + 'server-storage/vm/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_6_2=g_navNode_15_6.addNode('otnen_vm_docs','Documentation',ssUrlPrefix + 'server-storage/vm/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_6_3=g_navNode_15_6.addNode('otnen_vm_community','Community',ssUrlPrefix + 'server-storage/vm/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_6_4=g_navNode_15_6.addNode('otnen_vm_learnmore','Learn More',ssUrlPrefix + 'server-storage/vm/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_7=g_navNode_15.addNode('otnen_virtualbox','Oracle VM VirtualBox',ssUrlPrefix + 'server-storage/virtualbox/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_7_0=g_navNode_15_7.addNode('otnen_virtualbox_overview','Overview',ssUrlPrefix + 'server-storage/virtualbox/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_7_1=g_navNode_15_7.addNode('otnen_virtualbox_downloads','Downloads',ssUrlPrefix + 'server-storage/virtualbox/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_7_2=g_navNode_15_7.addNode('otnen_virtualbox_docs','Documentation',ssUrlPrefix + 'server-storage/virtualbox/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_7_3=g_navNode_15_7.addNode('otnen_virtualbox_community','Community',ssUrlPrefix + 'server-storage/virtualbox/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_7_4=g_navNode_15_7.addNode('otnen_virtualbox_learnmore','Learn More',ssUrlPrefix + 'server-storage/virtualbox/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_8=g_navNode_15.addNode('otnen_clustertools','Cluster Tools',ssUrlPrefix + 'server-storage/cluster-tools/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_10=g_navNode_15.addNode('otnen_sunblade','Oracle Sun Blade Systems',ssUrlPrefix + 'server-storage/sun-blade/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_10_0=g_navNode_15_10.addNode('otnen_sunblade_overview','Overview',ssUrlPrefix + 'server-storage/sun-blade/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_10_2=g_navNode_15_10.addNode('otnen_sunblade_docs','Documentation',ssUrlPrefix + 'server-storage/sun-blade/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_10_3=g_navNode_15_10.addNode('otnen_sunblade_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-blade/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_10_4=g_navNode_15_10.addNode('otnen_sunblade_community','Community',ssUrlPrefix + 'server-storage/sun-blade/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_11=g_navNode_15.addNode('otnen_sunsparcent','Oracle Sun SPARC Enterprise Servers',ssUrlPrefix + 'server-storage/sun-sparc-enterprise/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_11_0=g_navNode_15_11.addNode('otnen_sunsparcent_overview','Overview',ssUrlPrefix + 'server-storage/sun-sparc-enterprise/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_11_2=g_navNode_15_11.addNode('otnen_sunsparcent_docs','Documentation',ssUrlPrefix + 'server-storage/sun-sparc-enterprise/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_11_3=g_navNode_15_11.addNode('otnen_sunsparcent_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-sparc-enterprise/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_11_4=g_navNode_15_11.addNode('otnen_sunsparcent_community','Community',ssUrlPrefix + 'server-storage/sun-sparc-enterprise/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_12=g_navNode_15.addNode('otnen_sunx86','Oracle Sun x86 Servers',ssUrlPrefix + 'server-storage/sun-x86/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_12_0=g_navNode_15_12.addNode('otnen_sunx86_overview','Overview',ssUrlPrefix + 'server-storage/sun-x86/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_12_2=g_navNode_15_12.addNode('otnen_sunx86_docs','Documentation',ssUrlPrefix + 'server-storage/sun-x86/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_12_3=g_navNode_15_12.addNode('otnen_sunx86_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-x86/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_12_4=g_navNode_15_12.addNode('otnen_sunx86_community','Community',ssUrlPrefix + 'server-storage/sun-x86/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_13=g_navNode_15.addNode('otnen_sunnetra','Oracle Sun Netra Carrier-Grade Systems',ssUrlPrefix + 'server-storage/sun-netra-carrier/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_13_0=g_navNode_15_13.addNode('otnen_sunnetra_overview','Overview',ssUrlPrefix + 'server-storage/sun-netra-carrier/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_13_2=g_navNode_15_13.addNode('otnen_sunnetra_docs','Documentation',ssUrlPrefix + 'server-storage/sun-netra-carrier/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_13_3=g_navNode_15_13.addNode('otnen_sunnetra_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-netra-carrier/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_13_4=g_navNode_15_13.addNode('otnen_sunnetra_community','Community',ssUrlPrefix + 'server-storage/sun-netra-carrier/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_14=g_navNode_15.addNode('otnen_sunnetworking','Oracle Sun Networking Products',ssUrlPrefix + 'server-storage/sun-networking/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_14_0=g_navNode_15_14.addNode('otnen_sunnetworking_overview','Overview',ssUrlPrefix + 'server-storage/sun-networking/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_14_2=g_navNode_15_14.addNode('otnen_sunnetworking_docs','Documentation',ssUrlPrefix + 'server-storage/sun-networking/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_14_3=g_navNode_15_14.addNode('otnen_sunnetworking_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-networking/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_14_4=g_navNode_15_14.addNode('otnen_sunnetworking_community','Community',ssUrlPrefix + 'server-storage/sun-networking/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_15=g_navNode_15.addNode('otnen_flashstorage','Oracle Sun Flash Storage',ssUrlPrefix + 'server-storage/sun-flash-storage/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_15_0=g_navNode_15_15.addNode('otnen_flashstorage_overview','Overview',ssUrlPrefix + 'server-storage/sun-flash-storage/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_15_2=g_navNode_15_15.addNode('otnen_flashstorage_docs','Documentation',ssUrlPrefix + 'server-storage/sun-flash-storage/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_15_3=g_navNode_15_15.addNode('otnen_flashstorage_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-flash-storage/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_15_4=g_navNode_15_15.addNode('otnen_flashstorage_community','Community',ssUrlPrefix + 'server-storage/sun-flash-storage/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_16=g_navNode_15.addNode('otnen_unifiedstorage','Oracle Sun Unified Storage',ssUrlPrefix + 'server-storage/sun-unified-storage/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_16_0=g_navNode_15_16.addNode('otnen_unifiedstorage_overview','Overview',ssUrlPrefix + 'server-storage/sun-unified-storage/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_16_2=g_navNode_15_16.addNode('otnen_unifiedstorage_docs','Documentation',ssUrlPrefix + 'server-storage/sun-unified-storage/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_16_3=g_navNode_15_16.addNode('otnen_unifiedstorage_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-unified-storage/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_16_4=g_navNode_15_16.addNode('otnen_unifiedstorage_community','Community',ssUrlPrefix + 'server-storage/sun-unified-storage/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_17=g_navNode_15.addNode('otnen_storagesoft','Oracle Sun Storage Software',ssUrlPrefix + 'server-storage/sun-storage-software/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_17_0=g_navNode_15_17.addNode('otnen_storagesoft_overview','Overview',ssUrlPrefix + 'server-storage/sun-storage-software/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_17_2=g_navNode_15_17.addNode('otnen_storagesoft_docs','Documentation',ssUrlPrefix + 'server-storage/sun-storage-software/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_17_3=g_navNode_15_17.addNode('otnen_storagesoft_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-storage-software/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_17_4=g_navNode_15_17.addNode('otnen_storagesoft_community','Community',ssUrlPrefix + 'server-storage/sun-storage-software/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_18=g_navNode_15.addNode('otnen_sundiskstorage','Oracle Sun Disk Storage',ssUrlPrefix + 'server-storage/sun-disk-storage/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_18_0=g_navNode_15_18.addNode('otnen_sundiskstorage_overview','Overview',ssUrlPrefix + 'server-storage/sun-disk-storage/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_18_2=g_navNode_15_18.addNode('otnen_sundiskstorage_docs','Documentation',ssUrlPrefix + 'server-storage/sun-disk-storage/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_18_3=g_navNode_15_18.addNode('otnen_sundiskstorage_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-disk-storage/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_18_4=g_navNode_15_18.addNode('otnen_sundiskstorage_community','Community',ssUrlPrefix + 'server-storage/sun-disk-storage/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_19=g_navNode_15.addNode('otnen_suntapestorage','Oracle Sun Tape Storage',ssUrlPrefix + 'server-storage/sun-tape-storage/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_19_0=g_navNode_15_19.addNode('otnen_suntapestorage_overview','Overview',ssUrlPrefix + 'server-storage/sun-tape-storage/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_19_2=g_navNode_15_19.addNode('otnen_suntapestorage_docs','Documentation',ssUrlPrefix + 'server-storage/sun-tape-storage/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_19_3=g_navNode_15_19.addNode('otnen_suntapestorage_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-tape-storage/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_19_4=g_navNode_15_19.addNode('otnen_suntapestorage_community','Community',ssUrlPrefix + 'server-storage/sun-tape-storage/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_20=g_navNode_15.addNode('otnen_sunstoragenet','Oracle Sun Storage Networking',ssUrlPrefix + 'server-storage/sun-storage-networking/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_20_0=g_navNode_15_20.addNode('otnen_sunstoragenet_overview','Overview',ssUrlPrefix + 'server-storage/sun-storage-networking/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_20_2=g_navNode_15_20.addNode('otnen_sunstoragenet_docs','Documentation',ssUrlPrefix + 'server-storage/sun-storage-networking/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_20_3=g_navNode_15_20.addNode('otnen_sunstoragenet_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-storage-networking/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_20_4=g_navNode_15_20.addNode('otnen_sunstoragenet_community','Community',ssUrlPrefix + 'server-storage/sun-storage-networking/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21=g_navNode_15.addNode('otnen_sundesktops','Oracle Sun Desktops \x26 Peripherals',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21_0=g_navNode_15_21.addNode('otnen_sundesktops_overview','Overview',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21_1=g_navNode_15_21.addNode('otnen_sundesktops_tech','Technologies',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/technologies/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21_2=g_navNode_15_21.addNode('otnen_sundesktops_docs','Documentation',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21_3=g_navNode_15_21.addNode('otnen_sundesktops_downloads','Downloads',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21_4=g_navNode_15_21.addNode('otnen_sundesktops_community','Community',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_21_5=g_navNode_15_21.addNode('otnen_sundesktops_training','Training',ssUrlPrefix + 'server-storage/sun-desktops-peripherals/training/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_22=g_navNode_15.addNode('otnen_hardwaresolutions','Oracle Sun Hardware Solutions',ssUrlPrefix + 'server-storage/hardware-solutions/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_15_23=g_navNode_15.addNode('otnen_ssgeneral','General',ssUrlPrefix + 'server-storage/general/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
if (SSContributor)
{
g_navNode_15_24=g_navNode_15.addNode('otnen_sunray','Sun Ray Products',ssUrlPrefix + 'server-storage/sunrayproducts/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
g_navNode_15_24_0=g_navNode_15_24.addNode('otnen_sunray_overview','Overview',ssUrlPrefix + 'server-storage/sunrayproducts/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_24_1=g_navNode_15_24.addNode('otnen_sunray_downloads','Downloads',ssUrlPrefix + 'server-storage/sunrayproducts/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_24_2=g_navNode_15_24.addNode('otnen_sunray_docs','Documentation',ssUrlPrefix + 'server-storage/sunrayproducts/docs/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_24_4=g_navNode_15_24.addNode('otnen_sunray_community','Community',ssUrlPrefix + 'server-storage/sunrayproducts/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_15_24_5=g_navNode_15_24.addNode('otnen_sunray_training','Learn More',ssUrlPrefix + 'server-storage/sunrayproducts/training/index.html','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_25=g_navNode_15.addNode('otnen_virtualdesktop','Oracle Virtual Desktop Infrastructure',ssUrlPrefix + 'server-storage/virtualdesktop/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
if (SSContributor)
{
g_navNode_15_25_0=g_navNode_15_25.addNode('otnen_virtualdesktop_overview','Overview',ssUrlPrefix + 'server-storage/virtualdesktop/overview/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_25_1=g_navNode_15_25.addNode('otnen_virtualdesktop_downloads','Downloads',ssUrlPrefix + 'server-storage/virtualdesktop/downloads/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_25_2=g_navNode_15_25.addNode('otnen_virtualdesktop_docs','Documentation',ssUrlPrefix + 'server-storage/virtualdesktop/docs/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_25_4=g_navNode_15_25.addNode('otnen_virtualdesktop_community','Community',ssUrlPrefix + 'server-storage/virtualdesktop/community/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_25_5=g_navNode_15_25.addNode('otnen_virtualdesktop_training','Learn More',ssUrlPrefix + 'server-storage/virtualdesktop/training/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
}
if (SSContributor)
{
g_navNode_15_26=g_navNode_15.addNode('otnen_securedesktop','Oracle Secure Desktop',ssUrlPrefix + 'server-storage/securedesktop/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
if (SSContributor)
{
g_navNode_15_26_0=g_navNode_15_26.addNode('otnen_securedesktop_overview','Overview',ssUrlPrefix + 'server-storage/securedesktop/overview/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_26_1=g_navNode_15_26.addNode('otnen_securedesktop_downloads','Downloads',ssUrlPrefix + 'server-storage/securedesktop/downloads/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_26_2=g_navNode_15_26.addNode('otnen_securedesktop_docs','Documentation',ssUrlPrefix + 'server-storage/securedesktop/docs/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_26_4=g_navNode_15_26.addNode('otnen_securedesktop_community','Community',ssUrlPrefix + 'server-storage/securedesktop/community/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_26_5=g_navNode_15_26.addNode('otnen_securedesktop_training','Learn More',ssUrlPrefix + 'server-storage/securedesktop/training/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
}
if (SSContributor)
{
g_navNode_15_27=g_navNode_15.addNode('otnen_zones','Solaris Zones/Containers',ssUrlPrefix + 'server-storage/zones/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
if (SSContributor)
{
g_navNode_15_27_0=g_navNode_15_27.addNode('otnen_zones_overview','Overview',ssUrlPrefix + 'server-storage/zones/overview/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_27_1=g_navNode_15_27.addNode('otnen_zones_tech','Technologies',ssUrlPrefix + 'server-storage/zones/tech/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_27_2=g_navNode_15_27.addNode('otnen_zones_downloads','Downloads',ssUrlPrefix + 'server-storage/zones/downloads/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_27_3=g_navNode_15_27.addNode('otnen_zones_docs','Documentation',ssUrlPrefix + 'server-storage/zones/docs/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_27_4=g_navNode_15_27.addNode('otnen_zones_community','Community',ssUrlPrefix + 'server-storage/zones/community/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
if (SSContributor)
{
g_navNode_15_27_5=g_navNode_15_27.addNode('otnen_zones_training','Training',ssUrlPrefix + 'server-storage/zones/training/index.html','contributorOnly==TRUE','secondaryUrlVariableField==MainContent');
}
}
g_navNode_16=g_navNode_Root.addNode('otnen_searchcat','Search',ssUrlPrefix + 'search/index.html','secondaryUrlVariableField==MainContent');
g_navNode_16_0=g_navNode_16.addNode('otnen_ses','Secure Enterprise Search',ssUrlPrefix + 'search/oses/index.html','secondaryUrlVariableField==MainContent');
g_navNode_16_0_0=g_navNode_16_0.addNode('otnen_ses_overview','Overview',ssUrlPrefix + 'search/oses/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_16_0_1=g_navNode_16_0.addNode('otnen_ses_downloads','Downloads',ssUrlPrefix + 'search/oses/downloads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_16_0_2=g_navNode_16_0.addNode('otnen_ses_docs','Documentation',ssUrlPrefix + 'search/oses/documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_16_0_3=g_navNode_16_0.addNode('otnen_ses_community','Community',ssUrlPrefix + 'search/oses/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_16_0_4=g_navNode_16_0.addNode('otnen_ses_learnmore','Learn More',ssUrlPrefix + 'search/oses/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_18=g_navNode_Root.addNode('otnen_testcontent','testcontent',ssUrlPrefix + 'testcontent/index.html','secondaryUrlVariableField==MainContent');
g_navNode_19=g_navNode_Root.addNode('701','tabstest',ssUrlPrefix + 'tabstest1/index.html');
g_navNode_19_0=g_navNode_19.addNode('702','WebLogic',ssUrlPrefix + 'tabstest1/weblogic/index.html');
g_navNode_19_0_0=g_navNode_19_0.addNode('703','Overview',ssUrlPrefix + 'tabstest1/weblogic/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_19_0_1=g_navNode_19_0.addNode('704','Downloads',ssUrlPrefix + 'tabstest1/weblogic/downloads/index.html');
g_navNode_19_0_2=g_navNode_19_0.addNode('705','Documentation',ssUrlPrefix + 'tabstest1/weblogic/documentation/index.html');
g_navNode_19_0_3=g_navNode_19_0.addNode('1801','Community',ssUrlPrefix + 'tabstest1/weblogic/Community/index.html');
g_navNode_19_1=g_navNode_19.addNode('706','Tuxedo',ssUrlPrefix + 'tabstest1/tuxedo/index.html','secondaryUrlVariableField==MainContent');
g_navNode_19_2=g_navNode_19.addNode('707','SOA',ssUrlPrefix + 'tabstest1/soa/index.html');
g_navNode_19_2_0=g_navNode_19_2.addNode('1693','Overview',ssUrlPrefix + 'tabstest1/soa/overview/index.html');
g_navNode_19_2_1=g_navNode_19_2.addNode('1694','Downloads',ssUrlPrefix + 'tabstest1/soa/downloads/index.html');
g_navNode_19_2_2=g_navNode_19_2.addNode('1695','Docs',ssUrlPrefix + 'tabstest1/soa/docs/index.html');
g_navNode_20=g_navNode_Root.addNode('otnen_sysadmin','System Admins and Developers',ssUrlPrefix + 'systems/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_0=g_navNode_20.addNode('otnen_adminarticles','All System Admin Articles',ssUrlPrefix + 'systems/articles/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_1=g_navNode_20.addNode('otnen_alltopics','All Systems Topics',ssUrlPrefix + 'systems/alltopics/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_2=g_navNode_20.addNode('otnen_systems_appperformance','Analyzing Application Performance',ssUrlPrefix + 'systems/app-performance/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_3=g_navNode_20.addNode('otnen_systems_buildingapps','Building Applications',ssUrlPrefix + 'systems/building-applications/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_4=g_navNode_20.addNode('otnen_containers','Containers',ssUrlPrefix + 'systems/containers/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_5=g_navNode_20.addNode('otnen_coolthreads','Cool Threads',ssUrlPrefix + 'systems/coolthreads/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_5_0=g_navNode_20_5.addNode('otnen_coolthreads_overview','Overview',ssUrlPrefix + 'systems/coolthreads/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_5_1=g_navNode_20_5.addNode('otnen_coolthreads_resources','Resources',ssUrlPrefix + 'systems/coolthreads/resources/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_5_2=g_navNode_20_5.addNode('otnen_coolthreads_ultrasparc','UltraSPARC Processors',ssUrlPrefix + 'systems/coolthreads/ultrasparc/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_5_3=g_navNode_20_5.addNode('otnen_coolthreads_servers','T5140/T5240 Servers',ssUrlPrefix + 'systems/coolthreads/servers/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_6=g_navNode_20.addNode('otnen_systems_debugapps','Debugging Applications',ssUrlPrefix + 'systems/debugging-apps/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_7=g_navNode_20.addNode('otnen_dst','DST',ssUrlPrefix + 'systems/dst/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_7_0=g_navNode_20_7.addNode('otnen_dst_overview','Overview',ssUrlPrefix + 'systems/dst/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_7_1=g_navNode_20_7.addNode('otnen_dst_software','Software',ssUrlPrefix + 'systems/dst/software/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_7_2=g_navNode_20_7.addNode('otnen_dst_systems','Systems',ssUrlPrefix + 'systems/dst/systems/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_7_3=g_navNode_20_7.addNode('otnen_dst_storage','Storage',ssUrlPrefix + 'systems/dst/storage/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_7_4=g_navNode_20_7.addNode('otnen_dst_faq','FAQ',ssUrlPrefix + 'systems/dst/faq/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_8=g_navNode_20.addNode('otnen_dtrace','DTrace',ssUrlPrefix + 'systems/dtrace/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_8_0=g_navNode_20_8.addNode('otnen_dtrace_dtrace','DTrace',ssUrlPrefix + 'systems/dtrace/dtrace/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_8_1=g_navNode_20_8.addNode('otnen_dtrace_selfhealing','Predictive Self-Healing',ssUrlPrefix + 'systems/dtrace/self-healing/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_8_2=g_navNode_20_8.addNode('otnen_dtrace_zfs','ZFS',ssUrlPrefix + 'systems/dtrace/zfs/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_8_3=g_navNode_20_8.addNode('otnen_dtrace_zones','Zones',ssUrlPrefix + 'systems/dtrace/zones/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_9=g_navNode_20.addNode('otnen_sysadmin_faq','FAQ',ssUrlPrefix + 'systems/faq/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_10=g_navNode_20.addNode('otnen_handsonlabs','Hands-On Labs',ssUrlPrefix + 'systems/Hands-OnLabs/index.html','ssTabsLevelOverride==-1');
g_navNode_20_11=g_navNode_20.addNode('otnen_highperfcomp','High Performance Computing',ssUrlPrefix + 'systems/hpc/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_12=g_navNode_20.addNode('otnen_interoperability','Interoperability',ssUrlPrefix + 'systems/interoperability/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_12_0=g_navNode_20_12.addNode('otnen_interop_overview','Overview',ssUrlPrefix + 'systems/interoperability/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_12_1=g_navNode_20_12.addNode('otnen_interop_solaris','Solaris',ssUrlPrefix + 'systems/interoperability/solaris/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_12_2=g_navNode_20_12.addNode('otnen_interop_boot','Multiboot',ssUrlPrefix + 'systems/interoperability/boot/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_12_3=g_navNode_20_12.addNode('otnen_interop_sunhw','Sun HW',ssUrlPrefix + 'systems/interoperability/sunhw/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_12_4=g_navNode_20_12.addNode('otnen_interop_linux','Linux',ssUrlPrefix + 'systems/interoperability/linux/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_12_5=g_navNode_20_12.addNode('otnen_interop_tech','Virt/Web Tech',ssUrlPrefix + 'systems/interoperability/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_13=g_navNode_20.addNode('otnen_multithread','Multithreaded Programming',ssUrlPrefix + 'systems/multithreaded-programming/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_14=g_navNode_20.addNode('otnen_systems_numcomputing','Numerical Computing',ssUrlPrefix + 'systems/numerical-computing/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_15=g_navNode_20.addNode('otnen_patches','Patches',ssUrlPrefix + 'systems/patches/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_15_0=g_navNode_20_15.addNode('otnen_patches_overview','Overview',ssUrlPrefix + 'systems/patches/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_15_1=g_navNode_20_15.addNode('otnen_patches_solaris','Solaris',ssUrlPrefix + 'systems/patches/solaris/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_15_2=g_navNode_20_15.addNode('otnen_patches_firmware','Firmware',ssUrlPrefix + 'systems/patches/firmware/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_15_3=g_navNode_20_15.addNode('otnen_patches_sysmgmt','Systems Management',ssUrlPrefix + 'systems/patches/sysmgmt/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_15_4=g_navNode_20_15.addNode('otnen_patches_alerts','Sun Alerts',ssUrlPrefix + 'systems/patches/alerts/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_16=g_navNode_20.addNode('otnen_securitycerts','Security',ssUrlPrefix + 'systems/security/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_17=g_navNode_20.addNode('otnen_softwarestacks','Software Stacks',ssUrlPrefix + 'systems/software-stacks/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_17_0=g_navNode_20_17.addNode('otnen_softwarestacks_overview','Overview',ssUrlPrefix + 'systems/software-stacks/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_17_1=g_navNode_20_17.addNode('otnen_softwarestacks_stacks','Stacks',ssUrlPrefix + 'systems/software-stacks/stacks/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_18=g_navNode_20.addNode('otnen_admindocs','Solaris HowTo',ssUrlPrefix + 'systems/documentation/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_19=g_navNode_20.addNode('otnen_sysadmindocs','System Admin Docs',ssUrlPrefix + 'systems/sys-admin-docs/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_0=g_navNode_20_19.addNode('otnen_sysadmindocs_overview','Overview',ssUrlPrefix + 'systems/sys-admin-docs/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_1=g_navNode_20_19.addNode('otnen_sysadmindocs_apps','Apps',ssUrlPrefix + 'systems/sys-admin-docs/apps/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_2=g_navNode_20_19.addNode('otnen_sysadmindocs_mware','Middleware',ssUrlPrefix + 'systems/sys-admin-docs/middleware/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_3=g_navNode_20_19.addNode('otnen_sysadmindocs_tech','OS/Virt/HA/Net',ssUrlPrefix + 'systems/sys-admin-docs/tech/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_4=g_navNode_20_19.addNode('otnen_sysadmindocs_sysmgmt','System Mgmt',ssUrlPrefix + 'systems/sys-admin-docs/sysmgmt/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_5=g_navNode_20_19.addNode('otnen_sysadmindocs_hw','Hardware',ssUrlPrefix + 'systems/sys-admin-docs/hardware/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_19_6=g_navNode_20_19.addNode('otnen_sysadmindocs_storage','Storage',ssUrlPrefix + 'systems/sys-admin-docs/storage/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_20=g_navNode_20.addNode('otnen_systems_tuningapps','Tuning Applications',ssUrlPrefix + 'systems/tuning-apps/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_20_21=g_navNode_20.addNode('otnen_adminupgrade','Upgrade',ssUrlPrefix + 'systems/upgrade/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_21_0=g_navNode_20_21.addNode('otnen_adminupgrade_overview','Overview',ssUrlPrefix + 'systems/upgrade/overview/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_21_1=g_navNode_20_21.addNode('otnen_adminupgrade_why','Why Upgrade',ssUrlPrefix + 'systems/upgrade/why-upgrade/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_21_2=g_navNode_20_21.addNode('otnen_adminupgrade_patching','Patching',ssUrlPrefix + 'systems/upgrade/patching/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_21_3=g_navNode_20_21.addNode('otnen_adminupgrade_planning','Planning',ssUrlPrefix + 'systems/upgrade/planning/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_21_4=g_navNode_20_21.addNode('otnen_adminupgrade_implement','Implementation',ssUrlPrefix + 'systems/upgrade/implementation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_21_5=g_navNode_20_21.addNode('otnen_adminupgrade_post','Post-upgrade',ssUrlPrefix + 'systems/upgrade/post-upgrade/index.html','secondaryUrlVariableField==MainContent');
g_navNode_20_22=g_navNode_20.addNode('otnen_logicdomains','VM Server for SPARC',ssUrlPrefix + 'systems/logical-domains/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_21=g_navNode_Root.addNode('otnen_industries','Industries',ssUrlPrefix + 'industries/index.html','secondaryUrlVariableField==MainContent');
g_navNode_21_0=g_navNode_21.addNode('otnen_lifesciences','Life Sciences',ssUrlPrefix + 'industries/life-sciences/index.html','secondaryUrlVariableField==MainContent','ssTabsLevelOverride==-1');
g_navNode_24=g_navNode_Root.addNode('1562','tabstest',ssUrlPrefix + 'tabstest/index.html');
g_navNode_24_0=g_navNode_24.addNode('1563','tabstestl1',ssUrlPrefix + 'tabstest/tabstestl1/index.html');
g_navNode_24_0_0=g_navNode_24_0.addNode('1564','overview',ssUrlPrefix + 'tabstest/tabstestl1/overview/index.html');
g_navNode_24_0_2=g_navNode_24_0.addNode('1565','downloads',ssUrlPrefix + 'tabstest/tabstestl1/downloads/index.html');
g_navNode_24_1=g_navNode_24.addNode('1567','notabs',ssUrlPrefix + 'tabstest/notabs/index.html','ssTabsLevelOverride==-1');
g_navNode_24_1_0=g_navNode_24_1.addNode('1568','notabsoverview',ssUrlPrefix + 'tabstest/notabs/notabsoverview/index.html','ssTabsLevelOverride==-1');
g_navNode_24_1_1=g_navNode_24_1.addNode('1569','notabsdl',ssUrlPrefix + 'tabstest/notabs/notabsdl/index.html','ssTabsLevelOverride==-1');
g_navNode_24_2=g_navNode_24.addNode('1570','tabs4',ssUrlPrefix + 'tabstest/tabs4/index.html','ssTabsLevelOverride==-1');
g_navNode_24_2_0=g_navNode_24_2.addNode('1571','tabs4-l3',ssUrlPrefix + 'tabstest/tabs4/tabs4-l3/index.html','ssTabsLevelOverride==4');
g_navNode_24_2_0_0=g_navNode_24_2_0.addNode('1573','community',ssUrlPrefix + 'tabstest/tabs4/tabs4-l3/community/index.html','ssTabsLevelOverride==4');
g_navNode_24_2_0_1=g_navNode_24_2_0.addNode('1572','tabs4-l4',ssUrlPrefix + 'tabstest/tabs4/tabs4-l3/tabs4-l4/index.html','ssTabsLevelOverride==4');
g_navNode_24_3=g_navNode_24.addNode('1795','1col',ssUrlPrefix + 'tabstest/1col/index.html');
g_navNode_24_3_0=g_navNode_24_3.addNode('1796','Tab A',ssUrlPrefix + 'tabstest/1col/taba/index.html');
g_navNode_24_3_1=g_navNode_24_3.addNode('1797','Tab B',ssUrlPrefix + 'tabstest/1col/tabb/index.html');
g_navNode_25=g_navNode_Root.addNode('otnen_documentation','Documentation',ssUrlPrefix + 'documentation/index.html','secondaryUrlVariableField==MainContent');
g_navNode_25_1=g_navNode_25.addNode('otnen_dochome','Documentation Home',ssUrlPrefix + 'documentation/doc-home/index.html','ssRedirectURL==/technetwork/indexes/documentation/index.html');
g_navNode_26=g_navNode_Root.addNode('otnen_licenses','Licenses',ssUrlPrefix + 'licenses/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28=g_navNode_Root.addNode('otnen_architect','Architect',ssUrlPrefix + 'architect/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28_0=g_navNode_28.addNode('otnen_archresources','Resources',ssUrlPrefix + 'architect/resources/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28_0_0=g_navNode_28_0.addNode('otnen_archresources_whatsnew','What\'s New',ssUrlPrefix + 'architect/resources/whatsnew/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28_0_1=g_navNode_28_0.addNode('otnen_archresources_articles','Articles \x26 Whitepapers',ssUrlPrefix + 'architect/resources/articles/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28_0_2=g_navNode_28_0.addNode('otnen_archresources_community','Community',ssUrlPrefix + 'architect/resources/community/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28_0_3=g_navNode_28_0.addNode('otnen_archresources_learnmore','Learn More',ssUrlPrefix + 'architect/resources/learnmore/index.html','secondaryUrlVariableField==MainContent');
g_navNode_28_1=g_navNode_28.addNode('otnen_architect_bidata','BI \x26 Data Warehousing',ssUrlPrefix + 'architect/bidata/index.html','ssRedirectURL==/technetwork/topics/bi/whatsnew/index.html','ssTabsLevelOverride==-1');
g_navNode_28_2=g_navNode_28.addNode('otnen_architect_cloud','Cloud Computing',ssUrlPrefix + 'architect/cloud/index.html','ssRedirectURL==/technetwork/topics/cloud/index.html','ssTabsLevelOverride==-1');
g_navNode_28_3=g_navNode_28.addNode('otnen_architect_ent20','Enterprise 2.0',ssUrlPrefix + 'architect/ent20/index.html','ssRedirectURL==/technetwork/topics/ent20/index.html','ssTabsLevelOverride==-1');
g_navNode_28_4=g_navNode_28.addNode('otnen_architect_entarch','Enterprise Architecure',ssUrlPrefix + 'architect/entarch/index.html','ssRedirectURL==/technetwork/topics/entarch/index.html','ssTabsLevelOverride==-1');
g_navNode_28_5=g_navNode_28.addNode('otnen_architect_grid','Grid Computing',ssUrlPrefix + 'architect/grid/index.html','ssRedirectURL==/technetwork/topics/grid/index.html','ssTabsLevelOverride==-1');
g_navNode_28_6=g_navNode_28.addNode('otnen_architect_security','Security',ssUrlPrefix + 'architect/security/index.html','ssRedirectURL==/technetwork/topics/security/index.html','ssTabsLevelOverride==-1');
g_navNode_28_7=g_navNode_28.addNode('otnen_architect_soa','Service-Oriented Architecture',ssUrlPrefix + 'architect/soa/index.html','ssRedirectURL==/technetwork/topics/soa/index.html','ssTabsLevelOverride==-1');
g_navNode_28_8=g_navNode_28.addNode('otnen_architect_virtualization','Virtualization',ssUrlPrefix + 'architect/virtualization/index.html','ssRedirectURL==/technetwork/topics/virtualization/index.html','ssTabsLevelOverride==-1');
g_navNode_29=g_navNode_Root.addNode('otnen_databasedev','Database Admins and Developers',ssUrlPrefix + 'dbadev/index.html','secondaryUrlVariableField==MainContent');
g_navNode_30=g_navNode_Root.addNode('otnen_tutorials','Oracle Learning Library',ssUrlPrefix + 'tutorials/index.html','secondaryUrlVariableField==MainContent');
g_navNode_30_0=g_navNode_30.addNode('otnen_stallcontent','All Content',ssUrlPrefix + 'tutorials/all-content/index.html','ssRedirectURL==http\x3a//apex.oracle.com/pls/apex/f?p\x3d9830\x3a41','ssTabsLevelOverride==-1');
g_navNode_30_1=g_navNode_30.addNode('otnen_stdatabase','Database',ssUrlPrefix + 'tutorials/database/index.html','ssRedirectURL==http\x3a//apex.oracle.com/pls/apex/f?p\x3d9830\x3a28','ssTabsLevelOverride==-1');
g_navNode_30_2=g_navNode_30.addNode('otnen_stmiddleware','Fusion Middleware',ssUrlPrefix + 'tutorials/middleware/index.html','ssRedirectURL==http\x3a//apex.oracle.com/pls/apex/f?p\x3d9830\x3a29','ssTabsLevelOverride==-1');
g_navNode_30_3=g_navNode_30.addNode('otnen_stentmgr','Enterprise Manager',ssUrlPrefix + 'tutorials/oem/index.html','ssRedirectURL==http\x3a//apex.oracle.com/pls/apex/f?p\x3d9830\x3a30','ssTabsLevelOverride==-1');
g_navNode_30_4=g_navNode_30.addNode('otnen_stjdev','JDeveloper',ssUrlPrefix + 'tutorials/jdev/index.html','ssRedirectURL==http\x3a//apex.oracle.com/pls/apex/f?p\x3d9830\x3a32','ssTabsLevelOverride==-1');
